diff -pruN 1.2.6-1/.circleci/config.yml 1.2.7-1/.circleci/config.yml
--- 1.2.6-1/.circleci/config.yml	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/.circleci/config.yml	2024-07-01 20:01:34.000000000 +0000
@@ -2,7 +2,7 @@ version: 2.1
 parameters:
   fastnetmon_build_version:
     type: string
-    default: "1.2.6"
+    default: "1.2.7"
 orbs:
   win: circleci/windows@4.1
 jobs:
@@ -68,9 +68,10 @@ jobs:
       # https://github.com/Homebrew/discussions/discussions/4136
       HOMEBREW_NO_INSTALL_FROM_API: 1
     steps:
+      - run: env
       - checkout
       - run: /bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"
-      - run: cp src/packaging/homebrew/fastnetmon.rb /usr/local/Homebrew/Library/Taps/homebrew/homebrew-core/Formula/fastnetmon.rb
+      - run: cp src/packaging/homebrew/fastnetmon.rb /usr/local/Homebrew/Library/Taps/homebrew/homebrew-core/Formula/f/fastnetmon.rb
       - run: brew install --build-from-source --HEAD --verbose --debug fastnetmon
   build_debian_upstream_package:
     machine:
@@ -220,10 +221,10 @@ jobs:
     steps:
       - run: sudo docker run --name  linux_docker -d -t << parameters.docker_image >>
       - run: sudo docker exec linux_docker apt-get update; true
-      - run: sudo docker exec --env DEBIAN_FRONTEND linux_docker apt-get install -y perl wget git cmake g++ make liblog4cpp5-dev libhiredis-dev libmongoc-dev libbpf-dev libgrpc++-dev libprotobuf-dev protobuf-compiler libcapnp-dev capnproto libssl-dev protobuf-compiler-grpc libncurses5-dev libpcap-dev pkg-config  libboost-atomic-dev libboost-chrono-dev  libboost-date-time-dev libboost-program-options-dev libboost-regex-dev libboost-system-dev libboost-thread-dev
+      - run: sudo docker exec --env DEBIAN_FRONTEND linux_docker apt-get install -y perl wget git cmake g++ make liblog4cpp5-dev libhiredis-dev libmongoc-dev libbpf-dev libgrpc++-dev libprotobuf-dev protobuf-compiler libcapnp-dev capnproto libssl-dev protobuf-compiler-grpc libncurses5-dev libpcap-dev pkg-config  libboost-atomic-dev libboost-chrono-dev  libboost-date-time-dev libboost-program-options-dev libboost-regex-dev libboost-system-dev libboost-thread-dev libabsl-dev
       - run: sudo docker exec linux_docker git clone https://github.com/pavel-odintsov/fastnetmon.git
       - run: sudo docker exec linux_docker mkdir fastnetmon/src/build
-      - run: sudo docker exec linux_docker cmake -S fastnetmon/src -B fastnetmon/src/build -DENABLE_AF_XDP_SUPPORT=FALSE
+      - run: sudo docker exec linux_docker cmake -S fastnetmon/src -B fastnetmon/src/build -DENABLE_AF_XDP_SUPPORT=FALSE -DLINK_WITH_ABSL=TRUE
       - run: sudo docker exec linux_docker make -C fastnetmon/src/build -j
   build_debian:
     parameters:
@@ -316,10 +317,6 @@ workflows:
   all_distros:
     jobs:
       - build_centos:
-          docker_image: centos:centos7
-          centos_version: "7"
-          name: "centos7"
-      - build_centos:
           docker_image: almalinux:8
           centos_version: "8"
           name: "centos8"
@@ -345,6 +342,11 @@ workflows:
           name: "ubuntu2204"
           distro_name: "ubuntu"
       - build_debian:
+          docker_image: "ubuntu:noble"
+          distro_version: "24.04"
+          name: "ubuntu2404"
+          distro_name: "ubuntu"
+      - build_debian:
           docker_image: "ubuntu:jammy"
           distro_version: "22.04"
           name: "ubuntu2204_arm"
@@ -352,6 +354,13 @@ workflows:
           resource_class: "arm.large"
           debian_package_architecture: "arm64"
       - build_debian:
+          docker_image: "ubuntu:noble"
+          distro_version: "24.04"
+          name: "ubuntu2404_arm"
+          distro_name: "ubuntu"
+          resource_class: "arm.large"
+          debian_package_architecture: "arm64"
+      - build_debian:
           docker_image: "ubuntu:focal"
           distro_version: "20.04"
           name: "ubuntu2004"
@@ -364,23 +373,6 @@ workflows:
           resource_class: "arm.large"
           debian_package_architecture: "arm64"
       - build_debian:
-          docker_image: "ubuntu:bionic"
-          distro_version: "18.04"
-          name: "ubuntu1804"
-          distro_name: "ubuntu"
-      - build_debian:
-          docker_image: "ubuntu:xenial"
-          distro_version: "16.04"
-          name: "ubuntu1604"
-          distro_name: "ubuntu"
-      - build_debian:
-          docker_image: "debian:buster"
-          distro_version: "10"
-          name: "debian10"
-          distro_name: "debian"
-          # We do it this way because this version of Debian has no s3cmd in official repos for some reasons: https://packages.debian.org/buster-backports/s3cmd
-          s3cmd_install_command: "apt-get install -y python3-pip && pip3 install s3cmd"
-      - build_debian:
           docker_image: "debian:bullseye"
           distro_version: "11"
           name: "debian11"
@@ -416,26 +408,30 @@ workflows:
       - build_debian_system_dependencies:
           docker_image: "ubuntu:jammy"
           name: "ubuntu2204_system_dependencies"
-      # it's broken due to some changes in Sid
+      - build_debian_system_dependencies:
+          docker_image: "ubuntu:noble"
+          name: "ubuntu2404_system_dependencies"
+      # It's broken due to some changes in Sid
       #- build_debian_system_dependencies:
       #    docker_image: "debian:sid"
       #    name: "debian_sid_system_dependencies"
-      - build_fedora_upstream:
-          name: "Fedora 36 Upstream RPM"
-          docker_image: fedora:36
-      - build_fedora_upstream:
-          name: "Fedora 37 Upstream RPM"
-          docker_image: fedora:37
-      - build_fedora_upstream:
-          name: "Fedora 38 Upstream RPM"
-          docker_image: fedora:38
-      - build_epel9_upstream:
-          name: "EPEL 9 RPM"
-      - build_macos:
-          name: "Build on MacOS"
-      - build_windows:
-          name: "Build on Windows Server 2022"
-          windows_name: "win/server-2022"
-      - build_windows:
-          name: "Build on Windows Server 2019"
-          windows_name: "win/server-2019"
+      # All these platforms below are broken due to different reasons and need to be fixed in future
+      #- build_fedora_upstream:
+      #    name: "Fedora 36 Upstream RPM"
+      #    docker_image: fedora:36
+      #- build_fedora_upstream:
+      #    name: "Fedora 37 Upstream RPM"
+      #    docker_image: fedora:37
+      #- build_fedora_upstream:
+      #    name: "Fedora 38 Upstream RPM"
+      #    docker_image: fedora:38
+      #- build_epel9_upstream:
+      #    name: "EPEL 9 RPM"
+      #- build_macos:
+      #    name: "Build on MacOS"
+      #- build_windows:
+      #    name: "Build on Windows Server 2022"
+      #    windows_name: "win/server-2022"
+      #- build_windows:
+      #    name: "Build on Windows Server 2019"
+      #    windows_name: "win/server-2019"
diff -pruN 1.2.6-1/.github/FUNDING.yml 1.2.7-1/.github/FUNDING.yml
--- 1.2.6-1/.github/FUNDING.yml	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/.github/FUNDING.yml	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,3 @@
+# These are supported funding model platforms
+
+custom: ['https://fastnetmon.com/price/']
diff -pruN 1.2.6-1/README.md 1.2.7-1/README.md
--- 1.2.6-1/README.md	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/README.md	2024-07-01 20:01:34.000000000 +0000
@@ -50,7 +50,6 @@ Features
 - Detects DoS/DDoS in as little as 1-2 seconds
 - Scales up to terabits on single server (sFlow, Netflow, IPFIX) or to 40G + in mirror mode
 - Trigger block/notify script if an IP exceeds defined thresholds for packets/bytes/flows per second
-- [Complete support](https://fastnetmon.com/docs/detected_attack_types/) for most popular attack types
 - Thresholds can be configured per-subnet basis with the hostgroups feature
 - [Email notifications](https://fastnetmon.com/docs/attack_report_example/) about detected attack
 - Complete IPv6 support
diff -pruN 1.2.6-1/debian/changelog 1.2.7-1/debian/changelog
--- 1.2.6-1/debian/changelog	2023-10-27 06:47:11.000000000 +0000
+++ 1.2.7-1/debian/changelog	2024-07-08 13:49:50.000000000 +0000
@@ -1,3 +1,16 @@
+fastnetmon (1.2.7-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Use new systemd service: Create a fastnetmon user and do not run fastnetmon
+    as root anymore.
+  * Update debian/copyright.
+  * Overwrite false positive lintian warning.
+  * Use dh-sequence-movetousr build dependency to move files to /usr.
+    Closes: #1073746
+  * Bump Standards-Version to 4.7.0.
+
+ -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 08 Jul 2024 15:49:50 +0200
+
 fastnetmon (1.2.6-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 1.2.6-1/debian/control 1.2.7-1/debian/control
--- 1.2.6-1/debian/control	2023-10-27 06:47:11.000000000 +0000
+++ 1.2.7-1/debian/control	2024-07-08 13:49:50.000000000 +0000
@@ -2,10 +2,11 @@ Source: fastnetmon
 Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Section: net
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: cmake,
  debhelper-compat (= 13),
+ dh-sequence-movetousr,
  libboost-atomic-dev,
  libboost-chrono-dev,
  libboost-date-time-dev,
@@ -39,7 +40,8 @@ Package: fastnetmon
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
+ adduser
 Description: fast DDoS analyzer with sflow/netflow/mirror support (community edition)
  FastNetMon is a very high performance distributed denial-of-service attack
  (DDoS attack) detector built on top of multiple packet capture engines:
diff -pruN 1.2.6-1/debian/copyright 1.2.7-1/debian/copyright
--- 1.2.6-1/debian/copyright	2023-10-27 06:47:11.000000000 +0000
+++ 1.2.7-1/debian/copyright	2024-07-08 13:49:50.000000000 +0000
@@ -3,13 +3,13 @@ Upstream-Name: FastNetMon
 Source: https://github.com/pavel-odintsov/fastnetmon
 
 Files: *
-Copyright: 2013-2023 Pavel Odintsov <pavel.odintsov@gmail.com>
+Copyright: 2013-2024 Pavel Odintsov <pavel.odintsov@gmail.com>
 License: GPL-2
 
 Files: debian/*
 Copyright: 2015-2022 Pavel Odintsov <pavel.odintsov@gmail.com>
            2017 Benjamin Drung <benjamin.drung@profitbricks.com>
-           2017-2023 Patrick Matthäi <pmatthaei@debian.org>
+           2017-2024 Patrick Matthäi <pmatthaei@debian.org>
 License: GPL-2
 
 License: GPL-2
diff -pruN 1.2.6-1/debian/fastnetmon.lintian-overrides 1.2.7-1/debian/fastnetmon.lintian-overrides
--- 1.2.6-1/debian/fastnetmon.lintian-overrides	2023-10-27 06:47:11.000000000 +0000
+++ 1.2.7-1/debian/fastnetmon.lintian-overrides	2024-07-08 13:49:50.000000000 +0000
@@ -1,2 +1,3 @@
-fastnetmon: package-supports-alternative-init-but-no-init.d-script [lib/systemd/system/fastnetmon.service]
+fastnetmon: package-supports-alternative-init-but-no-init.d-script [usr/lib/systemd/system/fastnetmon.service]
 fastnetmon: no-manual-page [usr/bin/fastnetmon_api_client]
+fastnetmon: spelling-error-in-binary ment meant [usr/sbin/fastnetmon]
diff -pruN 1.2.6-1/debian/fastnetmon.postinst 1.2.7-1/debian/fastnetmon.postinst
--- 1.2.6-1/debian/fastnetmon.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/debian/fastnetmon.postinst	2024-07-08 13:49:50.000000000 +0000
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+set -e
+
+case "$1" in
+	configure)
+		getent group fastnetmon >/dev/null 2>&1 || addgroup --system fastnetmon
+		adduser --system --no-create-home --home /nonexistant --quiet fastnetmon --ingroup fastnetmon || true
+	;;
+
+	abort-upgrade|abort-remove|abort-deconfigure)
+	;;
+
+	*)
+		echo "postinst called with unknown argument \`$1'" >&2
+		exit 1
+	;;
+esac
+
+#DEBHELPER#
+
+exit 0
diff -pruN 1.2.6-1/debian/fastnetmon.postrm 1.2.7-1/debian/fastnetmon.postrm
--- 1.2.6-1/debian/fastnetmon.postrm	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/debian/fastnetmon.postrm	2024-07-08 13:49:50.000000000 +0000
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+set -e
+
+case "$1" in
+	purge)
+		delgroup fastnetmon || true
+		userdel fastnetmon || true
+	;;
+	remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
+	;;
+	*)
+		echo "postrm called with unknown argument \`$1'" >&2
+		exit 1
+esac
+
+#DEBHELPER#
+
+exit 0
diff -pruN 1.2.6-1/debian/rules 1.2.7-1/debian/rules
--- 1.2.6-1/debian/rules	2023-10-27 06:47:11.000000000 +0000
+++ 1.2.7-1/debian/rules	2024-07-08 13:49:50.000000000 +0000
@@ -11,3 +11,6 @@ endif
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DENABLE_CUSTOM_BOOST_BUILD=FALSE -DDO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD=FALSE -DLINK_WITH_ABSL=TRUE $(EXTRA_ARGS)
+
+override_dh_installsystemd:
+	dh_installsystemd --no-start --no-enable --restart-after-upgrade
diff -pruN 1.2.6-1/src/CMakeLists.txt 1.2.7-1/src/CMakeLists.txt
--- 1.2.6-1/src/CMakeLists.txt	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/CMakeLists.txt	2024-07-01 20:01:34.000000000 +0000
@@ -20,19 +20,20 @@ include(CheckLibraryExists)
 
 set (FASTNETMON_VERSION_MAJOR 1)
 set (FASTNETMON_VERSION_MINOR 2)
-set (FASTNETMON_VERSION_PATCH 6)
+set (FASTNETMON_VERSION_PATCH 7)
 
 set(HIREDIS_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/hiredis_0_14")
 set(LOG4CPP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/log4cpp_1_1_4")
 set(LIBPCAP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/pcap_1_10_4")
 set(MONGO_C_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/mongo_c_driver_1_23_0")
 set(CAPNP_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/capnproto_0_8_0")
+set(CLICKHOUSE_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/libclickhouse_2_3_0")
 set(OPENSSL_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/openssl_1_1_1q")
 set(GRPC_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/grpc_1_49_2")
 set(LIBBPF_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/bpf_1_0_1")
 set(LIBELF_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/elfutils_0_186")
 set(PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/protobuf_21_12")
-set(ABSL_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/abseil_2022_06_23")
+set(ABSL_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/abseil_2024_01_16")
 set(BOOST_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/boost_1_81_0")
 set(GCC_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/gcc_12_1_0")
 set(LIB_CPP_KAFKA_INSTALL_PATH "${FASTNETMON_LIBRARIES_GLOBAL_PATH}/cppkafka_0_3_1")
@@ -71,7 +72,7 @@ option(ENABLE_GOBGP_SUPPORT "Enable GoBG
 # It can be disabled this way: cmake .. -DENABLE_PCAP_SUPPORT=OFF
 option(ENABLE_PCAP_SUPPORT "Enable PCAP support" ON)
 
-# On some platforms like Fedora we need to explicitly link with libabseil / libabsl.
+# We need to explicitly link with libabsl.
 # We do not use it directly but gRPC uses it for libgpr and we need to link with absl explicitly to avoid linker errors like this:
 # libgpr.so: undefined reference to symbol '_ZN4absl12lts_202103245Mutex4LockEv'
 # /usr/lib64/libabsl_synchronization.so.2103.0.1: error adding symbols: DSO missing from command line
@@ -133,6 +134,7 @@ if (DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUIL
     
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CAPNP_CUSTOM_INSTALL_PATH}/lib")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${OPENSSL_CUSTOM_INSTALL_PATH}/lib")
+    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CLICKHOUSE_CUSTOM_INSTALL_PATH}/lib")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${LIBBPF_CUSTOM_INSTALL_PATH}/lib64")
     SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${LIBELF_CUSTOM_INSTALL_PATH}/lib")
 
@@ -181,6 +183,32 @@ execute_process(COMMAND git rev-list HEA
 message(STATUS "Commit hash: ${GIT_LAST_COMMIT_HASH_SHORT}")
 
 set(FASTNETMON_APPLICATION_VERSION "${FASTNETMON_VERSION_MAJOR}.${FASTNETMON_VERSION_MINOR}.${FASTNETMON_VERSION_PATCH} ${GIT_LAST_COMMIT_HASH_SHORT}")
+
+# Set standard values which work for majority of platforms
+set(FASTNETMON_PID_PATH "/var/run/fastnetmon.pid")
+set(FASTNETMON_CONFIGURATION_PATH "/etc/fastnetmon.conf")
+set(FASTNETMON_LOG_FILE_PATH "/var/log/fastnetmon.log")
+set(FASTNETMON_ATTACK_DETAILS_FOLDER "/var/log/fastnetmon_attacks")
+set(FASTNETMON_NOTIFY_SCRIPT_PATH_DEFAULT "/usr/local/bin/notify_about_attack.sh")
+set(FASTNETMON_NETWORK_WHITELIST_PATH "/etc/networks_whitelist")
+set(FASTNETMON_NETWORKS_LIST_PATH "/etc/networks_list")
+set(FASTNETMON_BACKTRACE_PATH "/var/log/fastnetmon_backtrace.dump")
+set(FASTNETMON_WHITELIST_RULES_PATH "/etc/whitelist_rules")
+
+# For FreeBSD based platforms we need to adjust them
+if (${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD" OR ${CMAKE_SYSTEM_NAME} STREQUAL "DragonFly")
+  set(FREEBSD_DEFAULT_PREFIX "/usr/local")
+
+  set(FASTNETMON_PID_PATH "/var/run/fastnetmon/fastnetmon.pid")
+  set(FASTNETMON_CONFIGURATION_PATH "${FREEBSD_DEFAULT_PREFIX}/etc/fastnetmon.conf")
+  set(FASTNETMON_LOG_FILE_PATH "/var/log/fastnetmon/fastnetmon.log")
+  set(FASTNETMON_ATTACK_DETAILS_FOLDER "/var/log/fastnetmon_attacks")
+  set(FASTNETMON_NOTIFY_SCRIPT_PATH_DEFAULT "${FREEBSD_DEFAULT_PREFIX}/bin/notify_about_attack.sh")
+  set(FASTNETMON_NETWORK_WHITELIST_PATH "${FREEBSD_DEFAULT_PREFIX}/etc/networks_whitelist")
+  set(FASTNETMON_NETWORKS_LIST_PATH "${FREEBSD_DEFAULT_PREFIX}/etc/networks_list")
+  set(FASTNETMON_BACKTRACE_PATH "/var/log/fastnetmon/fastnetmon_backtrace.dump")
+endif()
+
 configure_file(fast_platform.h.template "${PROJECT_SOURCE_DIR}/fast_platform.hpp")
 
 # Use new Memory Model Aware Atomic Operations
@@ -301,6 +329,26 @@ add_library(simple_packet_capnp STATIC s
 
 endif()
 
+# It's disabled by default as we have no CLickhouse support in system repos on many platforms but can be enabled using: 
+# cmake .. -DENABLE_CLICKHOUSE_SUPPORT=ON
+option(ENABLE_CLICKHOUSE_SUPPORT "Enable Cap'N'Proto support build" OFF)
+
+if (ENABLE_CLICKHOUSE_SUPPORT)
+    find_library(CLICKHOUSE_LIBRARY_PATH NAMES clickhouse-cpp-lib PATHS "${CLICKHOUSE_CUSTOM_INSTALL_PATH}/lib" ${DISABLE_DEFAULT_PATH_SEARCH_VAR})
+
+    if (CLICKHOUSE_LIBRARY_PATH)
+        message(STATUS "Found libclickhouse library: ${CLICKHOUSE_LIBRARY_PATH}")
+
+	# Enable Clickhouse define in code
+	add_definitions(-DENABLE_CLICKHOUSE_SUPPORT)
+
+    else()
+        message(FATAL_ERROR "We could not find libclickhouse library")
+    endif()
+
+    include_directories("${CLICKHOUSE_CUSTOM_INSTALL_PATH}/include")
+endif()
+
 # Our LPM library
 add_library(patricia STATIC libpatricia/patricia.cpp)
 
@@ -312,6 +360,12 @@ target_link_libraries(fastnetmon graphit
 add_library(influxdb_metrics STATIC metrics/influxdb.cpp)
 target_link_libraries(fastnetmon influxdb_metrics)
 
+# Clickhouse metrics
+if (ENABLE_CLICKHOUSE_SUPPORT)
+add_library(clickhouse_metrics STATIC metrics/clickhouse.cpp)
+target_link_libraries(fastnetmon clickhouse_metrics)
+endif()
+
 add_library(fastnetmon_pcap_format STATIC fastnetmon_pcap_format.cpp)
 
 # Our tools library
@@ -322,6 +376,17 @@ add_library(ipfix_rfc STATIC ipfix_field
 
 add_library(bgp_protocol STATIC bgp_protocol.cpp)
 
+# Here we store some service code for getting IP protocol name by number
+add_library(iana_ip_protocols STATIC iana_ip_protocols.cpp)
+
+# BGP Flow Spec
+add_library(bgp_protocol_flow_spec STATIC bgp_protocol_flow_spec.cpp)
+target_link_libraries(bgp_protocol_flow_spec iana_ip_protocols bgp_protocol)
+
+# Our filtering library
+add_library(filter STATIC filter.cpp)
+target_link_libraries(filter bgp_protocol bgp_protocol_flow_spec)
+
 # Our logic library
 add_library(fastnetmon_logic STATIC fastnetmon_logic.cpp)
 
@@ -594,26 +659,26 @@ if (ENABLE_GOBGP_SUPPORT)
         target_link_libraries(gobgp_action absl::base absl::synchronization)
     endif()
 
-    # By default use module supplied by cmake to search for Protobuf 
-    set(FIND_PACKAGE_MODE_PROTOBUF "MODULE")
-
     if (DO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD)
       # We add our custom path to Protobuf to top of search_list used by find_package: https://cmake.org/cmake/help/latest/variable/CMAKE_PREFIX_PATH.html
       # This approach has advantage over Protobuf_DIR which requires us to set direct path to cmake folder of custom built dependency
       # which resides in vendor specific folder with name lib which may be lib64 on CentOS platforms:
       # protobuf_21_12/lib/cmake/protobuf or  protobuf_21_12/lib64/cmake/protobuf on CentOS 
       list(APPEND CMAKE_PREFIX_PATH ${PROTOCOL_BUFFERS_CUSTOM_INSTALL_PATH}) 
-
-      # Switch to use to configuration supplied by custom Protobuf installation as it may be better
-      set(FIND_PACKAGE_MODE_PROTOBUF "CONFIG")
-
-      # Apparently it's required to set this flag because without this flag set it cannot find protoc when custom library path is in use
-      # https://github.com/protocolbuffers/protobuf/issues/1931
-      set(protobuf_MODULE_COMPATIBLE true)
     endif()
 
-    # https://cmake.org/cmake/help/latest/module/FindProtobuf.html
-    find_package(Protobuf ${FIND_PACKAGE_MODE_PROTOBUF} REQUIRED)
+    # Apparently it's required to set this flag because without this flag set it cannot find protoc when custom library path is in use
+    # https://github.com/protocolbuffers/protobuf/issues/1931
+    set(protobuf_MODULE_COMPATIBLE true)
+
+    # Switch to use to configuration supplied by custom Protobuf installation as it may be better
+    find_package(Protobuf CONFIG)
+
+    if (NOT Protobuf_FOUND)
+      # Fall back to module supplied by cmake to search for Protobuf
+      # https://cmake.org/cmake/help/latest/module/FindProtobuf.html
+      find_package(Protobuf MODULE REQUIRED)
+    endif()
 
     if (Protobuf_FOUND)
       message(STATUS "Found Protobuf ${Protobuf_VERSION}")
@@ -919,7 +984,7 @@ target_link_libraries(fastnetmon fastnet
 
 target_link_libraries(fastnetmon ipfix_rfc)
 
-target_link_libraries(fastnetmon_logic bgp_protocol exabgp_action)
+target_link_libraries(fastnetmon_logic filter bgp_protocol bgp_protocol_flow_spec exabgp_action)
 
 target_link_libraries(fastnetmon_logic protobuf_traffic_format)
 
diff -pruN 1.2.6-1/src/a10_plugin/fastnetmon_a10_v0.3.py 1.2.7-1/src/a10_plugin/fastnetmon_a10_v0.3.py
--- 1.2.6-1/src/a10_plugin/fastnetmon_a10_v0.3.py	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/a10_plugin/fastnetmon_a10_v0.3.py	2024-07-01 20:01:34.000000000 +0000
@@ -53,7 +53,7 @@ if action == "unban":
  
     sys.exit(0)
 
-elif action == "ban" or action == "attack_details":
+elif action == "ban":
     
     r = axapi_action(mitigator_base_url+ddos_dst_zone_path, method='GET', signature=signature)
     try: 
diff -pruN 1.2.6-1/src/afpacket_plugin/afpacket_collector.cpp 1.2.7-1/src/afpacket_plugin/afpacket_collector.cpp
--- 1.2.6-1/src/afpacket_plugin/afpacket_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/afpacket_plugin/afpacket_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -421,8 +421,6 @@ void start_af_packet_capture_for_interfa
             logger << log4cpp::Priority::INFO << "Start AF_PACKET worker process for " << capture_interface
                    << " with fanout group id " << fanout_group_id << " on CPU " << cpu;
 
-// Well, we have thread attributes from Boost 1.50
-#if defined(BOOST_THREAD_PLATFORM_PTHREAD) && BOOST_VERSION / 100 % 1000 >= 50 && defined(__GLIBC__)
             boost::thread::attributes thread_attrs;
 
             if (afpacket_execute_strict_cpu_affinity) {
@@ -445,14 +443,6 @@ void start_af_packet_capture_for_interfa
 
             packet_receiver_thread_group.add_thread(
                 new boost::thread(thread_attrs, boost::bind(start_af_packet_capture, capture_interface, fanout, fanout_group_id)));
-#else
-            bool fanout = true;
-
-            logger.error("Sorry but CPU affinity did not supported for your platform");
-
-            packet_receiver_thread_group.add_thread(
-                new boost::thread(start_af_packet_capture, capture_interface, fanout, fanout_group_id));
-#endif
         }
 
         // Wait all processes for finish
diff -pruN 1.2.6-1/src/bgp_protocol_flow_spec.cpp 1.2.7-1/src/bgp_protocol_flow_spec.cpp
--- 1.2.6-1/src/bgp_protocol_flow_spec.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/bgp_protocol_flow_spec.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,937 @@
+#include "bgp_protocol.hpp"
+
+#include <iostream>
+
+#include "fast_library.hpp"
+
+// inet_ntoa
+#include "network_data_structures.hpp"
+#include <arpa/inet.h>
+#include <netinet/in.h>
+#include <sys/socket.h>
+
+#include <boost/algorithm/string.hpp>
+#include <boost/algorithm/string/join.hpp>
+#include <boost/algorithm/string/replace.hpp>
+#include <cmath>
+
+#include "nlohmann/json.hpp"
+
+#include "bgp_protocol_flow_spec.hpp"
+
+// We use this encoding in FastNetMon code
+void uint8t_representation_of_tcp_flags_to_flow_spec(uint8_t tcp_flags, flow_spec_tcp_flagset_t& flagset) {
+    if (extract_bit_value(tcp_flags, TCP_SYN_FLAG_SHIFT)) {
+        flagset.syn_flag = true;
+    }
+
+    if (extract_bit_value(tcp_flags, TCP_FIN_FLAG_SHIFT)) {
+        flagset.fin_flag = true;
+    }
+
+    if (extract_bit_value(tcp_flags, TCP_RST_FLAG_SHIFT)) {
+        flagset.rst_flag = true;
+    }
+
+    if (extract_bit_value(tcp_flags, TCP_PSH_FLAG_SHIFT)) {
+        flagset.psh_flag = true;
+    }
+
+    if (extract_bit_value(tcp_flags, TCP_ACK_FLAG_SHIFT)) {
+        flagset.ack_flag = true;
+    }
+
+    if (extract_bit_value(tcp_flags, TCP_URG_FLAG_SHIFT)) {
+        flagset.urg_flag = true;
+    }
+}
+
+
+bool read_flow_spec_fragmentation_types_from_string(const std::string& string_form, flow_spec_fragmentation_types_t& fragment_flag) {
+    // Unify case for better experience with this function
+    std::string string_form_lowercase = boost::algorithm::to_lower_copy(string_form);
+
+    if (string_form_lowercase == "dont-fragment") {
+        fragment_flag = flow_spec_fragmentation_types_t::FLOW_SPEC_DONT_FRAGMENT;
+    } else if (string_form_lowercase == "is-fragment") {
+        fragment_flag = flow_spec_fragmentation_types_t::FLOW_SPEC_IS_A_FRAGMENT;
+    } else if (string_form_lowercase == "first-fragment") {
+        fragment_flag = flow_spec_fragmentation_types_t::FLOW_SPEC_FIRST_FRAGMENT;
+    } else if (string_form_lowercase == "last-fragment") {
+        fragment_flag = flow_spec_fragmentation_types_t::FLOW_SPEC_LAST_FRAGMENT;
+    } else if (string_form_lowercase == "not-a-fragment") {
+        fragment_flag = flow_spec_fragmentation_types_t::FLOW_SPEC_NOT_A_FRAGMENT;
+    } else {
+        return false;
+    }
+
+    return true;
+}
+
+std::string flow_spec_fragmentation_flags_to_string(flow_spec_fragmentation_types_t const& fragment_flag) {
+    // https://github.com/Exa-Networks/exabgp/blob/71157d560096ec20084cf96cfe0f60203721e93b/lib/exabgp/protocol/ip/fragment.py
+
+    if (fragment_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_DONT_FRAGMENT) {
+        return "dont-fragment";
+    } else if (fragment_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_IS_A_FRAGMENT) {
+        return "is-fragment";
+    } else if (fragment_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_FIRST_FRAGMENT) {
+        return "first-fragment";
+    } else if (fragment_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_LAST_FRAGMENT) {
+        return "last-fragment";
+    } else if (fragment_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_NOT_A_FRAGMENT) {
+        return "not-a-fragment";
+    } else {
+        return "";
+    }
+}
+
+bool read_flow_spec_action_type_from_string(const std::string& string_form, bgp_flow_spec_action_types_t& action_type) {
+    if (string_form == "accept") {
+        action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_ACCEPT;
+    } else if (string_form == "discard") {
+        action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_DISCARD;
+    } else if (string_form == "rate-limit") {
+        action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_RATE_LIMIT;
+    } else if (string_form == "redirect") {
+        action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_REDIRECT;
+    } else if (string_form == "mark") {
+        action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_MARK;
+    } else {
+        return false;
+    }
+
+    return true;
+}
+
+std::string serialize_action_type(const bgp_flow_spec_action_types_t& action_type) {
+    if (action_type == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_ACCEPT) {
+        return "accept";
+    } else if (action_type == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_DISCARD) {
+        return "discard";
+    } else if (action_type == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_RATE_LIMIT) {
+        return "rate-limit";
+    } else if (action_type == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_REDIRECT) {
+        return "redirect";
+    } else if (action_type == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_MARK) {
+        return "mark";
+    } else {
+        // TODO: add return code for notifying about this case
+        return std::string("");
+    }
+}
+
+bool read_flow_spec_tcp_flags_from_strig(const std::string& string_form, flow_spec_tcp_flagset_t& flagset) {
+    // Unify case for better experience with this function
+    std::string string_form_lowercase = boost::algorithm::to_lower_copy(string_form);
+
+    std::vector<std::string> tcp_flags;
+
+    // Split line by "|"
+    boost::split(tcp_flags, string_form_lowercase, boost::is_any_of("|"), boost::token_compress_on);
+
+    for (auto tcp_flag_string : tcp_flags) {
+        if (tcp_flag_string == "syn") {
+            flagset.syn_flag = true;
+        } else if (tcp_flag_string == "ack") {
+            flagset.ack_flag = true;
+        } else if (tcp_flag_string == "fin") {
+            flagset.fin_flag = true;
+        } else if (tcp_flag_string == "urgent") {
+            flagset.urg_flag = true;
+        } else if (tcp_flag_string == "push") {
+            flagset.psh_flag = true;
+        } else if (tcp_flag_string == "rst") {
+            flagset.rst_flag = true;
+        } else {
+            return false;
+        }
+    }
+
+    return true;
+}
+
+std::string flow_spec_tcp_flagset_to_string(flow_spec_tcp_flagset_t const& tcp_flagset) {
+    std::vector<std::string> output;
+
+    if (tcp_flagset.syn_flag) {
+        output.push_back("syn");
+    }
+
+    if (tcp_flagset.ack_flag) {
+        output.push_back("ack");
+    }
+
+    if (tcp_flagset.fin_flag) {
+        output.push_back("fin");
+    }
+
+    if (tcp_flagset.rst_flag) {
+        output.push_back("rst");
+    }
+
+    if (tcp_flagset.urg_flag) {
+        output.push_back("urgent");
+    }
+
+    if (tcp_flagset.psh_flag) {
+        output.push_back("push");
+    }
+
+    return boost::algorithm::join(output, "|");
+}
+
+bool operator==(const bgp_flow_spec_action_t& lhs, const bgp_flow_spec_action_t& rhs) {
+    if (lhs.get_type() != rhs.get_type()) {
+        return false;
+    }
+
+    // Action types are equal
+    if (lhs.get_type() == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_RATE_LIMIT) {
+        return lhs.get_rate_limit() == rhs.get_rate_limit();
+    } else {
+        return true;
+    }
+}
+
+bool operator!=(const bgp_flow_spec_action_t& lhs, const bgp_flow_spec_action_t& rhs) {
+    return !(lhs == rhs);
+}
+
+// It does not check UUID
+bool operator==(const flow_spec_rule_t& lhs, const flow_spec_rule_t& rhs) {
+    // Compare source subnets
+
+    // IPv4
+    if (lhs.source_subnet_ipv4_used != rhs.source_subnet_ipv4_used) {
+        return false;
+    } else {
+        if (lhs.source_subnet_ipv4_used) {
+            // If they have values
+            if (lhs.source_subnet_ipv4 != rhs.source_subnet_ipv4) {
+                return false;
+            }
+        }
+    }
+
+    // IPv6
+    if (lhs.source_subnet_ipv6_used != rhs.source_subnet_ipv6_used) {
+        return false;
+    } else {
+        if (lhs.source_subnet_ipv6_used) {
+            // If they have values
+            if (lhs.source_subnet_ipv6 != rhs.source_subnet_ipv6) {
+                return false;
+            }
+        }
+    }
+
+    // Compare destination subnets
+
+    // IPv4
+    if (lhs.destination_subnet_ipv4_used != rhs.destination_subnet_ipv4_used) {
+        return false;
+    } else {
+        if (lhs.destination_subnet_ipv4_used) {
+            if (lhs.destination_subnet_ipv4 != rhs.destination_subnet_ipv4) {
+                return false;
+            }
+        }
+    }
+
+    // IPv6
+    if (lhs.destination_subnet_ipv6_used != rhs.destination_subnet_ipv6_used) {
+        return false;
+    } else {
+        if (lhs.destination_subnet_ipv6_used) {
+            if (lhs.destination_subnet_ipv6 != rhs.destination_subnet_ipv6) {
+                return false;
+            }
+        }
+    }
+
+    // Compare actions
+    if (lhs.action != rhs.action) {
+        return false;
+    }
+
+    if (lhs.source_ports != rhs.source_ports) {
+        return false;
+    }
+
+    if (lhs.destination_ports != rhs.destination_ports) {
+        return false;
+    }
+
+    if (lhs.packet_lengths != rhs.packet_lengths) {
+        return false;
+    }
+
+    // This one is non standard compliant field and it cannot be used for BGP flow spec announces
+    if (lhs.vlans != rhs.vlans) {
+        return false;
+    }
+
+    // This one is non standard compliant field and it cannot be used for BGP flow spec announces
+    if (lhs.ttls != rhs.ttls) {
+        return false;
+    }
+
+    if (lhs.ipv4_nexthops != rhs.ipv4_nexthops) {
+        return false;
+    }
+
+    if (lhs.protocols != rhs.protocols) {
+        return false;
+    }
+
+    if (lhs.tcp_flags != rhs.tcp_flags) {
+        return false;
+    }
+
+    if (lhs.fragmentation_flags != rhs.fragmentation_flags) {
+        return false;
+    }
+
+    return true;
+}
+
+bool operator!=(const flow_spec_rule_t& lhs, const flow_spec_rule_t& rhs) {
+    return !(lhs == rhs);
+}
+
+bool operator!=(const flow_spec_tcp_flagset_t& lhs, const flow_spec_tcp_flagset_t& rhs) {
+    return !(lhs == rhs);
+}
+
+bool operator==(const flow_spec_tcp_flagset_t& lhs, const flow_spec_tcp_flagset_t& rhs) {
+    if (lhs.syn_flag == rhs.syn_flag && lhs.ack_flag == rhs.ack_flag && lhs.rst_flag == rhs.rst_flag &&
+        lhs.psh_flag == rhs.psh_flag && lhs.urg_flag == rhs.urg_flag && lhs.fin_flag == rhs.fin_flag) {
+        return true;
+    } else {
+        return false;
+    }
+}
+
+/*
+{
+  "source_prefix": "4.0.0.0\/24",
+  "destination_prefix": "127.0.0.0\/24",
+  "destination_ports": [ 80 ],
+  "source_ports": [ 53, 5353 ],
+  "packet_lengths": [ 777, 1122 ],
+  "protocols": [ "tcp" ],
+  "fragmentation_flags":[ "is-fragment", "dont-fragment" ],
+  "tcp_flags": [ "syn" ],
+  "action_type": "rate-limit",
+  "action": { "rate": 1024 }
+}
+*/
+
+bool read_flow_spec_from_json_to_native_format(const std::string& json_encoded_flow_spec, flow_spec_rule_t& flow_spec_rule, bool require_action) {
+    using json = nlohmann::json;
+
+    // We explicitly disable exceptions
+    auto json_doc = json::parse(json_encoded_flow_spec, nullptr, false);
+
+    if (json_doc.is_discarded()) {
+        logger << log4cpp::Priority::ERROR << "Cannot decode Flow Spec rule from JSON: '" << json_encoded_flow_spec << "'";
+        return false;
+    }
+
+    if (json_doc.contains("source_prefix")) {
+        std::string source_prefix_string;
+
+        try {
+            source_prefix_string = json_doc["source_prefix"].get<std::string>();
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded source_prefix";
+            return false;
+        }
+
+        if (source_prefix_string.find(":") != std::string::npos) {
+            subnet_ipv6_cidr_mask_t subnet_cidr_mask;
+
+            bool conversion_result = read_ipv6_subnet_from_string(subnet_cidr_mask, source_prefix_string);
+
+            if (!conversion_result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded IPv6 source_prefix";
+                return false;
+            }
+
+            flow_spec_rule.set_source_subnet_ipv6(subnet_cidr_mask);
+        } else {
+            subnet_cidr_mask_t subnet_cidr_mask;
+            bool conversion_result =
+                convert_subnet_from_string_to_binary_with_cidr_format_safe(source_prefix_string, subnet_cidr_mask);
+
+            if (!conversion_result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded source_prefix";
+                return false;
+            }
+
+            flow_spec_rule.set_source_subnet_ipv4(subnet_cidr_mask);
+        }
+    }
+
+    if (json_doc.contains("destination_prefix")) {
+        std::string destination_prefix_string;
+
+        try {
+            destination_prefix_string = json_doc["destination_prefix"].get<std::string>();
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded destination_prefix";
+            return false;
+        }
+
+        if (destination_prefix_string.find(":") != std::string::npos) {
+            subnet_ipv6_cidr_mask_t subnet_cidr_mask;
+
+            bool conversion_result = read_ipv6_subnet_from_string(subnet_cidr_mask, destination_prefix_string);
+
+            if (!conversion_result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded IPv6 destination_prefix";
+                return false;
+            }
+
+            flow_spec_rule.set_destination_subnet_ipv6(subnet_cidr_mask);
+        } else {
+            subnet_cidr_mask_t subnet_cidr_mask;
+            bool conversion_result =
+                convert_subnet_from_string_to_binary_with_cidr_format_safe(destination_prefix_string, subnet_cidr_mask);
+
+            if (!conversion_result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse json encoded destination_prefix";
+                return false;
+            }
+
+            flow_spec_rule.set_destination_subnet_ipv4(subnet_cidr_mask);
+        }
+    }
+
+    if (json_doc.contains("destination_ports")) {
+        std::vector<int32_t> ports_vector_as_ints;
+
+        try {
+            ports_vector_as_ints = json_doc["destination_ports"].get<std::vector<int32_t>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode destination_ports " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode destination_ports";
+            return false;
+        }
+
+        for (auto port : ports_vector_as_ints) {
+            if (!valid_port(port)) {
+                logger << log4cpp::Priority::ERROR << "Could not parse destination_ports element: bad range " << port;
+                return false;
+            }
+
+            flow_spec_rule.add_destination_port(port);
+        }
+    }
+
+    if (json_doc.contains("source_ports")) {
+        std::vector<int32_t> ports_vector_as_ints;
+
+        try {
+            ports_vector_as_ints = json_doc["source_ports"].get<std::vector<int32_t>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode source_ports " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode source_ports";
+            return false;
+        }
+
+        for (auto port : ports_vector_as_ints) {
+            if (!valid_port(port)) {
+                logger << log4cpp::Priority::ERROR << "Could not parse source_ports element: bad range " << port;
+                return false;
+            }
+
+            flow_spec_rule.add_source_port(port);
+        }
+    }
+
+    if (json_doc.contains("packet_lengths")) {
+        std::vector<int32_t> packet_lengths_vector_as_ints;
+
+        try {
+            packet_lengths_vector_as_ints = json_doc["packet_lengths"].get<std::vector<int32_t>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode packet_lengths " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode packet_lengths";
+            return false;
+        }
+
+        for (auto packet_length : packet_lengths_vector_as_ints) {
+            if (packet_length < 0) {
+                logger << log4cpp::Priority::ERROR << "Could not parse packet_lengths element, it must be positive: " << packet_length;
+                return false;
+            }
+
+            // Should we drop it?
+            if (packet_length > 1500) {
+                logger << log4cpp::Priority::ERROR
+                       << "Could not parse packet_lengths element, it must not exceed 1500: " << packet_length;
+                return false;
+            }
+
+            flow_spec_rule.add_packet_length(packet_length);
+        }
+    }
+
+    // TODO: this logic is not covered by tests
+
+    if (json_doc.contains("vlans")) {
+        std::vector<int32_t> vlans_vector_as_ints;
+
+        try {
+            vlans_vector_as_ints = json_doc["vlans"].get<std::vector<int32_t>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode vlans " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode vlans";
+            return false;
+        }
+
+        for (auto vlan : vlans_vector_as_ints) {
+            if (vlan < 0) {
+                logger << log4cpp::Priority::ERROR << "Could not parse vlan element, bad range: " << vlan;
+                return false;
+            }
+
+            flow_spec_rule.add_vlan(vlan);
+        }
+    }
+
+    // TODO: this logic is not covered by tests
+    if (json_doc.contains("ttls")) {
+	// TODO: I'm not sure that it can handle such small unsigned well
+        std::vector<uint8_t> ttls_vector_as_ints;
+
+        try {
+            ttls_vector_as_ints = json_doc["ttls"].get<std::vector<uint8_t>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode TTLs " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode TTLs";
+            return false;
+        }
+
+        for (auto ttl : ttls_vector_as_ints) {
+            flow_spec_rule.add_ttl(ttl);
+        }
+    }
+
+    if (json_doc.contains("protocols")) {
+        std::vector<std::string> protocols_vector_as_strings;
+
+        try {
+            protocols_vector_as_strings = json_doc["protocols"].get<std::vector<std::string>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode protocols " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode protocols";
+            return false;
+        }
+
+        for (const auto& protocol_as_string : protocols_vector_as_strings) {
+            ip_protocol_t protocol;
+
+            bool result = read_protocol_from_string(protocol_as_string, protocol);
+
+            if (!result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse this " << protocol_as_string << " as protocol";
+                return false;
+            }
+
+            flow_spec_rule.add_protocol(protocol);
+        }
+    }
+
+    // TODO: this logic is not covered by tests
+    if (json_doc.contains("ipv4_nexthops")) {
+        std::vector<std::string> next_hops_vector_as_strings;
+
+        try {
+            next_hops_vector_as_strings = json_doc["ipv4_nexthops"].get<std::vector<std::string>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode ipv4_nexthops " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode ipv4_nexthops";
+            return false;
+        }
+
+        for (const auto& next_hop_as_string : next_hops_vector_as_strings) {
+            uint32_t next_hop_ipv4 = 0;
+
+            auto ip_parser_result = convert_ip_as_string_to_uint_safe(next_hop_as_string, next_hop_ipv4);
+
+            if (!ip_parser_result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse this " << next_hop_as_string << " as IPv4 address";
+                return false;
+            }
+
+            flow_spec_rule.add_ipv4_nexthop(next_hop_ipv4);
+        }
+    }
+
+    if (json_doc.contains("fragmentation_flags")) {
+        std::vector<std::string> fragmentation_flags_vector_as_strings;
+
+        try {
+            fragmentation_flags_vector_as_strings = json_doc["fragmentation_flags"].get<std::vector<std::string>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode fragmentation_flags " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode fragmentation_flags";
+            return false;
+        }
+
+        for (const auto& fragmentation_flag_as_string : fragmentation_flags_vector_as_strings) {
+            flow_spec_fragmentation_types_t fragment_flag;
+
+            bool result = read_flow_spec_fragmentation_types_from_string(fragmentation_flag_as_string, fragment_flag);
+
+            if (!result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse this " << fragmentation_flag_as_string
+                       << " as flow spec fragmentation flag";
+                return false;
+            }
+
+            flow_spec_rule.add_fragmentation_flag(fragment_flag);
+        }
+    }
+
+
+    if (json_doc.contains("tcp_flags")) {
+        std::vector<std::string> tcp_flags_vector_as_strings;
+
+        try {
+            tcp_flags_vector_as_strings = json_doc["tcp_flags"].get<std::vector<std::string>>();
+        } catch (nlohmann::json::exception& e) {
+            logger << log4cpp::Priority::ERROR << "Could not decode tcp_flags " << e.what();
+            return false;
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not decode tcp_flags";
+            return false;
+        }
+
+        for (const auto& tcp_flag_as_string : tcp_flags_vector_as_strings) {
+            flow_spec_tcp_flagset_t flagset;
+
+            bool result = read_flow_spec_tcp_flags_from_strig(tcp_flag_as_string, flagset);
+
+            if (!result) {
+                logger << log4cpp::Priority::ERROR << "Could not parse this " << tcp_flag_as_string << " as flow spec tcp option flag";
+                return false;
+            }
+
+            flow_spec_rule.add_tcp_flagset(flagset);
+        }
+    }
+
+    // Skip action section when we do not need it
+    if (!require_action) {
+        return true;
+    }
+
+    bgp_flow_spec_action_t bgp_flow_spec_action;
+
+    if (!json_doc.contains("action_type")) {
+        logger << log4cpp::Priority::ERROR << "We have no action_type in JSON and it's mandatory";
+        return false;
+    }
+
+    std::string action_as_string;
+
+    try {
+        action_as_string = json_doc["action_type"].get<std::string>();
+    } catch (...) {
+        logger << log4cpp::Priority::ERROR << "Could not parse JSON encoded action_type";
+        return false;
+    }
+
+    bgp_flow_spec_action_types_t action_type;
+    bool result = read_flow_spec_action_type_from_string(action_as_string, action_type);
+
+    if (!result) {
+        logger << log4cpp::Priority::ERROR << "Could not parse action type: " << action_as_string;
+        return false;
+    }
+
+    bgp_flow_spec_action.set_type(action_type);
+
+    // And in this case we should extract rate_limit number
+    if (bgp_flow_spec_action.get_type() == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_RATE_LIMIT) {
+        if (json_doc.contains("action")) {
+            auto json_action_doc = json_doc["action"];
+
+            if (!json_action_doc.contains("rate")) {
+                logger << log4cpp::Priority::ERROR << "Absent rate argument for rate limit action";
+                return false;
+            }
+
+            int32_t rate = 0;
+
+            try {
+                rate = json_action_doc["rate"].get<int32_t>();
+            } catch (...) {
+                logger << log4cpp::Priority::ERROR << "Could not parse JSON document for rate";
+                return false;
+            }
+
+
+            if (rate < 0) {
+                logger << log4cpp::Priority::ERROR << "Rate validation failed, it must be positive: " << rate;
+                return false;
+            }
+
+            bgp_flow_spec_action.set_rate_limit(rate);
+        } else {
+            // We assume zero rate in this case
+        }
+    } else if (bgp_flow_spec_action.get_type() == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_REDIRECT) {
+        if (!json_doc.contains("action")) {
+            logger << log4cpp::Priority::ERROR << "Action need to be provided for redirect";
+            return false;
+        }
+
+        auto json_action_doc = json_doc["action"];
+
+        if (!json_action_doc.contains("redirect_target_as")) {
+            logger << log4cpp::Priority::ERROR << "Absent redirect_target_as argument for redirect action";
+            return false;
+        }
+
+        uint16_t redirect_target_as = 0;
+
+        try {
+            redirect_target_as = json_action_doc["redirect_target_as"].get<uint16_t>();
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not parse JSON document for redirect_target_as";
+            return false;
+        }
+
+        bgp_flow_spec_action.set_redirect_as(redirect_target_as);
+
+        uint32_t redirect_target_value = 0;
+        
+        try {
+            redirect_target_value = json_action_doc["redirect_target_value"].get<uint32_t>();
+        } catch (...) {
+            logger << log4cpp::Priority::ERROR << "Could not parse JSON document for redirect_target_value";
+            return false;
+        }   
+        
+        bgp_flow_spec_action.set_redirect_value(redirect_target_value);
+    }
+
+    flow_spec_rule.set_action(bgp_flow_spec_action);
+
+    return true;
+}
+
+// Encode flow spec announce into JSON representation
+bool encode_flow_spec_to_json(const flow_spec_rule_t& flow_spec_rule, std::string& json_encoded_flow_spec, bool add_uuid) {
+    nlohmann::json flow_json;
+
+    bool encoding_result = encode_flow_spec_to_json_raw(flow_spec_rule, add_uuid, flow_json);
+
+    if (!encoding_result) {
+        logger << log4cpp::Priority::ERROR << "Cannot encode Flow Spec into JSON";
+        return false;
+    }
+
+    std::string json_as_text = flow_json.dump();
+
+    // Remove ugly useless escaping for flow spec destination and source subnets
+    // I.e. 127.0.0.1\/32
+    boost::replace_all(json_as_text, "\\", "");
+
+    json_encoded_flow_spec = json_as_text;
+    return true;
+}
+
+// Encode flow spec in JSON object representation
+bool encode_flow_spec_to_json_raw(const flow_spec_rule_t& flow_spec_rule, bool add_uuid, nlohmann::json& flow_json) {
+    // UUID is quite important for us, let's add it
+    if (add_uuid) {
+        flow_json["uuid"] = flow_spec_rule.get_announce_uuid_as_string();
+    }
+
+    if (flow_spec_rule.source_subnet_ipv4_used) {
+        flow_json["source_prefix"] = convert_ipv4_subnet_to_string(flow_spec_rule.source_subnet_ipv4);
+    } else if (flow_spec_rule.source_subnet_ipv6_used) {
+        flow_json["source_prefix"] = convert_ipv6_subnet_to_string(flow_spec_rule.source_subnet_ipv6);
+    }
+
+    if (flow_spec_rule.destination_subnet_ipv4_used) {
+        flow_json["destination_prefix"] = convert_ipv4_subnet_to_string(flow_spec_rule.destination_subnet_ipv4);
+    } else if (flow_spec_rule.destination_subnet_ipv6_used) {
+        flow_json["destination_prefix"] = convert_ipv6_subnet_to_string(flow_spec_rule.destination_subnet_ipv6);
+    }
+
+    if (!flow_spec_rule.destination_ports.empty()) {
+        flow_json["destination_ports"] = flow_spec_rule.destination_ports;
+    }
+
+    if (!flow_spec_rule.source_ports.empty()) {
+        flow_json["source_ports"] = flow_spec_rule.source_ports;
+    }
+
+    if (!flow_spec_rule.packet_lengths.empty()) {
+        flow_json["packet_lengths"] = flow_spec_rule.packet_lengths;
+    }
+
+    if (!flow_spec_rule.vlans.empty()) {
+        flow_json["vlans"] = flow_spec_rule.vlans;
+    }
+
+    if (!flow_spec_rule.ttls.empty()) {
+        flow_json["ttls"] = flow_spec_rule.ttls;
+    }
+
+    if (!flow_spec_rule.protocols.empty()) {
+        flow_json["protocols"] = nlohmann::json::array();
+
+        for (auto protocol : flow_spec_rule.protocols) {
+            std::string protocol_name = get_ip_protocol_name(protocol);
+
+            // We use lowercase format
+            boost::algorithm::to_lower(protocol_name);
+
+            flow_json["protocols"].push_back(protocol_name);
+        }
+    }
+
+    if (!flow_spec_rule.fragmentation_flags.empty()) {
+        flow_json["fragmentation_flags"] = nlohmann::json::array();
+
+        for (auto fragment_flag : flow_spec_rule.fragmentation_flags) {
+            std::string fragmentation_flag_as_string = flow_spec_fragmentation_flags_to_string(fragment_flag);
+
+            // For some reasons we cannot convert it to string
+            if (fragmentation_flag_as_string == "") {
+                continue;
+            }
+
+            flow_json["fragmentation_flags"].push_back(fragmentation_flag_as_string);
+        }
+    }
+
+    // If we have TCP in protocols list explicitly, we add flags
+    bool we_have_tcp_protocol_in_list = find(flow_spec_rule.protocols.begin(), flow_spec_rule.protocols.end(),
+                                             ip_protocol_t::TCP) != flow_spec_rule.protocols.end();
+
+    if (!flow_spec_rule.tcp_flags.empty() && we_have_tcp_protocol_in_list) {
+        flow_json["tcp_flags"] = nlohmann::json::array();
+
+        for (auto tcp_flag : flow_spec_rule.tcp_flags) {
+            std::string tcp_flags_as_string = flow_spec_tcp_flagset_to_string(tcp_flag);
+
+            // For some reasons we cannot encode it, skip iteration
+            if (tcp_flags_as_string == "") {
+                continue;
+            }
+
+            flow_json["tcp_flags"].push_back(tcp_flags_as_string);
+        }
+    }
+
+    // Encode action structure
+    flow_json["action_type"] = serialize_action_type(flow_spec_rule.action.get_type());
+
+    // We add sub document action when arguments needed
+    if (flow_spec_rule.action.get_type() == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_RATE_LIMIT) {
+        nlohmann::json action_json;
+        action_json["rate"] = flow_spec_rule.action.get_rate_limit();
+
+        flow_json["action"] = action_json;
+    } else if (flow_spec_rule.action.get_type() == bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_REDIRECT) {
+        nlohmann::json action_json;
+
+        action_json["redirect_target_as"] = flow_spec_rule.action.get_redirect_as();
+        action_json["redirect_target_value"] = flow_spec_rule.action.get_redirect_value();
+
+        flow_json["action"] = action_json;
+    }
+
+    return true;
+}
+
+bgp_flowspec_one_byte_byte_encoded_tcp_flags_t return_in_one_byte_encoding(const flow_spec_tcp_flagset_t& flagset) {
+    bgp_flowspec_one_byte_byte_encoded_tcp_flags_t one_byte_flags{};
+
+    if (flagset.syn_flag) {
+        one_byte_flags.syn = 1;
+    }
+
+    if (flagset.fin_flag) {
+        one_byte_flags.fin = 1;
+    }
+
+    if (flagset.urg_flag) {
+        one_byte_flags.urg = 1;
+    }
+
+    if (flagset.ack_flag) {
+        one_byte_flags.ack = 1;
+    }
+
+    if (flagset.psh_flag) {
+        one_byte_flags.psh = 1;
+    }
+
+    if (flagset.rst_flag) {
+        one_byte_flags.rst = 1;
+    }
+
+    return one_byte_flags;
+}
+
+flow_spec_tcp_flagset_t convert_one_byte_encoding_to_flowset(const bgp_flowspec_one_byte_byte_encoded_tcp_flags_t& one_byte_flags) {
+    flow_spec_tcp_flagset_t flagset;
+
+    if (one_byte_flags.syn == 1) {
+        flagset.syn_flag = true;
+    }
+
+    if (one_byte_flags.fin == 1) {
+        flagset.fin_flag = true;
+    }
+
+    if (one_byte_flags.urg == 1) {
+        flagset.urg_flag = true;
+    }
+
+    if (one_byte_flags.ack == 1) {
+        flagset.ack_flag = true;
+    }
+
+
+    if (one_byte_flags.psh == 1) {
+        flagset.psh_flag = true;
+    }
+
+    if (one_byte_flags.rst == 1) {
+        flagset.rst_flag = true;
+    }
+
+    return flagset;
+}
+
+// Is it range valid for port?
+bool valid_port(int32_t port) {
+    return port >= 0 && port <= 65535;
+}
diff -pruN 1.2.6-1/src/bgp_protocol_flow_spec.hpp 1.2.7-1/src/bgp_protocol_flow_spec.hpp
--- 1.2.6-1/src/bgp_protocol_flow_spec.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/bgp_protocol_flow_spec.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,745 @@
+#pragma once
+
+#include <algorithm>
+#include <cstdint>
+#include <cstring>
+#include <iostream>
+#include <sstream>
+#include <string>
+#include <vector>
+
+#include "fast_endianless.hpp"
+
+#include "dynamic_binary_buffer.hpp"
+#include "fast_library.hpp"
+#include "fastnetmon_networks.hpp"
+
+#include <boost/serialization/nvp.hpp>
+
+#include "iana_ip_protocols.hpp"
+
+#include "bgp_protocol.hpp"
+
+class bgp_flow_spec_action_t;
+
+
+// This structure stores TCP flags in very human friendly way
+// It could store multiple enabled flags in same time
+class flow_spec_tcp_flagset_t {
+    public:
+    bool syn_flag = false;
+    bool ack_flag = false;
+    bool fin_flag = false;
+    bool psh_flag = false;
+    bool rst_flag = false;
+    bool urg_flag = false;
+
+    // Do we have least one flag enabled?
+    bool we_have_least_one_flag_enabled() const {
+        return syn_flag || fin_flag || urg_flag || ack_flag || psh_flag || rst_flag;
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "syn: " << syn_flag << " "
+               << "ack: " << ack_flag << " "
+               << "fin: " << fin_flag << " "
+               << "psh: " << psh_flag << " "
+               << "rst: " << rst_flag << " "
+               << "urg: " << urg_flag;
+
+        return buffer.str();
+    }
+
+    template <class Archive> void serialize(Archive& ar, [[maybe_unused]] const unsigned int version) {
+        ar& BOOST_SERIALIZATION_NVP(syn_flag);
+        ar& BOOST_SERIALIZATION_NVP(ack_flag);
+        ar& BOOST_SERIALIZATION_NVP(fin_flag);
+        ar& BOOST_SERIALIZATION_NVP(psh_flag);
+        ar& BOOST_SERIALIZATION_NVP(rst_flag);
+        ar& BOOST_SERIALIZATION_NVP(urg_flag);
+    }
+};
+
+bool operator==(const flow_spec_tcp_flagset_t& lhs, const flow_spec_tcp_flagset_t& rhs);
+bool operator!=(const flow_spec_tcp_flagset_t& lhs, const flow_spec_tcp_flagset_t& rhs);
+
+// All possible values for BGP Flow Spec fragmentation field
+enum class flow_spec_fragmentation_types_t {
+    FLOW_SPEC_DONT_FRAGMENT,
+    FLOW_SPEC_IS_A_FRAGMENT,
+    FLOW_SPEC_FIRST_FRAGMENT,
+    FLOW_SPEC_LAST_FRAGMENT,
+    // Well, this entity does not exist in RFC at all. It was addition from ExaBGP
+    FLOW_SPEC_NOT_A_FRAGMENT,
+};
+
+// Flow spec actions
+enum class bgp_flow_spec_action_types_t {
+    FLOW_SPEC_ACTION_DISCARD,
+    FLOW_SPEC_ACTION_ACCEPT,
+    FLOW_SPEC_ACTION_RATE_LIMIT,
+    FLOW_SPEC_ACTION_REDIRECT,
+    FLOW_SPEC_ACTION_MARK
+};
+
+
+
+bool read_flow_spec_action_type_from_string(const std::string& string_form, bgp_flow_spec_action_types_t& action_type);
+std::string serialize_action_type(const bgp_flow_spec_action_types_t& action_type);
+
+class bgp_flow_spec_action_t {
+    public:
+    void set_type(bgp_flow_spec_action_types_t action_type) {
+        this->action_type = action_type;
+    }
+
+    bgp_flow_spec_action_types_t get_type() const {
+        return this->action_type;
+    }
+
+    void set_rate_limit(unsigned int rate_limit) {
+        this->rate_limit = rate_limit;
+    }
+
+    unsigned int get_rate_limit() const {
+        return this->rate_limit;
+    }
+
+    uint16_t get_redirect_as() const {
+        return redirect_as;
+    }
+
+    uint32_t get_redirect_value() const {
+        return redirect_value;
+    }
+
+    void set_redirect_as(uint16_t value) {
+        redirect_as = value;
+    }
+    
+    void set_redirect_value(uint32_t value) {
+        redirect_value = value;
+    }
+
+
+    template <class Archive> void serialize(Archive& ar, [[maybe_unused]] const unsigned int version) {
+        ar& BOOST_SERIALIZATION_NVP(action_type);
+        ar& BOOST_SERIALIZATION_NVP(rate_limit);
+        ar& BOOST_SERIALIZATION_NVP(redirect_as);
+        ar& BOOST_SERIALIZATION_NVP(redirect_value);
+    }
+
+    private:
+    bgp_flow_spec_action_types_t action_type = bgp_flow_spec_action_types_t::FLOW_SPEC_ACTION_ACCEPT;
+    unsigned int rate_limit                  = 0;
+
+    // Values for redirect
+    uint16_t redirect_as = 0;
+    uint32_t redirect_value = 0;
+};
+
+bool operator==(const bgp_flow_spec_action_t& lhs, const bgp_flow_spec_action_t& rhs);
+bool operator!=(const bgp_flow_spec_action_t& lhs, const bgp_flow_spec_action_t& rhs);
+
+// We do not use < and > operators at all, sorry
+class flow_spec_rule_t {
+    public:
+    // This operation is very heavy, it may crash in case of entropy shortage and it actually happened to our customer
+    // And we must not do them in constructors as it causes lots of side effects and slows down all things
+    bool generate_uuid() {
+        boost::uuids::random_generator gen;
+
+        try {
+            announce_uuid = gen();
+        } catch (...) {
+            return false;
+        }
+
+        return true;
+    }
+
+    void set_source_subnet_ipv4(const subnet_cidr_mask_t& source_subnet) {
+        this->source_subnet_ipv4      = source_subnet;
+        this->source_subnet_ipv4_used = true;
+    }
+
+    void set_source_subnet_ipv6(const subnet_ipv6_cidr_mask_t& source_subnet) {
+        this->source_subnet_ipv6      = source_subnet;
+        this->source_subnet_ipv6_used = true;
+    }
+
+    void set_destination_subnet_ipv4(const subnet_cidr_mask_t& destination_subnet) {
+        this->destination_subnet_ipv4      = destination_subnet;
+        this->destination_subnet_ipv4_used = true;
+    }
+
+    void set_destination_subnet_ipv6(const subnet_ipv6_cidr_mask_t& destination_subnet) {
+        this->destination_subnet_ipv6      = destination_subnet;
+        this->destination_subnet_ipv6_used = true;
+    }
+
+    void set_agent_subnet(subnet_cidr_mask_t subnet_param) {
+        this->agent_subnet      = subnet_param;
+        this->agent_subnet_used = true;
+    }
+
+    void add_source_port(uint16_t source_port) {
+        this->source_ports.push_back(source_port);
+    }
+
+    void add_destination_port(uint16_t destination_port) {
+        this->destination_ports.push_back(destination_port);
+    }
+
+    void add_packet_length(uint16_t packet_length) {
+        this->packet_lengths.push_back(packet_length);
+    }
+
+    void add_vlan(uint16_t vlan) {
+        this->vlans.push_back(vlan);
+    }
+
+    void add_ipv4_nexthop(uint32_t ip) {
+        this->ipv4_nexthops.push_back(ip);
+    }
+
+    void add_protocol(ip_protocol_t protocol) {
+        this->protocols.push_back(protocol);
+    }
+
+    void add_ttl(uint8_t ttl) {
+	 this->ttls.push_back(ttl);
+    }
+
+    void add_fragmentation_flag(flow_spec_fragmentation_types_t flag) {
+        this->fragmentation_flags.push_back(flag);
+    }
+
+    void add_tcp_flagset(flow_spec_tcp_flagset_t flag) {
+        this->tcp_flags.push_back(flag);
+    }
+
+    void set_action(bgp_flow_spec_action_t action) {
+        this->action = action;
+    }
+
+    bgp_flow_spec_action_t get_action() const {
+        return this->action;
+    }
+
+    std::string get_announce_uuid_as_string() const {
+        return boost::uuids::to_string(announce_uuid);
+    }
+
+    template <class Archive> void serialize(Archive& ar, [[maybe_unused]] const unsigned int version) {
+        ar& BOOST_SERIALIZATION_NVP(source_subnet_ipv4);
+        ar& BOOST_SERIALIZATION_NVP(source_subnet_ipv4_used);
+
+        ar& BOOST_SERIALIZATION_NVP(source_subnet_ipv6);
+        ar& BOOST_SERIALIZATION_NVP(source_subnet_ipv6_used);
+
+        ar& BOOST_SERIALIZATION_NVP(destination_subnet_ipv4);
+        ar& BOOST_SERIALIZATION_NVP(destination_subnet_ipv4_used);
+
+        ar& BOOST_SERIALIZATION_NVP(destination_subnet_ipv6);
+        ar& BOOST_SERIALIZATION_NVP(destination_subnet_ipv6_used);
+
+        ar& BOOST_SERIALIZATION_NVP(agent_subnet);
+        ar& BOOST_SERIALIZATION_NVP(agent_subnet_used);
+
+        ar& BOOST_SERIALIZATION_NVP(source_ports);
+        ar& BOOST_SERIALIZATION_NVP(destination_ports);
+        ar& BOOST_SERIALIZATION_NVP(packet_lengths);
+        ar& BOOST_SERIALIZATION_NVP(vlans);
+	ar& BOOST_SERIALIZATION_NVP(ttls);
+        ar& BOOST_SERIALIZATION_NVP(ipv4_nexthops);
+
+        ar& BOOST_SERIALIZATION_NVP(protocols);
+        ar& BOOST_SERIALIZATION_NVP(fragmentation_flags);
+
+        ar& BOOST_SERIALIZATION_NVP(tcp_flags);
+        ar& BOOST_SERIALIZATION_NVP(set_match_bit_for_tcp_flags);
+        ar& BOOST_SERIALIZATION_NVP(set_match_bit_for_fragmentation_flags);
+
+        ar& BOOST_SERIALIZATION_NVP(action);
+        ar& BOOST_SERIALIZATION_NVP(announce_uuid);
+    }
+
+    // Source prefix
+    subnet_cidr_mask_t source_subnet_ipv4;
+    bool source_subnet_ipv4_used = false;
+
+    subnet_ipv6_cidr_mask_t source_subnet_ipv6;
+    bool source_subnet_ipv6_used = false;
+
+    // Destination prefix
+    subnet_cidr_mask_t destination_subnet_ipv4;
+    bool destination_subnet_ipv4_used = false;
+
+    subnet_ipv6_cidr_mask_t destination_subnet_ipv6;
+    bool destination_subnet_ipv6_used = false;
+
+    // Agent subnet
+    subnet_cidr_mask_t agent_subnet;
+    bool agent_subnet_used = false;
+
+    std::vector<uint16_t> source_ports;
+    std::vector<uint16_t> destination_ports;
+
+    // It's total IP packet length (excluding Layer 2 but including IP header)
+    // https://datatracker.ietf.org/doc/html/rfc5575#section-4
+    std::vector<uint16_t> packet_lengths;
+
+    // This one is an non standard extension for our own purposes
+    std::vector<uint16_t> vlans;
+
+    // This one is an non standard extension for our own purposes
+    std::vector<uint8_t> ttls;
+
+    // IPv4 next hops for https://datatracker.ietf.org/doc/html/draft-ietf-idr-flowspec-redirect-ip-01
+    std::vector<uint32_t> ipv4_nexthops ;
+
+    std::vector<ip_protocol_t> protocols;
+    std::vector<flow_spec_fragmentation_types_t> fragmentation_flags;
+
+    std::vector<flow_spec_tcp_flagset_t> tcp_flags;
+
+    // By default we do not use match bit for TCP flags when encode them to Flow Spec NLRI
+    // But in some cases it could be really useful
+    bool set_match_bit_for_tcp_flags = false;
+
+    // By default we do not use match bit for fragmentation flags when encode them to Flow Spec NLRI
+    // But in some cases (Huawei) it could be useful
+    bool set_match_bit_for_fragmentation_flags = false;
+
+    bgp_flow_spec_action_t action;
+    boost::uuids::uuid announce_uuid{};
+};
+
+bool operator==(const flow_spec_rule_t& lhs, const flow_spec_rule_t& rhs);
+bool operator!=(const flow_spec_rule_t& lhs, const flow_spec_rule_t& rhs);
+
+bool read_flow_spec_from_json_to_native_format(const std::string& json_encoded_flow_spec, flow_spec_rule_t& flow_spec_rule, bool require_action);
+bool encode_flow_spec_to_json(const flow_spec_rule_t& flow_spec_rule, std::string& json_encoded_flow_spec, bool add_uuid);
+bool decode_native_flow_spec_announce_from_binary_encoded_atributes(std::vector<dynamic_binary_buffer_t> binary_attributes,
+                                                                    flow_spec_rule_t& flow_spec_rule);
+
+bool encode_bgp_flow_spec_action_as_extended_attribute(const bgp_flow_spec_action_t& bgp_flow_spec_action,
+                                                       dynamic_binary_buffer_t& extended_attributes_as_binary_array);
+
+// It's format of redirect target. So called route target community. Official spec RFC5575 is pretty vague about it: 
+// https://datatracker.ietf.org/doc/html/rfc4360#section-4
+// But new BGP Flow Spec clarifies it as https://datatracker.ietf.org/doc/html/rfc8955#name-rt-redirect-rt-redirect-sub
+class __attribute__((__packed__)) redirect_2_octet_as_4_octet_value_t {
+    // We must not access these fields directly as it requires explicit byte order conversion
+    private:
+    uint16_t as = 0;
+    uint32_t value = 0;
+
+public:
+    uint16_t get_as_host_byte_order() const {
+        return fast_ntoh(as);
+    }
+
+    uint32_t get_value_host_byte_order() const {
+        return fast_ntoh(value);
+    }
+ 
+   std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "as: " << get_as_host_byte_order() << " "
+               << "value: " << get_value_host_byte_order() << " ";
+
+        return buffer.str();
+    }
+
+};
+
+static_assert(sizeof(redirect_2_octet_as_4_octet_value_t) == 6,
+              "Bad size for redirect_2_octet_as_4_octet_value_t");
+
+// More details at https://tools.ietf.org/html/rfc5575 page 6
+class __attribute__((__packed__)) bgp_flow_spec_operator_byte_t {
+    public:
+    uint8_t equal : 1 = 0, greater_than : 1 = 0, less_than : 1 = 0, reserved : 1 = 0, bit_shift_len : 2 = 0,
+                    and_bit : 1 = 0, end_of_list : 1 = 0;
+
+    void set_equal_bit() {
+        equal = 1;
+    }
+
+    void set_greater_than_bit() {
+        greater_than = 1;
+    }
+
+    void set_less_than_bit() {
+        less_than = 1;
+    }
+
+    void set_and_bit() {
+        and_bit = 1;
+    }
+
+    void set_end_of_list_bit() {
+        end_of_list = 1;
+    }
+
+    bool set_length_in_bytes(uint32_t byte_length) {
+        // We could set only for numbers which are pow of 2
+        if (byte_length == 1) {
+            bit_shift_len = 0;
+        } else if (byte_length == 2) {
+            bit_shift_len = 1;
+        } else if (byte_length == 4) {
+            bit_shift_len = 2;
+        } else {
+            logger << log4cpp::Priority::ERROR << "Could not calculate log2 for " << byte_length;
+            return false;
+        }
+
+        return true;
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "end of list: " << uint32_t(end_of_list) << " "
+               << "and_bit: " << uint32_t(and_bit) << " "
+               << "bit_shift_len: " << uint32_t(bit_shift_len) << " "
+               << "reserved: " << uint32_t(reserved) << " "
+               << "less_than: " << uint32_t(less_than) << " "
+               << "greater_than: " << uint32_t(greater_than) << " "
+               << "equal: " << uint32_t(equal);
+
+        return buffer.str();
+    }
+
+    // Real value evaluated as 1 << bit_shift_len
+    uint32_t get_value_length() {
+        return 1 << bit_shift_len;
+    }
+};
+
+// Here we store multiple enumerable values for flow spec protocol (ports,
+// protocols and other)
+class flow_spec_enumerable_lement {
+    public:
+    uint8_t one_byte_value  = 0;
+    uint16_t two_byte_value = 0;
+
+    // Could be only 1 or 2 bytes
+    uint32_t value_length = 0;
+    bgp_flow_spec_operator_byte_t operator_byte{};
+};
+
+typedef std::vector<flow_spec_enumerable_lement> multiple_flow_spec_enumerable_items_t;
+
+bool read_one_or_more_values_encoded_with_operator_byte(uint8_t* start,
+                                                        uint8_t* global_end,
+                                                        uint32_t& readed_bytes,
+                                                        multiple_flow_spec_enumerable_items_t& multiple_flow_spec_enumerable_items);
+std::string get_flow_spec_type_name_by_number(uint8_t flow_spec_type);
+std::string get_bgp_attribute_name_by_number(uint8_t bgp_attribute_type);
+bool flow_spec_decode_nlri_value(uint8_t* data_ptr, uint32_t data_length, flow_spec_rule_t& flow_spec_rule);
+
+class __attribute__((__packed__)) bgp_flow_spec_fragmentation_entity_t {
+    public:
+    uint8_t dont_fragment : 1 = 0, is_fragment : 1 = 0, first_fragment : 1 = 0, last_fragment : 1 = 0, reserved : 4 = 0;
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "reserved: " << uint32_t(reserved) << " "
+               << "last_fragment: " << uint32_t(last_fragment) << " "
+               << "first_fragment: " << uint32_t(first_fragment) << " "
+               << "is_fragment: " << uint32_t(is_fragment) << " "
+               << "dont_fragment: " << uint32_t(dont_fragment);
+
+        return buffer.str();
+    }
+};
+
+static_assert(sizeof(bgp_flow_spec_fragmentation_entity_t) == 1, "Broken size for bgp_flow_spec_fragmentation_entity_t");
+
+// More details at https://tools.ietf.org/html/rfc5575#page-9
+// We use this version of operator byte for TCP flags and for fragmentation flags
+class __attribute__((__packed__)) bgp_flow_spec_bitmask_operator_byte_t {
+    public:
+    uint8_t match_bit : 1 = 0, not_bit : 1 = 0, reserved2 : 1 = 0, reserved1 : 1 = 0, bit_shift_len : 2 = 0,
+                        and_bit : 1 = 0, end_of_list : 1 = 0;
+
+    bgp_flow_spec_bitmask_operator_byte_t() {
+        memset(this, 0, sizeof(*this));
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "end of list: " << uint32_t(end_of_list) << " "
+               << "and_bit: " << uint32_t(and_bit) << " "
+               << "bit_shift_len: " << uint32_t(bit_shift_len) << " "
+               << "reserved1: " << uint32_t(reserved1) << " "
+               << "reserved2: " << uint32_t(reserved2) << " "
+               << "not_bit: " << uint32_t(not_bit) << " "
+               << "match_bit: " << uint32_t(match_bit);
+
+        return buffer.str();
+    }
+
+    void set_not_bit() {
+        not_bit = 1;
+    }
+
+    void set_and_bit() {
+        and_bit = 1;
+    }
+
+    void set_match_bit() {
+        match_bit = 1;
+    }
+
+    void set_end_of_list_bit() {
+        end_of_list = 1;
+    }
+
+    bool set_length_in_bytes(uint32_t byte_length) {
+        // We could set only for numbers which are pow of 2
+        if (byte_length == 1) {
+            bit_shift_len = 0;
+        } else if (byte_length == 2) {
+            bit_shift_len = 1;
+        } else if (byte_length == 4) {
+            bit_shift_len = 2;
+        } else {
+            logger << log4cpp::Priority::WARN << "Could not calculate log2 for " << byte_length;
+            return false;
+        }
+
+        return true;
+    }
+
+    // Real value evaluated as 1 << bit_shift_len
+    uint32_t get_value_length() {
+        return 1 << bit_shift_len;
+    }
+};
+
+// We have two ways to encode TCP flags - one byte and two byte
+
+// This is extracted some piece of code from: tcp_header_t /
+// network_data_structures
+class __attribute__((__packed__)) bgp_flowspec_two_byte_encoded_tcp_flags_t {
+    public:
+    uint16_t fin : 1 = 0, syn : 1 = 0, rst : 1 = 0, psh : 1 = 0, ack : 1 = 0, urg : 1 = 0, ece : 1 = 0, cwr : 1 = 0,
+                   ns : 1 = 0, reserved : 3 = 0, data_offset : 4 = 0;
+};
+
+static_assert(sizeof(bgp_flowspec_two_byte_encoded_tcp_flags_t) == 2, "Bad size for bgp_flowspec_two_byte_encoded_tcp_flags_t");
+
+class __attribute__((__packed__)) bgp_flowspec_one_byte_byte_encoded_tcp_flags_t {
+    public:
+    // Just drop 8 bytes from bgp_flowspec_two_byte_encoded_tcp_flags
+    uint8_t fin : 1 = 0, syn : 1 = 0, rst : 1 = 0, psh : 1 = 0, ack : 1 = 0, urg : 1 = 0, ece : 1 = 0, cwr : 1 = 0;
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "cwr: " << uint32_t(cwr) << " "
+               << "ece: " << uint32_t(ece) << " "
+               << "urg: " << uint32_t(urg) << " "
+               << "ack: " << uint32_t(ack) << " "
+               << "psh: " << uint32_t(psh) << " "
+               << "rst: " << uint32_t(rst) << " "
+               << "syn: " << uint32_t(syn) << " "
+               << "fin: " << uint32_t(fin);
+
+        return buffer.str();
+    }
+};
+
+static_assert(sizeof(bgp_flowspec_one_byte_byte_encoded_tcp_flags_t) == 1, "Bad size for ");
+
+// BGP flow spec entity numbers
+enum FLOW_SPEC_ENTITY_TYPES : uint8_t {
+    FLOW_SPEC_ENTITY_DESTINATION_PREFIX = 1,
+    FLOW_SPEC_ENTITY_SOURCE_PREFIX      = 2,
+    FLOW_SPEC_ENTITY_IP_PROTOCOL        = 3,
+    FLOW_SPEC_ENTITY_PORT               = 4,
+    FLOW_SPEC_ENTITY_DESTINATION_PORT   = 5,
+    FLOW_SPEC_ENTITY_SOURCE_PORT        = 6,
+    FLOW_SPEC_ENTITY_ICMP_TYPE          = 7,
+    FLOW_SPEC_ENTITY_ICMP_CODE          = 8,
+    FLOW_SPEC_ENTITY_TCP_FLAGS          = 9,
+    FLOW_SPEC_ENTITY_PACKET_LENGTH      = 10,
+    FLOW_SPEC_ENTITY_DSCP               = 11,
+    FLOW_SPEC_ENTITY_FRAGMENT           = 12,
+};
+
+/*
+    Here we have custom NLRI encoding
+   (https://tools.ietf.org/html/rfc4760#section-5.1.3):
+    +---------------------------------------------------------+
+    | Address Family Identifier (2 octets)                    |
+    +---------------------------------------------------------+
+    | Subsequent Address Family Identifier (1 octet)          |
+    +---------------------------------------------------------+
+    | Length of Next Hop Network Address (1 octet)            |
+    +---------------------------------------------------------+
+    | Network Address of Next Hop (variable)                  |
+    +---------------------------------------------------------+
+    | Reserved (1 octet)                                      |
+    +---------------------------------------------------------+
+    | Network Layer Reachability Information (variable)       |
+    +---------------------------------------------------------+
+*/
+class __attribute__((__packed__)) bgp_mp_ext_flow_spec_header_t {
+    public:
+    uint16_t afi_identifier = AFI_IP;
+    uint8_t safi_identifier = SAFI_FLOW_SPEC_UNICAST;
+    // For BGP Flow spec we are using blank next hop because it's useless for us
+    // now
+    uint8_t length_of_next_hop = 0;
+    // Here we have blank next hop. Or haven't ... :)
+    uint8_t reserved = 0;
+    // Here we have NLRI information
+
+    void network_to_host_byte_order() {
+        afi_identifier = ntohs(afi_identifier);
+    }
+
+    void host_byte_order_to_network_byte_order() {
+        afi_identifier = htons(afi_identifier);
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "afi_identifier: " << uint32_t(afi_identifier) << " "
+               << "safi_identifier: " << uint32_t(safi_identifier) << " "
+               << "length_of_next_hop: " << uint32_t(length_of_next_hop) << " "
+               << "reserved: " << uint32_t(reserved);
+
+        return buffer.str();
+    }
+};
+
+class __attribute__((__packed__)) bgp_extended_community_element_flow_spec_rate_t {
+    public:
+    uint8_t type_hight = EXTENDED_COMMUNITY_TRANSITIVE_EXPEREMENTAL;
+    uint8_t type_low   = FLOW_SPEC_EXTENDED_COMMUNITY_SUBTYPE_TRAFFIC_RATE;
+
+    // This bytes are meaningless and should not processed at all by receiver side
+    uint8_t value[2] = { 0, 0 };
+    float rate_limit = 0;
+
+    void host_byte_order_to_network_byte_order() {
+        // Have you ever do little endian to big endian conversion for float? We do!
+        float rate_limit_copy = rate_limit;
+
+        logger << log4cpp::Priority::DEBUG << "Original rate: " << rate_limit;
+
+        // We do not use pointer to field structure here because it may cause alignment issues and gcc yells on it:
+        // warning: taking address of packed member of ... may result in an unaligned pointer value [-Waddress-of-packed-member]
+        uint32_t* integer_pointer = (uint32_t*)&rate_limit_copy;
+
+        logger << log4cpp::Priority::DEBUG << "Integer part of rate: " << *integer_pointer;
+
+        *integer_pointer = htonl(*integer_pointer);
+
+        // Overwrite original value
+        this->rate_limit = rate_limit_copy;
+
+        logger << log4cpp::Priority::DEBUG << "Network byte order encoded rate limit: " << rate_limit;
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "type hight: " << uint32_t(type_hight) << " "
+               << "type low: " << uint32_t(type_low) << " "
+               << "value raw: " << print_binary_string_as_hex_with_leading_0x(value, sizeof(value));
+
+        return buffer.str();
+    }
+};
+
+static_assert(sizeof(bgp_extended_community_element_flow_spec_rate_t) == 8,
+              "Bad size for bgp_extended_community_element_flow_spec_rate_t");
+
+class __attribute__((__packed__)) bgp_extended_community_element_flow_spec_redirect_2_octet_as_4_octet_value_t_t {
+    public:
+    uint8_t type_hight = EXTENDED_COMMUNITY_TRANSITIVE_EXPEREMENTAL;
+    uint8_t type_low   = FLOW_SPEC_EXTENDED_COMMUNITY_SUBTYPE_REDIRECT_AS_TWO_BYTE;
+
+    // 6 octet value
+    uint16_t redirect_as = 0;
+    uint32_t redirect_value = 0;
+
+    void set_redirect_as(uint16_t value) {
+        redirect_as = fast_hton(value);
+    }
+
+    void set_redirect_value(uint32_t value) {
+        redirect_value = fast_hton(value);
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "type hight: " << uint32_t(type_hight) << " "
+               << "type low: " << uint32_t(type_low) << " "
+               << "redirect_as: " << redirect_as << " "
+               << "redirect_value: " << redirect_value;
+
+        return buffer.str();
+    }
+};
+
+static_assert(sizeof(bgp_extended_community_element_flow_spec_redirect_2_octet_as_4_octet_value_t_t) == 8,
+              "Bad size for bgp_extended_community_element_flow_spec_redirect_2_octet_as_4_octet_value_t_t");
+
+// This structure encodes Flow Spec next hop IPv4
+class __attribute__((__packed__)) bgp_extended_community_element_flow_spec_ipv4_next_hop_t {
+    public:
+    uint8_t type_hight = EXTENDED_COMMUNITY_TRANSITIVE_IPV4_ADDRESS_SPECIFIC;
+    uint8_t type_low   = BGP_IPV4_EXTENDED_COMMUNITY_SUBTYPE_FLOW_SPEC_REDIRECT_IPv4;
+
+    // Actual value of IPv4 next hop
+    uint32_t next_hop_ipv4 = 0;
+
+    // In this field we can set mirror flag to make packet copies
+    uint16_t local_administrator = 0;
+
+    void host_byte_order_to_network_byte_order() {
+    }
+
+    std::string print() const {
+        std::stringstream buffer;
+
+        buffer << "type hight: " << uint32_t(type_hight) << " "
+               << "type low: " << uint32_t(type_low) << " "
+               << "nexthop: " << next_hop_ipv4 << " "
+               << "local administrator: " << local_administrator;
+
+        return buffer.str();
+    }
+};
+
+
+static_assert(sizeof(bgp_extended_community_element_flow_spec_ipv4_next_hop_t) == 8,
+              "Bad size for bgp_extended_community_element_flow_spec_ipv4_next_hop_t");
+
+static_assert(sizeof(bgp_flow_spec_bitmask_operator_byte_t) == 1, "Bad size for bgp_flow_spec_bitmask_operator_byte_t");
+static_assert(sizeof(bgp_flow_spec_operator_byte_t) == 1, "Bad size for bgp_flow_spec_operator_byte_t");
+
+bool read_flow_spec_tcp_flags_from_strig(const std::string& string_form, flow_spec_tcp_flagset_t& tcp_flagset);
+bool read_flow_spec_fragmentation_types_from_string(const std::string& string_form, flow_spec_fragmentation_types_t& fragment_flag);
+bool valid_port(int32_t port);
+bool encode_flow_spec_to_json_raw(const flow_spec_rule_t& flow_spec_rule, bool add_uuid, nlohmann::json& flow_json);
+std::string flow_spec_fragmentation_flags_to_string(flow_spec_fragmentation_types_t const& fragment_flag);
+std::string flow_spec_tcp_flagset_to_string(flow_spec_tcp_flagset_t const& tcp_flagset);
+void uint8t_representation_of_tcp_flags_to_flow_spec(uint8_t tcp_flags, flow_spec_tcp_flagset_t& flagset);
+
diff -pruN 1.2.6-1/src/fast_platform.h.template 1.2.7-1/src/fast_platform.h.template
--- 1.2.6-1/src/fast_platform.h.template	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/fast_platform.h.template	2024-07-01 20:01:34.000000000 +0000
@@ -1,27 +1,30 @@
 #pragma once
 
-// This file automatically generated for your platform (Linux, FreeBSD and others) with cmake
+// This file is automatically generated for your platform with cmake, please do not edit it manually
 
 class FastnetmonPlatformConfigurtion {
     public:
 
-    /* Platform specific paths */
     std::string fastnetmon_version = "${FASTNETMON_APPLICATION_VERSION}";
 
-    std::string pid_path = "/var/run/fastnetmon.pid";
-    std::string global_config_path = "/etc/fastnetmon.conf";
+    std::string pid_path = "${FASTNETMON_PID_PATH}";
+    std::string global_config_path = "${FASTNETMON_CONFIGURATION_PATH}";
 
-    std::string log_file_path = "/var/log/fastnetmon.log";
-    std::string attack_details_folder = "/var/log/fastnetmon_attacks";
+    std::string log_file_path = "${FASTNETMON_LOG_FILE_PATH}";
+    std::string attack_details_folder = "${FASTNETMON_ATTACK_DETAILS_FOLDER}";
 
     // Default path to notify script
-    std::string notify_script_path = "/usr/local/bin/notify_about_attack.sh";
+    std::string notify_script_path = "${FASTNETMON_NOTIFY_SCRIPT_PATH_DEFAULT}";
 
     // Default path to file with networks for whitelising
-    std::string white_list_path = "/etc/networks_whitelist";
+    std::string white_list_path = "${FASTNETMON_NETWORK_WHITELIST_PATH}";
 
     // Default path to file with all networks listing
-    std::string networks_list_path = "/etc/networks_list";
+    std::string networks_list_path = "${FASTNETMON_NETWORKS_LIST_PATH}";
 
-    /* Platform specific paths end */
+    // Path to temporarily store backtrace when fatal failure happened
+    std::string backtrace_path = "${FASTNETMON_BACKTRACE_PATH}";
+
+    // Path to whitelist rules
+    std::string whitelist_rules_path = "${FASTNETMON_WHITELIST_RULES_PATH}";
 };
diff -pruN 1.2.6-1/src/fastnetmon.cpp 1.2.7-1/src/fastnetmon.cpp
--- 1.2.6-1/src/fastnetmon.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/fastnetmon.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -64,6 +64,8 @@
 #include "actions/gobgp_action.hpp"
 #endif
 
+#include "bgp_protocol_flow_spec.hpp"
+
 // Yes, maybe it's not an good idea but with this we can guarantee working code in example plugin
 #include "example_plugin/example_collector.hpp"
 
@@ -115,6 +117,11 @@
 #include "metrics/graphite.hpp"
 #include "metrics/influxdb.hpp"
 
+// It's not enabled by default and we enable it only when we have Clickhouse libraries on platform
+#ifdef ENABLE_CLICKHOUSE_SUPPORT
+#include "metrics/clickhouse.hpp"
+#endif
+
 #ifdef KAFKA
 #include <cppkafka/cppkafka.h>
 #endif
@@ -157,9 +164,6 @@ unsigned int stats_thread_initial_call_d
 
 std::string reporting_server = "community-stats.fastnetmon.com";
 
-// Path to temporarily store backtrace when fatal failure happened
-std::string backtrace_path = "/var/log/fastnetmon_backtrace.dump";
-
 // Each this seconds we will check about available data in bucket
 unsigned int check_for_availible_for_processing_packets_buckets = 1;
 
@@ -239,11 +243,16 @@ bool monitor_openvz_vps_ip_addresses = f
 // We will announce whole subnet instead single IP with BGP if this flag enabled
 bool exabgp_announce_whole_subnet = false;
 
+std::string exabgp_command_pipe = "";
+
 // We will announce only /32 host
 bool exabgp_announce_host = false;
 
 ban_settings_t global_ban_settings;
 
+// We use these flow spec rules as custom whitelist
+std::vector<flow_spec_rule_t> static_flowspec_based_whitelist;
+
 void init_global_ban_settings() {
     // ban Configuration params
     global_ban_settings.enable_ban_for_pps              = false;
@@ -371,6 +380,8 @@ uint64_t our_ipv6_packets = 0;
 uint64_t incoming_total_flows_speed = 0;
 uint64_t outgoing_total_flows_speed = 0;
 
+uint64_t total_flowspec_whitelist_packets         = 0;
+
 // Network counters for IPv6
 abstract_subnet_counters_t<subnet_ipv6_cidr_mask_t, subnet_counter_t> ipv6_subnet_counters;
 
@@ -423,7 +434,6 @@ std::string exabgp_community_subnet = ""
 std::string exabgp_community_host   = "";
 
 
-std::string exabgp_command_pipe = "/var/run/exabgp.cmd";
 std::string exabgp_next_hop     = "";
 
 // Graphite monitoring
@@ -1126,28 +1136,94 @@ void subnet_vectors_allocator(prefix_t*
     logger << log4cpp::Priority::INFO << "Successfully allocated " << ipv4_host_counters.average_speed_map.size() << " counters";
 }
 
+// Load flow spec based whitelist
+bool load_whitelist_rules() {
+    if (!file_exists(fastnetmon_platform_configuration.whitelist_rules_path)) {
+	return true;
+    }
+
+    auto whitelist_rules_json = read_file_to_vector(fastnetmon_platform_configuration.whitelist_rules_path);
+
+    logger << log4cpp::Priority::INFO << "Read " << whitelist_rules_json.size() << " whitelist rules from configuration";
+
+    for (auto json_encoded_flow_spec : whitelist_rules_json) {
+        flow_spec_rule_t flow_spec_rule;
+
+        bool need_action_section = false;
+
+        bool parse_result =
+	    read_flow_spec_from_json_to_native_format(json_encoded_flow_spec, flow_spec_rule, need_action_section);
+    
+        if (!parse_result) {
+	    logger << log4cpp::Priority::ERROR << "Cannot parse flowspec whitelist rule: " << json_encoded_flow_spec;
+	    continue;
+        }
+
+        // Print rule to verify that parser worked correctly
+        std::string flow_spec_rule_as_json_to_print;
+
+        if (encode_flow_spec_to_json(flow_spec_rule, flow_spec_rule_as_json_to_print, false)) {
+	    logger << log4cpp::Priority::DEBUG << "Loaded rule " << flow_spec_rule_as_json_to_print;
+        } else {
+	    logger << log4cpp::Priority::ERROR << "Cannot encode flow spec rule for printing";
+        }
+
+        static_flowspec_based_whitelist.push_back(flow_spec_rule);
+    }
+
+    logger << log4cpp::Priority::INFO << "Loaded " << static_flowspec_based_whitelist.size() << " whitelist rules";
+
+    return true;
+}
+
 bool load_our_networks_list() {
     if (file_exists(fastnetmon_platform_configuration.white_list_path)) {
-        unsigned int network_entries                      = 0;
-        std::vector<std::string> network_list_from_config = read_file_to_vector(fastnetmon_platform_configuration.white_list_path);
+        std::vector<std::string> network_list_from_config =
+	    read_file_to_vector(fastnetmon_platform_configuration.white_list_path);
 
-        for (std::vector<std::string>::iterator ii = network_list_from_config.begin(); ii != network_list_from_config.end(); ++ii) {
-            std::string text_subnet = *ii;
-            if (text_subnet.empty()) {
-                continue;
-            }
-            if (is_v4_host(text_subnet)) {
-                logger << log4cpp::Priority::INFO << "Assuming /32 netmask for " << text_subnet;
-                text_subnet += "/32";
-            } else if (!is_cidr_subnet(text_subnet)) {
-                logger << log4cpp::Priority::ERROR << "Can't parse line from whitelist: " << text_subnet;
+        uint32_t ipv4_whitelists = 0;
+        uint32_t ipv6_whitelists = 0;
+
+        for (const auto& subnet_raw : network_list_from_config) {
+	    // Trim leading and trailing spaces
+	    std::string subnet = boost::algorithm::trim_copy(subnet_raw);
+
+            if (subnet.empty()) {
                 continue;
+	    }
+
+	    // Ignore comments
+            if (subnet.find("#") == 0) {
+		continue;
+	    }
+
+            if (strstr(subnet.c_str(), ":") == NULL) {
+                if (!is_cidr_subnet(subnet)) {
+		    logger << log4cpp::Priority::ERROR << "Cannot parse " << subnet << " as IPv4 prefix";
+                    continue;
+		}
+		    
+		// IPv4
+                ipv4_whitelists++;
+                make_and_lookup(whitelist_tree_ipv4, subnet.c_str());
+            } else {
+                // IPv6
+		
+		// Verify IPv6 prefix format    
+		subnet_ipv6_cidr_mask_t ipv6_subnet;
+
+		if (!read_ipv6_subnet_from_string(ipv6_subnet, subnet)) {
+                    logger << log4cpp::Priority::ERROR << "Cannot parse " << subnet << " as IPv6 prefix";
+		    continue;
+		}
+                
+		ipv6_whitelists++;
+                make_and_lookup_ipv6(whitelist_tree_ipv6, subnet.c_str());
             }
-            network_entries++;
-            make_and_lookup(whitelist_tree_ipv4, text_subnet.c_str());
         }
 
-        logger << log4cpp::Priority::INFO << "We loaded " << network_entries << " networks from whitelist file";
+        logger << log4cpp::Priority::INFO << "We loaded " << ipv4_whitelists << " IPv4 networks and " << ipv6_whitelists
+           << " IPv6 networks from whitelist";
     }
 
     std::vector<std::string> networks_list_ipv4_as_string;
@@ -1195,11 +1271,11 @@ bool load_our_networks_list() {
     }
 
     if (monitor_local_ip_addresses && file_exists("/sbin/ip")) {
-        logger << log4cpp::Priority::INFO << "We are working on Linux and could use ip tool for detecting local IP's";
+        logger << log4cpp::Priority::INFO << "On Linux we can use ip tool to detect local IPs";
 
         ip_addresses_list_t ip_list = get_local_ip_v4_addresses_list();
 
-        logger << log4cpp::Priority::INFO << "We found " << ip_list.size() << " local IP addresses and will monitor they";
+        logger << log4cpp::Priority::INFO << "We found " << ip_list.size() << " local IP addresses";
 
         for (ip_addresses_list_t::iterator iter = ip_list.begin(); iter != ip_list.end(); ++iter) {
             // TODO: add IPv6 here
@@ -1211,18 +1287,29 @@ bool load_our_networks_list() {
         std::vector<std::string> network_list_from_config =
             read_file_to_vector(fastnetmon_platform_configuration.networks_list_path);
 
-        for (std::vector<std::string>::iterator line_itr = network_list_from_config.begin();
-             line_itr != network_list_from_config.end(); ++line_itr) {
+        for (const auto& subnet_raw : network_list_from_config) {
+            // Trim leading and trailing spaces
+            std::string subnet = boost::algorithm::trim_copy(subnet_raw);
+
+            if (subnet.empty()) {
+                // Empty line
+                continue;
+            }
 
-            if (line_itr->length() == 0) {
+            if (subnet.length() == 0) {
                 // Skip blank lines in subnet list file silently
                 continue;
             }
 
-            if (strstr(line_itr->c_str(), ":") == NULL) {
-                networks_list_ipv4_as_string.push_back(*line_itr);
+            // Ignore comments
+            if (subnet.find("#") == 0) {
+                continue;
+            }
+
+            if (strstr(subnet.c_str(), ":") == NULL) {
+                networks_list_ipv4_as_string.push_back(subnet);
             } else {
-                networks_list_ipv6_as_string.push_back(*line_itr);
+                networks_list_ipv6_as_string.push_back(subnet);
             }
         }
 
@@ -1413,7 +1500,7 @@ void init_logging(bool log_to_console) {
         logger.addAppender(appender);
     }
 
-    logger << log4cpp::Priority::INFO << "Logger initialized!";
+    logger << log4cpp::Priority::INFO << "Logger initialized";
 }
 
 void reconfigure_logging_level(const std::string& logging_level) {
@@ -1519,7 +1606,7 @@ void redirect_fds() {
 // Handles fatal failure of FastNetMon's daemon
 void fatal_signal_handler(int signum) {
     ::signal(signum, SIG_DFL);
-    boost::stacktrace::safe_dump_to(backtrace_path.c_str());
+    boost::stacktrace::safe_dump_to(fastnetmon_platform_configuration.backtrace_path.c_str());
     ::raise(SIGABRT);
 }
 
@@ -1650,9 +1737,9 @@ int main(int argc, char** argv) {
 
     init_logging(log_to_console);
 
-    if (std::filesystem::exists(backtrace_path)) {
+    if (std::filesystem::exists(fastnetmon_platform_configuration.backtrace_path)) {
         // there is a backtrace
-        std::ifstream ifs(backtrace_path);
+        std::ifstream ifs(fastnetmon_platform_configuration.backtrace_path);
 
         boost::stacktrace::stacktrace st = boost::stacktrace::stacktrace::from_dump(ifs);
         logger << log4cpp::Priority::ERROR << "Previous run crashed, you can find stack trace below";
@@ -1660,7 +1747,7 @@ int main(int argc, char** argv) {
 
         // cleaning up
         ifs.close();
-        std::filesystem::remove(backtrace_path);
+        std::filesystem::remove(fastnetmon_platform_configuration.backtrace_path);
     }
 
 #ifdef FASTNETMON_API
@@ -1763,6 +1850,8 @@ int main(int argc, char** argv) {
 
     load_our_networks_list();
 
+    load_whitelist_rules();
+
     // We should specify size of circular buffers here
     packet_buckets_ipv4_storage.set_buffers_capacity(ban_details_records_count);
 
diff -pruN 1.2.6-1/src/fastnetmon.service.in 1.2.7-1/src/fastnetmon.service.in
--- 1.2.6-1/src/fastnetmon.service.in	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/fastnetmon.service.in	2024-07-01 20:01:34.000000000 +0000
@@ -4,14 +4,15 @@ Documentation=man:fastnetmon(8)
 After=network.target remote-fs.target
  
 [Service]
-Type=forking
-ExecStart=@CMAKE_INSTALL_SBINDIR@/fastnetmon --daemonize
-PIDFile=/run/fastnetmon.pid
+Type=simple
+ExecStart=@CMAKE_INSTALL_SBINDIR@/fastnetmon --log_to_console
+User=fastnetmon
+Group=fastnetmon
 Restart=on-failure
 RestartSec=3
 LimitNOFILE=65535
-#ExecReload=/bin/kill -s HUP $MAINPID
-#ExecStop=/bin/kill -s QUIT $MAINPID
- 
+# We need it to use AF_PACKET and AF_XDP when run under non root user
+AmbientCapabilities=CAP_NET_RAW CAP_IPC_LOCK
+
 [Install]
 WantedBy=multi-user.target
diff -pruN 1.2.6-1/src/fastnetmon_logic.cpp 1.2.7-1/src/fastnetmon_logic.cpp
--- 1.2.6-1/src/fastnetmon_logic.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/fastnetmon_logic.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -18,6 +18,10 @@
 #include "fast_library.hpp"
 #include "fast_platform.hpp"
 
+#include "bgp_protocol_flow_spec.hpp"
+
+#include "filter.hpp"
+
 #include "fast_endianless.hpp"
 
 // Plugins
@@ -322,7 +326,9 @@ std::string print_ban_thresholds(ban_set
 void print_attack_details_to_file(const std::string& details, const std::string& client_ip_as_string, const attack_details_t& current_attack) {
     std::ofstream my_attack_details_file;
 
+    // TODO: it may not work well with systems which do not allow ":" as part of file name (macOS)
     std::string ban_timestamp_as_string = print_time_t_in_fastnetmon_format(current_attack.ban_timestamp);
+    
     std::string attack_dump_path =
         fastnetmon_platform_configuration.attack_details_folder + "/" + client_ip_as_string + "_" + ban_timestamp_as_string + ".txt";
 
@@ -1220,7 +1226,7 @@ void call_blackhole_actions_per_host(att
 
         std::string full_attack_description = basic_attack_information + "\n\nAttack traffic dump\n\n" + simple_packets_dump + "\n\nFlow dump\n\n" + flow_attack_details;
 
-        if (store_attack_details_to_file && ipv4) {
+        if (store_attack_details_to_file) {
             print_attack_details_to_file(full_attack_description, client_ip_as_string, current_attack);
         }
     }
@@ -2386,8 +2392,9 @@ void collect_traffic_to_buckets_ipv4(con
 void process_packet(simple_packet_t& current_packet) {
     extern abstract_subnet_counters_t<uint32_t, subnet_counter_t> ipv4_host_counters;
     extern packet_buckets_storage_t<uint32_t> packet_buckets_ipv4_storage;
-
+    extern std::vector<flow_spec_rule_t> static_flowspec_based_whitelist;
     extern map_of_vector_counters_for_flow_t SubnetVectorMapFlow;
+    extern uint64_t total_flowspec_whitelist_packets;
 
 #ifdef KAFKA
     extern bool kafka_traffic_export;
@@ -2449,6 +2456,19 @@ void process_packet(simple_packet_t& cur
     }
 #endif
 
+    // Check against static flow spec based whitelist
+    if ((current_packet.packet_direction == INCOMING or current_packet.packet_direction == OUTGOING) &&
+        static_flowspec_based_whitelist.size() > 0) {
+        // We do not use mutex here because we load this list only on startup
+        bool should_we_whitelist_this_packet = filter_packet_by_flowspec_rule_list(current_packet, static_flowspec_based_whitelist);
+
+        if (should_we_whitelist_this_packet) {
+            total_flowspec_whitelist_packets++;
+            return;
+        }
+    }
+
+
     // It's useful in case when we can't find what packets do not processed correctly
     if (DEBUG_DUMP_OTHER_PACKETS && current_packet.packet_direction == OTHER) {
         logger << log4cpp::Priority::INFO << "Dump other: " << print_simple_packet(current_packet);
diff -pruN 1.2.6-1/src/fastnetmon_rc_freebsd 1.2.7-1/src/fastnetmon_rc_freebsd
--- 1.2.6-1/src/fastnetmon_rc_freebsd	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/fastnetmon_rc_freebsd	1970-01-01 00:00:00.000000000 +0000
@@ -1,36 +0,0 @@
-#!/bin/sh
-
-# PROVIDE: fastnetmon
-# REQUIRE: NETWORKING SERVERS LOGIN
-# BEFORE:  securelevel
-# KEYWORD: shutdown
-
-# Add the following line to /etc/rc.conf to enable `fastnetmon':
-#
-#fastnetmon_enable="YES"
-#
-
-. /etc/rc.subr
-
-name="fastnetmon"
-rcvar="${name}_enable"
-
-command="/usr/local/bin/fastnetmon"
-start_precmd="start_precmd"
-pidfile="/var/run/$name.pid"
-
-# read configuration and set defaults
-load_rc_config "$name"
-: ${fastnetmon_enable="NO"}
-: ${fastnetmon_user="fastnetmon"}
-#: ${fastnetmon_config="/usr/local/etc/$name.conf"}
-
-start_precmd()
-{
-    echo -n "Starting fastnetmon deamon:" && \
-    su -m $fastnetmon_user -c "$command"; && \
-    echo .
-    return 0
-}
-
-run_rc_command "$1"
diff -pruN 1.2.6-1/src/filter.cpp 1.2.7-1/src/filter.cpp
--- 1.2.6-1/src/filter.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/filter.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,233 @@
+#include "filter.hpp"
+
+#include "iana_ip_protocols.hpp"
+
+#include "ip_lookup_tree.hpp"
+
+// Filter packet if it matches list of active flow spec announces
+bool filter_packet_by_flowspec_rule_list(const simple_packet_t& current_packet,
+                                         const std::vector<flow_spec_rule_t>& active_flow_spec_announces) {
+    for (auto& flow_announce : active_flow_spec_announces) {
+        // Check that any rule matches specific flow spec announce
+        if (filter_packet_by_flowspec_rule(current_packet, flow_announce)) {
+            return true;
+        }
+    }
+
+    return false;
+}
+
+// Returns true when packet matches specific rule
+bool filter_packet_by_flowspec_rule(const simple_packet_t& current_packet, const flow_spec_rule_t& flow_announce) {
+    bool source_port_matches         = false;
+    bool destination_port_matches    = false;
+    bool source_ip_matches           = false;
+    bool destination_ip_matches      = false;
+    bool packet_size_matches         = false;
+    bool vlan_matches                = false;
+    bool tcp_flags_matches           = false;
+    bool fragmentation_flags_matches = false;
+    bool protocol_matches            = false;
+
+    if (flow_announce.source_ports.size() == 0) {
+        source_port_matches = true;
+    } else {
+        if (std::find(flow_announce.source_ports.begin(), flow_announce.source_ports.end(), current_packet.source_port) !=
+            flow_announce.source_ports.end()) {
+            // We found this IP in list
+            source_port_matches = true;
+        }
+    }
+
+    if (flow_announce.destination_ports.size() == 0) {
+        destination_port_matches = true;
+    } else {
+        if (std::find(flow_announce.destination_ports.begin(), flow_announce.destination_ports.end(),
+                      current_packet.destination_port) != flow_announce.destination_ports.end()) {
+            // We found this IP in list
+            destination_port_matches = true;
+        }
+    }
+
+    if (flow_announce.protocols.size() == 0) {
+        protocol_matches = true;
+    } else {
+        if (current_packet.protocol <= 255) {
+            // Convert protocol as number into strictly typed protocol_type
+            ip_protocol_t flow_protocol = get_ip_protocol_enum_type_from_integer(uint8_t(current_packet.protocol));
+
+            if (std::find(flow_announce.protocols.begin(), flow_announce.protocols.end(), flow_protocol) !=
+                flow_announce.protocols.end()) {
+                protocol_matches = true;
+            }
+        } else {
+            // Protocol cannot exceed 255!
+        }
+    }
+
+    if (flow_announce.source_subnet_ipv4_used) {
+        subnet_cidr_mask_t src_subnet;
+
+        if (flow_announce.source_subnet_ipv4.cidr_prefix_length == 32) {
+
+            src_subnet.set_cidr_prefix_length(32);
+            src_subnet.set_subnet_address(current_packet.src_ip);
+
+            if (flow_announce.source_subnet_ipv4 == src_subnet) {
+                source_ip_matches = true;
+            }
+        } else {
+            // We build Patricia tree for lookup but it's not very effective from performance perspective
+            // To improve performance you may write native function to check if IP belongs to subnet_cidr_mask_t
+            lookup_tree_32bit_t lookup_tree;
+
+            lookup_tree.add_subnet(flow_announce.source_subnet_ipv4);
+
+            if (lookup_tree.lookup_ip(current_packet.src_ip)) {
+                source_ip_matches = true;
+            }
+        }
+    } else if (flow_announce.source_subnet_ipv6_used) {
+        if (flow_announce.source_subnet_ipv6.cidr_prefix_length == 128) {
+            subnet_ipv6_cidr_mask_t src_subnet;
+
+            src_subnet.set_cidr_prefix_length(128);
+            src_subnet.set_subnet_address(&current_packet.src_ipv6);
+
+            if (flow_announce.source_subnet_ipv6 == src_subnet) {
+                source_ip_matches = true;
+            }
+        } else {
+            // We do not support non /128 boundaries yet
+        }
+    } else {
+        source_ip_matches = true;
+    }
+
+    if (flow_announce.destination_subnet_ipv4_used) {
+        if (flow_announce.destination_subnet_ipv4.cidr_prefix_length == 32) {
+            subnet_cidr_mask_t dst_subnet;
+
+            dst_subnet.set_cidr_prefix_length(32);
+            dst_subnet.set_subnet_address(current_packet.dst_ip);
+
+            if (flow_announce.destination_subnet_ipv4 == dst_subnet) {
+                destination_ip_matches = true;
+            }
+        } else {
+            // We build Patricia tree for lookup but it's not very effective from performance perspective
+            // To improve performance you may write native function to check if IP belongs to subnet_cidr_mask_t
+            lookup_tree_32bit_t lookup_tree;
+
+            lookup_tree.add_subnet(flow_announce.destination_subnet_ipv4);
+
+            if (lookup_tree.lookup_ip(current_packet.dst_ip)) {
+                destination_ip_matches = true;
+            }
+        }
+    } else if (flow_announce.destination_subnet_ipv6_used) {
+        if (flow_announce.destination_subnet_ipv6.cidr_prefix_length == 128) {
+            subnet_ipv6_cidr_mask_t dst_subnet;
+
+            dst_subnet.set_cidr_prefix_length(128);
+            dst_subnet.set_subnet_address(&current_packet.dst_ipv6);
+
+            if (flow_announce.destination_subnet_ipv6 == dst_subnet) {
+                destination_ip_matches = true;
+            }
+        } else {
+            // We do not support non /128 boundaries yet
+        }
+    } else {
+        destination_ip_matches = true;
+    }
+
+    if (flow_announce.fragmentation_flags.size() == 0) {
+        fragmentation_flags_matches = true;
+    } else {
+        for (auto& fragmentation_flag : flow_announce.fragmentation_flags) {
+            // TODO: we are using only this two options in detection code but we should cover ALL possible cases!
+            if (fragmentation_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_DONT_FRAGMENT) {
+                if (current_packet.ip_dont_fragment) {
+                    fragmentation_flags_matches = true;
+                }
+            } else if (fragmentation_flag == flow_spec_fragmentation_types_t::FLOW_SPEC_IS_A_FRAGMENT) {
+                if (current_packet.ip_fragmented) {
+                    fragmentation_flags_matches = true;
+                }
+            }
+        }
+    }
+
+    if (flow_announce.tcp_flags.size() == 0) {
+        tcp_flags_matches = true;
+    } else {
+        // Convert 8bit representation of flags for this packet into flagset representation for flow spec
+        flow_spec_tcp_flagset_t flagset;
+        uint8t_representation_of_tcp_flags_to_flow_spec(current_packet.flags, flagset);
+
+        // logger << log4cpp::Priority::WARN <<"Packet's tcp flagset: " << flagset.to_string();
+
+        if (std::find(flow_announce.tcp_flags.begin(), flow_announce.tcp_flags.end(), flagset) !=
+            flow_announce.tcp_flags.end()) {
+            tcp_flags_matches = true;
+        }
+    }
+
+    if (flow_announce.packet_lengths.size() == 0) {
+        packet_size_matches = true;
+    } else {
+        // Use matching only if we can convert it to 16 bit value
+        if (current_packet.length <= 65635) {
+            // Convert 64 bit (we need it because netflow) value to 16 bit
+            uint16_t packet_length_uint16 = (uint16_t)current_packet.length;
+
+            // TODO: it's a bit incorrect to use check against packet length here
+            // because as mentioned below we use total ip length for flow spec rules.
+            // And here we have FULL packet length (including L2, Ethernet header)
+            // But we just added ip_length field and need to check both
+            if (std::find(flow_announce.packet_lengths.begin(), flow_announce.packet_lengths.end(), packet_length_uint16) !=
+                flow_announce.packet_lengths.end()) {
+                packet_size_matches = true;
+            }
+
+            // Flow spec uses length in form "total length of IP packet" and we should check it
+            uint16_t ip_packet_length_uint16 = (uint16_t)current_packet.ip_length;
+
+            if (std::find(flow_announce.packet_lengths.begin(), flow_announce.packet_lengths.end(),
+                          ip_packet_length_uint16) != flow_announce.packet_lengths.end()) {
+                packet_size_matches = true;
+            }
+        }
+    }
+
+    if (flow_announce.vlans.size() == 0) {
+        vlan_matches = true;
+    } else {
+        if (std::find(flow_announce.vlans.begin(), flow_announce.vlans.end(), current_packet.vlan) !=
+            flow_announce.vlans.end()) {
+            vlan_matches = true;
+        }
+    }
+
+    // Nice thing for debug
+    /*
+    logger << log4cpp::Priority::WARN
+        << "source_port_matches: " << source_port_matches << " "
+        << "destination_port_matches: " << destination_port_matches << " "
+        << "source_ip_matches: " << source_ip_matches << " "
+        << "destination_ip_matches: " << destination_ip_matches << " "
+        << "packet_size_matches: " << packet_size_matches << " "
+        << "tcp_flags_matches: " << tcp_flags_matches << " "
+        << "fragmentation_flags_matches: " << fragmentation_flags_matches << " "
+        << "protocol_matches: " << protocol_matches;
+    */
+
+    // Return true only of all parts matched
+    if (source_port_matches && destination_port_matches && source_ip_matches && destination_ip_matches &&
+        packet_size_matches && tcp_flags_matches && fragmentation_flags_matches && protocol_matches && vlan_matches) {
+        return true;
+    }
+
+    return false;
+}
diff -pruN 1.2.6-1/src/filter.hpp 1.2.7-1/src/filter.hpp
--- 1.2.6-1/src/filter.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/filter.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,6 @@
+#include "bgp_protocol_flow_spec.hpp"
+#include "fastnetmon_simple_packet.hpp"
+
+bool filter_packet_by_flowspec_rule_list(const simple_packet_t& current_packet,
+                                         const std::vector<flow_spec_rule_t>& active_flow_spec_announces);
+bool filter_packet_by_flowspec_rule(const simple_packet_t& current_packet, const flow_spec_rule_t& flow_announce);
diff -pruN 1.2.6-1/src/ip_lookup_tree.hpp 1.2.7-1/src/ip_lookup_tree.hpp
--- 1.2.6-1/src/ip_lookup_tree.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/ip_lookup_tree.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,155 @@
+#pragma once
+
+#include <iostream>
+
+#include "fastnetmon_networks.hpp"
+#include "libpatricia/patricia.hpp"
+
+// Here we have pretty nice wrappers for patricia tree
+class lookup_tree_128bit_t {
+    public:
+    lookup_tree_128bit_t() {
+        patricia_tree = New_Patricia(128);
+    }
+
+    ~lookup_tree_128bit_t() {
+        if (patricia_tree) {
+            Destroy_Patricia(patricia_tree);
+            patricia_tree = nullptr;
+        }
+    }
+
+    bool add_subnet(const subnet_ipv6_cidr_mask_t& subnet) {
+        // TODO: rewrite this code to native prefix adding. Get rid useless string conversion
+        std::string subnet_as_string = convert_ipv6_subnet_to_string(subnet);
+
+        make_and_lookup_ipv6(patricia_tree, (char*)subnet_as_string.c_str());
+
+        return true;
+    }
+
+    // Lookup this IP in Patricia tree
+    bool lookup_ip(const in6_addr& client_ipv6_address) const {
+        prefix_t prefix_for_check_address;
+
+        prefix_for_check_address.family   = AF_INET6;
+        prefix_for_check_address.bitlen   = 128;
+        prefix_for_check_address.add.sin6 = client_ipv6_address;
+
+        patricia_node_t* found_patrica_node = patricia_search_best2(patricia_tree, &prefix_for_check_address, 1);
+
+        // Could not find anything
+        if (found_patrica_node == NULL) {
+            return false;
+        }
+
+        return true;
+
+    }
+
+    // TODO: rework get_packet_direction_ipv6 and make it public
+    public:
+    patricia_tree_t* patricia_tree = nullptr;
+};
+
+class lookup_tree_32bit_t {
+    public:
+    lookup_tree_32bit_t() {
+        patricia_tree = New_Patricia(32);
+    }
+
+    bool add_subnet(const subnet_cidr_mask_t& subnet) {
+        // TODO: rewrite this code to native prefix adding. Get rid useless string conversion
+        std::string subnet_as_string = convert_ipv4_subnet_to_string(subnet);
+
+        make_and_lookup(patricia_tree, (char*)subnet_as_string.c_str());
+
+        return true;
+    }
+
+    // Lookup this IP in Patricia tree
+    bool lookup_ip(uint32_t ip_address_big_endian) const {
+        prefix_t prefix_for_check_address;
+
+        prefix_for_check_address.add.sin.s_addr = ip_address_big_endian;
+        prefix_for_check_address.family         = AF_INET;
+        prefix_for_check_address.bitlen         = 32;
+
+        patricia_node_t* found_patrica_node = patricia_search_best2(patricia_tree, &prefix_for_check_address, 1);
+
+        // Could not find anything
+        if (found_patrica_node == NULL) {
+            return false;
+        }
+
+        return true;
+    }
+
+    // Lookup this network in Patricia tree
+    bool lookup_network(const subnet_cidr_mask_t& subnet) const {
+        prefix_t prefix_for_check_adreess;
+        
+        prefix_for_check_adreess.add.sin.s_addr = subnet.subnet_address;
+        prefix_for_check_adreess.family         = AF_INET;
+        prefix_for_check_adreess.bitlen         = subnet.cidr_prefix_length;
+
+        patricia_node_t* found_patrica_node = patricia_search_best2(patricia_tree, &prefix_for_check_adreess, 1);
+
+        // Could not find anything
+        if (found_patrica_node == NULL) {
+            return false;
+        }
+
+        return true;
+    }
+
+    // Lookups this IP in Patricia tree and returns network prefix which consists this IP in our tree
+    // Returns false when IP is not a part of tree
+    bool lookup_network_which_includes_ip(uint32_t ip_address_big_endian, subnet_cidr_mask_t& subnet) const {
+        prefix_t prefix_for_check_address;
+
+        prefix_for_check_address.add.sin.s_addr = ip_address_big_endian;
+        prefix_for_check_address.family         = AF_INET;
+        prefix_for_check_address.bitlen         = 32;
+
+        patricia_node_t* found_patrica_node = patricia_search_best2(patricia_tree, &prefix_for_check_address, 1);
+
+        // Could not find anything
+        if (found_patrica_node == NULL) {
+            return false;
+        }
+
+        prefix_t* prefix = found_patrica_node->prefix;
+
+        // It should not happen but I prefer to be on safe side
+        if (prefix == NULL) {
+            return false;
+        }
+
+        subnet.subnet_address     = prefix->add.sin.s_addr;
+        subnet.cidr_prefix_length = prefix->bitlen;
+
+        return true;
+    }
+
+    ~lookup_tree_32bit_t() {
+        if (patricia_tree) {
+            Destroy_Patricia(patricia_tree);
+            patricia_tree = nullptr;
+        }
+    }
+    
+    // Allow access to private variables from tests
+    friend class patricia_process_ipv4_Test;
+    friend class patricia_positive_lookup_ipv4_check_data_field_value_Test;
+    friend class patricia_positive_lookup_ipv4_lookup_24_in_same_24_Test;
+    friend class patricia_positive_lookup_ipv4_Test;
+    friend class patricia_positive_lookup_ipv4_lookup_24_in_same_24_not_inclusive_Test;
+    friend class patricia_positive_lookup_32_in32_with_24_Test;
+    friend class patricia_positive_lookup_multiple_networks_Test;
+    friend class patricia_positive_lookup_32_in32_Test;
+
+    private:
+    patricia_tree_t* patricia_tree = nullptr;
+};
+
diff -pruN 1.2.6-1/src/juniper_plugin/fastnetmon_juniper.php 1.2.7-1/src/juniper_plugin/fastnetmon_juniper.php
--- 1.2.6-1/src/juniper_plugin/fastnetmon_juniper.php	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/juniper_plugin/fastnetmon_juniper.php	2024-07-01 20:01:34.000000000 +0000
@@ -61,7 +61,7 @@ $conn = new Device($cfg);
 switch($ACTION_ATTACK){
     case 'ban':
         try{
-            $desc = 'FastNetMon Guard: IP '. $IP_ATTACK .' unblocked because '. $DIRECTION_ATTACK .' attack with power '. $POWER_ATTACK .' pps | at '.$fecha_now;
+            $desc = 'FastNetMon Community: IP '. $IP_ATTACK .' unblocked because '. $DIRECTION_ATTACK .' attack with power '. $POWER_ATTACK .' pps | at '.$fecha_now;
             $conn->connect(); //Try conect or catch NetconfException (Wrong username, Timeout, Device not found, etc)
             $locked = $conn->lock_config(); //Equivalent of "configure exclusive" on Juniper CLI
             if($locked){
@@ -83,7 +83,7 @@ switch($ACTION_ATTACK){
         break;
     case 'unban':
         try{
-            $desc = 'FastNetMon Guard: IP '. $IP_ATTACK .' remove from blacklist.';
+            $desc = 'FastNetMon Community: IP '. $IP_ATTACK .' remove from blacklist.';
             $conn->connect(); //Try conect or catch NetconfException (Wrong username, Timeout, Device not found, etc)
             $locked = $conn->lock_config(); //Equivalent of "configure exclusive" on Juniper CLI
             if($locked){
diff -pruN 1.2.6-1/src/metrics/clickhouse.cpp 1.2.7-1/src/metrics/clickhouse.cpp
--- 1.2.6-1/src/metrics/clickhouse.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/metrics/clickhouse.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,11 @@
+#include "clickhouse.hpp"
+
+#include <clickhouse/client.h>
+
+#include "../abstract_subnet_counters.hpp"
+#include "../fast_library.hpp"
+#include "../fastnetmon_types.hpp"
+
+#include "hostgroup_lookup.hpp"
+#include "traffic_rule_lookup.hpp"
+
diff -pruN 1.2.6-1/src/metrics/clickhouse.hpp 1.2.7-1/src/metrics/clickhouse.hpp
--- 1.2.6-1/src/metrics/clickhouse.hpp	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.7-1/src/metrics/clickhouse.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -0,0 +1,16 @@
+#pragma once
+
+#include <clickhouse/client.h>
+
+#include "../fastnetmon_types.hpp"
+#include "../fastnetmon_configuration_scheme.hpp"
+
+void clickhouse_push_thread();
+
+bool push_network_traffic_counters_to_clickhouse();
+bool push_total_traffic_counters_to_clickhouse();
+bool push_hosts_traffic_counters_to_clickhouse();
+
+void create_clickhouse_attack_event(const std::string& ip_address, const std::string& title, const std::string& text);
+bool init_clickhouse_for_metrics(fastnetmon_configuration_t& fastnetmon_global_configuration,
+                                 clickhouse::Client*& clickhouse_metrics_client);
diff -pruN 1.2.6-1/src/metrics/influxdb.cpp 1.2.7-1/src/metrics/influxdb.cpp
--- 1.2.6-1/src/metrics/influxdb.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/metrics/influxdb.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -17,6 +17,7 @@ extern abstract_subnet_counters_t<subnet
 extern uint64_t influxdb_writes_total;
 extern uint64_t influxdb_writes_failed;
 extern abstract_subnet_counters_t<subnet_ipv6_cidr_mask_t, subnet_counter_t> ipv6_host_counters;
+extern abstract_subnet_counters_t<subnet_ipv6_cidr_mask_t, subnet_counter_t> ipv6_subnet_counters;
 extern std::vector<ban_settings_t> hostgroup_list_total_calculation;
 extern std::mutex hostgroup_list_total_calculation_mutex;
 extern abstract_subnet_counters_t<int64_t, subnet_counter_t> per_hostgroup_total_counters;
@@ -342,6 +343,11 @@ void influxdb_push_thread() {
                                                 current_influxdb_ip_address, std::to_string(influxdb_port), influxdb_auth,
                                                 influxdb_user, influxdb_password, "hosts_ipv6_traffic", "host");
 
+        // Push per network IPv6 counters to InfluxDB
+        push_network_traffic_counters_to_influxdb(ipv6_subnet_counters, influxdb_database,
+                                                current_influxdb_ip_address, std::to_string(influxdb_port), influxdb_auth,
+                                                influxdb_user, influxdb_password, "networks_ipv6_traffic", "network");
+
         // Push total IPv6 counters
         push_total_traffic_counters_to_influxdb(influxdb_database, current_influxdb_ip_address, std::to_string(influxdb_port),
                                                 influxdb_auth, influxdb_user, influxdb_password, "total_traffic_ipv6",
diff -pruN 1.2.6-1/src/mikrotik_plugin/fastnetmon_mikrotik.php 1.2.7-1/src/mikrotik_plugin/fastnetmon_mikrotik.php
--- 1.2.6-1/src/mikrotik_plugin/fastnetmon_mikrotik.php	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/mikrotik_plugin/fastnetmon_mikrotik.php	2024-07-01 20:01:34.000000000 +0000
@@ -65,7 +65,7 @@ $API = new RouterosAPI();
 if ( $API->connect( $cfg[ ip_mikrotik ], $cfg[ api_user ], $cfg[ api_pass ] ) ) {
     //add Blocking by route blackhole
     if ( $ACTION_ATTACK == "ban" ) {
-        $comment_rule = 'FastNetMon Guard: IP ' . $IP_ATTACK . ' blocked because ' . $DIRECTION_ATTACK . ' attack with power ' . $POWER_ATTACK . ' pps | at '.$fecha_now;
+        $comment_rule = 'FastNetMon Community: IP ' . $IP_ATTACK . ' blocked because ' . $DIRECTION_ATTACK . ' attack with power ' . $POWER_ATTACK . ' pps | at '.$fecha_now;
         $API->write( '/ip/route/add', false );
         $API->write( '=dst-address=' . $IP_ATTACK, false );
         $API->write( '=type=blackhole', false );
@@ -79,7 +79,7 @@ if ( $API->connect( $cfg[ ip_mikrotik ],
     }
     if ( $ACTION_ATTACK == "unban" ) {
         // remove the blackhole rule 
-        $comment_rule = 'FastNetMon Guard: IP ' . $IP_ATTACK . ' remove from blacklist ';
+        $comment_rule = 'FastNetMon Community: IP ' . $IP_ATTACK . ' remove from blacklist ';
         $API->write( '/ip/route/print', false );
         $API->write( '?dst-address=' . $IP_ATTACK . "/32" );
         $ID_ARRAY = $API->read();
diff -pruN 1.2.6-1/src/netflow_plugin/ipfix.hpp 1.2.7-1/src/netflow_plugin/ipfix.hpp
--- 1.2.6-1/src/netflow_plugin/ipfix.hpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netflow_plugin/ipfix.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -45,9 +45,15 @@
 #define IPFIX_ENGINE_TYPE 38
 #define IPFIX_ENGINE_ID 39
 
+#define IPFIX_FRAGMENT_IDENTIFICATION 54
+
+#define IPFIX_SOURCE_MAC_ADDRESS 56
+
 #define IPFIX_FLOW_DIRECTION 61
 #define IPFIX_IPV6_NEXT_HOP 62
 
+#define IPFIX_DESTINATION_MAC_ADDRESS 80
+
 #define IPFIX_FORWARDING_STATUS 89
 
 #define IPFIX_FLOW_END_REASON 136
@@ -56,6 +62,12 @@
 #define IPFIX_FLOW_START_MILLISECONDS 152
 #define IPFIX_FLOW_END_MILLISECONDS 153
 
+// We use 8 byte encoding: https://datatracker.ietf.org/doc/html/rfc7011#section-6.1.10
+#define IPFIX_FLOW_START_NANOSECONDS 156
+#define IPFIX_FLOW_END_NANOSECONDS 157
+
+#define IPFIX_SAMPLING_SELECTOR_ALGORITHM 304
+
 #define IPFIX_SAMPLING_PACKET_INTERVAL 305
 
 #define IPFIX_SAMPLING_PACKET_SPACE 306
@@ -65,7 +77,8 @@
 #define IPFIX_SELECTOR_TOTAL_PACKETS_OBSERVED 318
 #define IPFIX_SELECTOR_TOTAL_PACKETS_SELECTED 319
 
-
+// Sampler types https://www.iana.org/assignments/psamp-parameters/psamp-parameters.xhtml
+#define IPFIX_SAMPLER_TYPE_SYSTEMATIC_COUNT_BASED_SAMPLING 1
 
 class __attribute__((__packed__)) ipfix_header_common_t {
     public:
@@ -118,5 +131,3 @@ class __attribute__((__packed__)) ipfix_
     uint16_t field_count       = 0;
     uint16_t scope_field_count = 0;
 };
-
-
diff -pruN 1.2.6-1/src/netflow_plugin/ipfix_collector.cpp 1.2.7-1/src/netflow_plugin/ipfix_collector.cpp
--- 1.2.6-1/src/netflow_plugin/ipfix_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netflow_plugin/ipfix_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -1,3 +1,6 @@
+// That's not a module as we do refactoring right now in small steps
+// TODO: place make it proper module
+
 void update_ipfix_sampling_rate(uint32_t sampling_rate, const std::string& client_addres_in_string_format);
 
 // https://tools.ietf.org/html/rfc5101#page-18
@@ -172,8 +175,12 @@ bool process_ipfix_options_template(cons
     bool updated                   = false;
     bool updated_existing_template = false;
 
-    add_update_peer_template(netflow_protocol_version_t::ipfix, global_ipfix_templates, source_id, template_id, client_addres_in_string_format,
-                             field_template, updated, updated_existing_template);
+    add_update_peer_template(netflow_protocol_version_t::ipfix, global_ipfix_templates, global_ipfix_templates_mutex, source_id,
+                             template_id, client_addres_in_string_format, field_template, updated, updated_existing_template);
+
+    // This code is not perfect from locks perspective as we read global_ipfix_templates without any locks below
+
+    // NB! Please be careful with changing name of variable as it's part of serialisation protocol
 
     if (updated_existing_template) {
         ipfix_template_data_updates++;
@@ -263,12 +270,10 @@ bool process_ipfix_template(const uint8_
         bool updated                   = false;
         bool updated_existing_template = false;
 
-        add_update_peer_template(netflow_protocol_version_t::ipfix, global_ipfix_templates, source_id, template_id, client_addres_in_string_format,
+        add_update_peer_template(netflow_protocol_version_t::ipfix, global_ipfix_templates,
+                                 global_ipfix_templates_mutex, source_id, template_id, client_addres_in_string_format,
                                  field_template, updated, updated_existing_template);
 
-        // If we have any changes for this template, let's flush them to disk
-        if (updated) {
-        }
 
         if (updated_existing_template) {
             ipfix_template_data_updates++;
@@ -278,12 +283,15 @@ bool process_ipfix_template(const uint8_
     return true;
 }
 
-
 bool ipfix_record_to_flow(uint32_t record_type, uint32_t record_length, const uint8_t* data, simple_packet_t& packet, netflow_meta_info_t& flow_meta) {
     switch (record_type) {
     case IPFIX_IN_BYTES:
         if (record_length > sizeof(packet.length)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IN_BYTES: " << record_length;
+            }
         } else {
             BE_COPY(packet.length);
 
@@ -299,6 +307,11 @@ bool ipfix_record_to_flow(uint32_t recor
     case IPFIX_IN_PACKETS:
         if (record_length > sizeof(packet.number_of_packets)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IN_PACKETS: " << record_length;
+            }
+
         } else {
             BE_COPY(packet.number_of_packets);
 
@@ -309,6 +322,11 @@ bool ipfix_record_to_flow(uint32_t recor
     case IPFIX_IN_PROTOCOL:
         if (record_length > sizeof(packet.protocol)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IN_PROTOCOL: " << record_length;
+            }
+
         } else {
             BE_COPY(packet.protocol);
 
@@ -327,12 +345,21 @@ bool ipfix_record_to_flow(uint32_t recor
             memcpy(&packet.flags, data + 1, 1);
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_TCP_FLAGS: " << record_length;
+            }
         }
 
         break;
     case IPFIX_L4_SRC_PORT:
         if (record_length > sizeof(packet.source_port)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_L4_SRC_PORT: " << record_length;
+            }
+
         } else {
             BE_COPY(packet.source_port);
 
@@ -344,6 +371,11 @@ bool ipfix_record_to_flow(uint32_t recor
     case IPFIX_L4_DST_PORT:
         if (record_length > sizeof(packet.destination_port)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_L4_DST_PORT: " << record_length;
+            }
+
         } else {
             BE_COPY(packet.destination_port);
 
@@ -355,6 +387,11 @@ bool ipfix_record_to_flow(uint32_t recor
     case IPFIX_IPV4_SRC_ADDR:
         if (record_length > sizeof(packet.src_ip)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV4_SRC_ADDR: " << record_length;
+            }
+
         } else {
             memcpy(&packet.src_ip, data, record_length);
         }
@@ -363,6 +400,11 @@ bool ipfix_record_to_flow(uint32_t recor
     case IPFIX_IPV4_DST_ADDR:
         if (record_length > sizeof(packet.dst_ip)) {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV4_DST_ADDR: " << record_length;
+            }
+
         } else {
             memcpy(&packet.dst_ip, data, record_length);
         }
@@ -380,6 +422,10 @@ bool ipfix_record_to_flow(uint32_t recor
             // std::cout << "IP next hop: " << convert_ip_as_uint_to_string(ip_next_hop_ipv4) << std::endl;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV4_NEXT_HOP: " << record_length;
+            }
         }
 
         break;
@@ -396,6 +442,10 @@ bool ipfix_record_to_flow(uint32_t recor
             // std::cout << "BGP next hop: " << convert_ip_as_uint_to_string(bgp_next_hop_ipv4) << std::endl;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_BGP_NEXT_HOP_IPV4_ADDRESS: " << record_length;
+            }
         }
 
         break;
@@ -411,6 +461,10 @@ bool ipfix_record_to_flow(uint32_t recor
             // std::cout << "bgp next hop: " << print_ipv6_address(ipv6_next_hop) << std::endl;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV6_NEXT_HOP: " << record_length;
+            }
         }
 
 
@@ -432,6 +486,10 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.src_asn = src_asn;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_SRC_AS: " << record_length;
+            }
         }
 
         break;
@@ -450,9 +508,37 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.dst_asn = dst_asn;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_DST_AS: " << record_length;
+            }
         }
 
         break;
+    case IPFIX_SOURCE_MAC_ADDRESS:
+        if (record_length == 6) {
+            // Copy it directly to packet structure
+            memcpy(&packet.source_mac, data, record_length);
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Too large field for IPFIX_SOURCE_MAC_ADDRESS";
+            }
+        }
+        break;
+    case IPFIX_DESTINATION_MAC_ADDRESS:
+        if (record_length == 6) {
+            // Copy it directly to packet structure
+            memcpy(&packet.destination_mac, data, record_length);
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Too large field for IPFIX_DESTINATION_MAC_ADDRESS";
+            }
+        }
+        break;
     // According to https://www.iana.org/assignments/ipfix/ipfix.xhtml interfaces can be 4 byte only
     case IPFIX_INPUT_SNMP:
         if (record_length == 4) {
@@ -461,8 +547,18 @@ bool ipfix_record_to_flow(uint32_t recor
 
             input_interface        = fast_ntoh(input_interface);
             packet.input_interface = input_interface;
+        } else if (record_length == 2) {
+            uint16_t input_interface = 0;
+            memcpy(&input_interface, data, record_length);
+
+            input_interface        = fast_ntoh(input_interface);
+            packet.input_interface = input_interface;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_INPUT_SNMP: " << record_length;
+            }
         }
 
         break;
@@ -473,31 +569,49 @@ bool ipfix_record_to_flow(uint32_t recor
 
             output_interface        = fast_ntoh(output_interface);
             packet.output_interface = output_interface;
+        } else if (record_length == 2) {
+            uint16_t output_interface = 0;
+            memcpy(&output_interface, data, record_length);
+
+            output_interface        = fast_ntoh(output_interface);
+            packet.output_interface = output_interface;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_OUTPUT_SNMP: " << record_length;
+            }
         }
 
         break;
     case IPFIX_IPV6_SRC_ADDR:
         // It should be 16 bytes only
-            if (record_length == 16) {
-                memcpy(&packet.src_ipv6, data, record_length);
-                // Set protocol version to IPv6
-                packet.ip_protocol_version = 6;
-            } else {
-                ipfix_too_large_field++;
+        if (record_length == 16) {
+            memcpy(&packet.src_ipv6, data, record_length);
+            // Set protocol version to IPv6
+            packet.ip_protocol_version = 6;
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV6_SRC_ADDR: " << record_length;
             }
+        }
 
         break;
     case IPFIX_IPV6_DST_ADDR:
         // It should be 16 bytes only
-            if (record_length == 16) {
-                memcpy(&packet.dst_ipv6, data, record_length);
-                // Set protocol version to IPv6
-                packet.ip_protocol_version = 6;
-            } else {
-                ipfix_too_large_field++;
+        if (record_length == 16) {
+            memcpy(&packet.dst_ipv6, data, record_length);
+            // Set protocol version to IPv6
+            packet.ip_protocol_version = 6;
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_IPV6_DST_ADDR: " << record_length;
             }
+        }
         break;
     case IPFIX_FIRST_SWITCHED:
         // Mikrotik uses this encoding
@@ -510,6 +624,10 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.flow_start = flow_started;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FIRST_SWITCHED: " << record_length;
+            }
         }
 
         break;
@@ -524,6 +642,10 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.flow_end = flow_finished;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_LAST_SWITCHED: " << record_length;
+            }
         }
 
         break;
@@ -539,6 +661,10 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.flow_start = flow_started;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_START_MILLISECONDS: " << record_length;
+            }
         }
 
         break;
@@ -553,9 +679,57 @@ bool ipfix_record_to_flow(uint32_t recor
             packet.flow_end = flow_finished;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_END_MILLISECONDS: " << record_length;
+            }
+        }
+
+        break;
+        // Netgate TNSR uses IPFIX_FLOW_START_NANOSECONDS and IPFIX_FLOW_END_NANOSECONDS
+    case IPFIX_FLOW_START_NANOSECONDS:
+        if (record_length == 8) {
+            uint64_t flow_started = 0;
+
+            memcpy(&flow_started, data, record_length);
+            flow_started = fast_ntoh(flow_started);
+
+            // We cast unsigned to signed and it may cause issues
+            packet.flow_start = flow_started;
+
+            // Convert to milliseconds
+            packet.flow_start = packet.flow_start / 1000000;
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_START_NANOSECONDS: " << record_length;
+            }
+        }
+
+        break;
+    case IPFIX_FLOW_END_NANOSECONDS:
+        if (record_length == 8) {
+            uint64_t flow_finished = 0;
+
+            memcpy(&flow_finished, data, record_length);
+            flow_finished = fast_ntoh(flow_finished);
+
+            // We cast unsigned to signed and it may cause issues
+            packet.flow_end = flow_finished;
+
+            // Convert to milliseconds
+            packet.flow_end = packet.flow_end / 1000000;
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_END_NANOSECONDS: " << record_length;
+            }
         }
 
         break;
+
     case IPFIX_FORWARDING_STATUS:
         // TODO: we did using theoretical information and did not test it at all
         // Documented here: https://www.iana.org/assignments/ipfix/ipfix.xhtml#forwarding-status
@@ -577,6 +751,10 @@ bool ipfix_record_to_flow(uint32_t recor
         } else {
             // It must be exactly one byte
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FORWARDING_STATUS: " << record_length;
+            }
         }
 
         break;
@@ -588,47 +766,74 @@ bool ipfix_record_to_flow(uint32_t recor
             flow_meta.data_link_frame_size = fast_ntoh(datalink_frame_size);
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_DATALINK_FRAME_SIZE: " << record_length;
+            }
         }
 
         break;
     case IPFIX_DATALINK_FRAME_SECTION:
         // Element 315: https://www.iana.org/assignments/ipfix/ipfix.xhtml
 
-        // We create block here as gcc does not want to compile without it with error: error: jump to case label
-        {
         // It's packet header as is in variable length encoding
+        if (true) {
             ipfix_inline_headers++;
 
-            // This data is encoded using following approach: https://datatracker.ietf.org/doc/html/rfc7011#section-7
-            const uint8_t* field_length_ptr = (const uint8_t*)data;
+            // This packet is ended using IPFIX variable length encoding and it may have two possible ways of length encoding
+            // https://datatracker.ietf.org/doc/html/rfc7011#section-7
+            if (flow_meta.variable_field_length_encoding == variable_length_encoding_t::single_byte || flow_meta.variable_field_length_encoding == variable_length_encoding_t::two_byte) {
 
-            // Get rid of pointer syntax
-            uint8_t packet_header_length = *field_length_ptr;
-
-            // logger << log4cpp::Priority::DEBUG << "Packet header length is " << int(packet_header_length);
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Packet header length: " << flow_meta.variable_field_length;
+                }
 
-            // We will support only fields which are < 255 bytes length as it simpler way of encoding
-            if (packet_header_length != 0 && packet_header_length < 255) {
-                bool read_packet_length_from_ip_header = true;
+                if (flow_meta.variable_field_length != 0) {
+                    bool read_packet_length_from_ip_header = true;
 
-                bool extract_tunnel_traffic = false;
+                    bool extract_tunnel_traffic = false;
 
-                auto result =
-                    parse_raw_packet_to_simple_packet_full_ng((u_char*)(data + sizeof(uint8_t)), packet_header_length, packet_header_length,
-                                                           flow_meta.nested_packet, extract_tunnel_traffic, read_packet_length_from_ip_header);
+                    const uint8_t* payload_shift = nullptr;
 
-                if (result != network_data_stuctures::parser_code_t::success) {
-                    // Cannot decode data
-                    ipfix_inline_header_parser_error++;
+                    if (flow_meta.variable_field_length_encoding == variable_length_encoding_t::single_byte) {
+                        payload_shift = data + sizeof(uint8_t);
+                    } else if (flow_meta.variable_field_length_encoding == variable_length_encoding_t::two_byte) {
+                        payload_shift = data + sizeof(uint8_t) + sizeof(uint16_t);
+                    }
+
+                    auto result =
+                        parse_raw_packet_to_simple_packet_full_ng(payload_shift, flow_meta.variable_field_length,
+                                                                    flow_meta.variable_field_length, flow_meta.nested_packet,
+                                                                  extract_tunnel_traffic, read_packet_length_from_ip_header);
+
+                    if (result != network_data_stuctures::parser_code_t::success) {
+                        // Cannot decode data
+                        ipfix_inline_header_parser_error++;
+
+                        if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                            logger << log4cpp::Priority::DEBUG << "Cannot parse packet header with error: " << network_data_stuctures::parser_code_to_string(result);
+                        }
+
+                    } else {
+                        // Successfully decoded data
+                        ipfix_inline_header_parser_success++;
+
+                        flow_meta.nested_packet_parsed = true;
+                        // logger << log4cpp::Priority::DEBUG << "IPFIX inline extracted packet: " << print_simple_packet(flow_meta.nested_packet);
+                    }
                 } else {
-                    // Successfully decoded data
-                    ipfix_inline_header_parser_success++;
-                    
-                    flow_meta.nested_packet_parsed = true;
-                    // logger << log4cpp::Priority::DEBUG << "IPFIX inline extracted packet: " << print_simple_packet(flow_meta.nested_packet);
+                    ipfix_inline_encoding_error++;
+
+                    if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                        logger << log4cpp::Priority::DEBUG << "Zero length variable fields are not supported";
+                    }
                 }
             } else {
-                // It may be zero length value or it may be 255 which means that data is longer
+                ipfix_inline_encoding_error++;
+                
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Unknown variable field encoding type";
+                }
             }
         }
 
@@ -646,6 +851,10 @@ bool ipfix_record_to_flow(uint32_t recor
             // std::cout << "Flow direction: " << int(flow_direction) << std::endl;
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_DIRECTION: " << record_length;
+            }
         }
 
         break;
@@ -671,6 +880,61 @@ bool ipfix_record_to_flow(uint32_t recor
             }
         } else {
             ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FLOW_END_REASON: " << record_length;
+            }
+        }
+
+        break;
+    case IPFIX_FRAGMENT_IDENTIFICATION:
+        //
+        // Specification: https://www.rfc-editor.org/rfc/rfc5102.html#section-5.4.23
+        //
+        // IPFIX uses 32 bit values to accommodate following cases:
+        //  - 16 bit IPv4 identification field https://www.rfc-editor.org/rfc/rfc791
+        //  - 32 bit IPv6 identification field https://en.wikipedia.org/wiki/IPv6_packet#Fragment
+        //
+        // Juniper uses it on J MX platforms but they do not have much information about it:
+        // https://www.juniper.net/documentation/us/en/software/junos/flow-monitoring/topics/concept/inline-sampling-overview.html
+        // I asked https://t.me/dgubin about it
+        //
+        // I did review of dump from J MX and I can confirm that values for IPv4 do not exceed maximum value for uint16_t (65535)
+        // 
+        // J MX is doing something fun with this field. I got dump in hands and in this dump of 42421 packets only 2337 have non zero value of this field.
+        // Clearly they violate RFC and do not populate this field unconditionally as RFC dictates.
+        //
+        // I see cases like this which is very likely non first fragment of fragmented series of packets as we do not have ports:
+        // Identification: 20203 ipv4:0 > ipv4:0 protocol: udp frag: 0  packets: 1 size: 352 bytes ip size: 352 bytes ttl: 0 sample ratio: 1
+        // 
+        // And I see packets like this which may be first packet in fragmented series of packets as we do indeed have ports here and packet length is high: 
+        // Identification: 2710 ipv4:53 > ipv4:45134 protocol: udp frag: 0  packets: 1 size: 1476 bytes ip size: 1476 bytes ttl: 0 sample ratio: 1
+        //
+        // And majority of packets looks this way:
+        // Identification: 0 ipv4:80 > ipv4:50179 protocol: tcp flags: ack frag: 0  packets: 1 size: 40 bytes ip size: 40 bytes ttl: 0 sample ratio: 1
+        //
+        // We clearly can distinguish first fragmented packet and non first fragmented packet
+        //
+        // TODO: this logic must be enabled via flag only as this is non RFC compliant behavior and we need to have confirmation from J
+        //
+        // We have this guide from J: https://www.juniper.net/documentation/us/en/software/junos/flow-monitoring/topics/concept/services-ipfix-flow-aggregation-ipv6-extended-attributes.html but it's written in exceptionally weird way and raises more questions then answers
+        //
+
+        // It's exactly 4 bytes
+        if (record_length == 4) {
+            uint32_t fragment_identification = 0;
+
+            memcpy(&fragment_identification, data, record_length);
+
+            fragment_identification = fast_ntoh(fragment_identification);
+
+            // logger << log4cpp::Priority::INFO << "Fragment identification: " << fragment_identification; 
+        } else {
+            ipfix_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_FRAGMENT_IDENTIFICATION: " << record_length;
+            }
         }
 
         break;
@@ -679,7 +943,6 @@ bool ipfix_record_to_flow(uint32_t recor
     return true;
 }
 
-
 // Read options data packet with known template
 bool ipfix_options_flowset_to_store(const uint8_t* pkt,
                                     const ipfix_header_t* ipfix_header,
@@ -689,7 +952,16 @@ bool ipfix_options_flowset_to_store(cons
     pkt += flow_template->option_scope_length;
 
     uint32_t sampling_rate = 0;
-    uint32_t offset        = 0;
+
+    // Field shift in memory
+    uint32_t offset = 0;
+
+    // Sampling algorithm for exotic sampling types
+    uint16_t sampling_selector_algorithm = 0;
+
+    // We use these fields to work with systematic count-based Sampling Selector on Nokia
+    uint32_t sampling_packet_space    = 0;
+    uint32_t sampling_packet_interval = 0;
 
     device_timeouts_t device_timeouts{};
 
@@ -699,46 +971,81 @@ bool ipfix_options_flowset_to_store(cons
         // Time to extract sampling rate
         if (elem.record_type == IPFIX_SAMPLING_INTERVAL) {
             // RFC suggest that this field is 4 byte: https://www.iana.org/assignments/ipfix/ipfix.xhtml
-            if (elem.record_length > sizeof(sampling_rate)) {
-                logger << log4cpp::Priority::ERROR << "Unexpectedly big size for IPFIX_SAMPLING_INTERVAL: " << elem.record_length;
-                ipfix_too_large_field++;
+            if (elem.record_length == 4) {
+                uint32_t current_sampling_rate = 0;
+                memcpy(&current_sampling_rate, data_shift, elem.record_length);
 
-                return false;
-            }
+                // TODO: we do not convert value to little endian as sampling update function expects big endian / network byte order
 
-            bool result = be_copy_function(data_shift, (uint8_t*)&sampling_rate, sizeof(sampling_rate), elem.record_length);
+                sampling_rate = current_sampling_rate;
 
-            if (!result) {
-                logger << log4cpp::Priority::ERROR
-                       << "Prevented attempt to read outside of allowed memory region for IPFIX_SAMPLING_INTERVAL";
-                return false;
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "4 byte encoded IPFIX_SAMPLING_INTERVAL sampling rate: " << sampling_rate
+                           << " from " << client_addres_in_string_format;
+                }
+            } else {
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Unexpectedly big size for IPFIX_SAMPLING_INTERVAL: " << elem.record_length;
+                }
+
+                ipfix_too_large_field++;
             }
         } else if (elem.record_type == IPFIX_SAMPLING_PACKET_INTERVAL) {
             // RFC suggest that this field is 4 byte: https://www.iana.org/assignments/ipfix/ipfix.xhtml
-            if (elem.record_length > sizeof(sampling_rate)) {
-                logger << log4cpp::Priority::ERROR
-                       << "Unexpectedly big size for IPFIX_SAMPLING_PACKET_INTERVAL: " << elem.record_length;
-                ipfix_too_large_field++;
+            if (elem.record_length == 4) {
+                uint32_t current_sampling_packet_interval = 0;
 
-                return false;
-            }
+                memcpy(&current_sampling_packet_interval, data_shift, elem.record_length);
 
-            bool result = be_copy_function(data_shift, (uint8_t*)&sampling_rate, sizeof(sampling_rate), elem.record_length);
+                current_sampling_packet_interval = fast_ntoh(current_sampling_packet_interval);
 
-            if (!result) {
-                logger << log4cpp::Priority::ERROR << "Prevented attempt to read outside of allowed memory region for IPFIX_SAMPLING_PACKET_INTERVAL";
-                return false;
+                // Well, we need this information to deal with systematic count-based Sampling Selector on Nokia
+                sampling_packet_interval = current_sampling_packet_interval;
+
+                // And we need this value to use as regular sampling rate on Cisco NSC
+                // We need to return it to big endian again we sampling logic in IPFIX uses big endian / network byte order
+                sampling_rate = fast_hton(sampling_packet_interval);
+            } else {
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG
+                           << "Unexpectedly big size for IPFIX_SAMPLING_PACKET_INTERVAL: " << elem.record_length;
+                }
+
+                ipfix_too_large_field++;
             }
         } else if (elem.record_type == IPFIX_SAMPLING_PACKET_SPACE) {
-            uint32_t sampling_packet_space = 0;
-
             // RFC requires this field to be 4 byte long
             if (elem.record_length == 4) {
                 memcpy(&sampling_packet_space, data_shift, elem.record_length);
 
                 sampling_packet_space = fast_ntoh(sampling_packet_space);
             } else {
-                logger << log4cpp::Priority::DEBUG << "Unexpected size for IPFIX_SAMPLING_PACKET_SPACE: " << elem.record_length;
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Unexpected size for IPFIX_SAMPLING_PACKET_SPACE: " << elem.record_length;
+                }
+
+                ipfix_too_large_field++;
+
+                // We're OK to continue process, we should not stop it
+            }
+
+        } else if (elem.record_type == IPFIX_SAMPLING_SELECTOR_ALGORITHM) {
+            // RFC requires this field to be 2 byte long
+            // You can find all possible values for it here: https://www.iana.org/assignments/psamp-parameters/psamp-parameters.xhtml
+            if (elem.record_length == 2) {
+                memcpy(&sampling_selector_algorithm, data_shift, elem.record_length);
+
+                sampling_selector_algorithm = fast_ntoh(sampling_selector_algorithm);
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Decoded sampling selector algorithm " << sampling_selector_algorithm;
+                }
+            } else {
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG
+                           << "Unexpected size for IPFIX_SAMPLING_SELECTOR_ALGORITM: " << elem.record_length;
+                }
+
                 ipfix_too_large_field++;
 
                 // We're OK to continue process, we should not stop it
@@ -754,8 +1061,15 @@ bool ipfix_options_flowset_to_store(cons
 
                 ipfix_active_flow_timeout_received++;
                 device_timeouts.active_timeout = active_timeout;
-                // logger << log4cpp::Priority::DEBUG << "Got active timeout: " << active_timeout << " seconds";
+                
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Got active timeout: " << active_timeout << " seconds";
+                }
             } else {
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Unexpected size for IPFIX_ACTIVE_TIMEOUT: " << elem.record_length;
+                }
+
                 ipfix_too_large_field++;
             }
 
@@ -769,8 +1083,15 @@ bool ipfix_options_flowset_to_store(cons
 
                 ipfix_inactive_flow_timeout_received++;
                 device_timeouts.inactive_timeout = inactive_timeout;
-                // logger << log4cpp::Priority::DEBUG << "Got inactive timeout: " << inactive_timeout << " seconds";
+                
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Got inactive timeout: " << inactive_timeout << " seconds";
+                }
             } else {
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Unexpected size for IPFIX_INACTIVE_TIMEOUT: " << elem.record_length;
+                }
+
                 ipfix_too_large_field++;
             }
         }
@@ -778,6 +1099,35 @@ bool ipfix_options_flowset_to_store(cons
         offset += elem.record_length;
     }
 
+    // Additional logic to deal with systematic count-based Sampling Selector on Nokia Nokia 7750 SR
+    // https://www.rfc-editor.org/rfc/rfc5476.html#section-6.5.2.1
+    // We check that sampler selected non zero number of packets as additional sanity check that we deal with this
+    // specific type of sampler and to avoid division by zero
+    if (sampling_selector_algorithm == IPFIX_SAMPLER_TYPE_SYSTEMATIC_COUNT_BASED_SAMPLING && sampling_packet_interval != 0) {
+        // We have seen following cases from Nokia:
+        // Packet space: 999 packet interval 1
+        // Packet space: 9999 packet interval 1
+        //
+        // Packet interval is the number of packets selected from whole packet space
+        //
+
+        //
+        // We never seen packet interval which is not set to 1 but I prefer to cover this case too
+        // For values of  packet interval after 1 we need to divide whole amount of observed packets
+        // (sampling_packet_space + sampling_packet_interval) by number of selected packets
+        //
+        uint32_t systematic_count_based_sampling_rate =
+            uint32_t(double(sampling_packet_space + sampling_packet_interval) / double(sampling_packet_interval));
+
+        // Update sampling rate
+        sampling_rate = fast_hton(systematic_count_based_sampling_rate);
+
+        if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+            logger << log4cpp::Priority::DEBUG << "Packet space: " << sampling_packet_space << " packet interval "
+                   << sampling_packet_interval << " sampling " << systematic_count_based_sampling_rate;
+        }
+    }
+
     update_ipfix_sampling_rate(sampling_rate, client_addres_in_string_format);
 
     // Update flow timeouts in our store
@@ -848,28 +1198,61 @@ bool ipfix_flowset_to_store(const uint8_
 
             if (*field_length_ptr == 0) {
                 logger << log4cpp::Priority::ERROR << "Zero length variable fields are not supported";
+                ipfix_inline_encoding_error++;
                 return false;
             }
 
             if (*field_length_ptr == 255) {
-                logger << log4cpp::Priority::ERROR << "Packet headers longer then 255 bytes are not supported, please reduce header length on device";
-                return false;
-            }
+                // 255 is special and it means that packet length is encoded in two following bytes
+                // Juniper PTX routers use this encoding even in case when packet length does not exceed 255 bytes
+
+                // RFC reference https://datatracker.ietf.org/doc/html/rfc7011#page-37
+                // In this case, the first octet of the
+                // Length field MUST be 255, and the length is carried in the second and
+                // third octets, as shown in Figure S.
+
+                // Read 2 byte length by skipping placeholder byte with 255
+                const uint16_t* two_byte_field_length_ptr = (const uint16_t*)(pkt + offset + sizeof(uint8_t));
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Two byte variable length encoding detected. Retrieved packet length: "
+                        << fast_ntoh(*two_byte_field_length_ptr);
+                }
 
-            // Override field length with length extracted from leading byte
-            record_length = *field_length_ptr + sizeof(uint8_t);
+                // Pass variable payload length 
+                flow_meta.variable_field_length = fast_ntoh(*two_byte_field_length_ptr);
+
+                // Override field length with length extracted from two bytes + length of placeholder byte itself
+                record_length = flow_meta.variable_field_length + sizeof(uint8_t) + sizeof(uint16_t);;
+
+                // Pass variable payload length
+                flow_meta.variable_field_length = fast_ntoh(*two_byte_field_length_ptr);
+
+                // Specify length encoding type as it's required for payload retrieval process
+                flow_meta.variable_field_length_encoding = variable_length_encoding_t::two_byte;
+            } else {
+                // Pass variable payload length
+                flow_meta.variable_field_length = *field_length_ptr;
+
+                // Override field length with length extracted from leading byte
+                record_length = flow_meta.variable_field_length + sizeof(uint8_t);
+
+                // Specify length encoding type as it's required for payload retrieval process
+                flow_meta.variable_field_length_encoding = variable_length_encoding_t::single_byte;
+            }
         }
 
         // We do not need this check when we have only fixed length fields in template
         // but this function is versatile and must handle all cases.
         if (offset + record_length > flowset_maximum_length) {
-            logger << log4cpp::Priority::ERROR << "Attempt to read data after end of flowset";
+            logger << log4cpp::Priority::ERROR << "Attempt to read data after end of flowset. Offset: " << offset
+                << " record length: " << record_length << " flowset_maximum_length: " << flowset_maximum_length;
             return false;
         }
 
         bool ipfix_record_to_flow_result = ipfix_record_to_flow(record_type, record_length, pkt + offset, packet, flow_meta);
 
-        // In case of serious errors we stop loop completely:w
+        // In case of serious errors we stop loop completely
         if (!ipfix_record_to_flow_result) {
             return false;
         }
@@ -883,38 +1266,38 @@ bool ipfix_flowset_to_store(const uint8_
         override_packet_fields_from_nested_packet(packet, flow_meta.nested_packet);
     }
 
-    bool netflow_mark_zero_next_hop_and_zero_output_as_dropped = false;
 
-    if (netflow_mark_zero_next_hop_and_zero_output_as_dropped) {
+    if (false) {
         //
         // For Juniper routers we need fancy logic to mark packets as dropped as it does not use RFC compliant IPFIX field for it
         //
 
         //
-        // The only reliable information we have from Juniper documentation is about Netflow v9 
+        // The only reliable information we have from Juniper documentation is about Netflow v9
         // https://apps.juniper.net/feature-explorer/feature-info.html?fKey=7679&fn=Enhancements%20to%20inline%20flow%20monitoring
-        // and we have no idea how it behaves in IPFIX mode. 
-        // 
-        // I think previously we had Juniper routers which set output interface to zero and both bgp_next_hop_ipv4 and ip_next_hop_ipv4 to zero values to report
-        // dropped and we checked only bgp_next_hop_ipv4 to identify dropped traffic. It worked well enough until we got flows explained below where 
-        // bgp_next_hop_ipv4 is not 0.0.0.0 but ip_next_hop_ipv4 and output interface were set to zeroes.
-        //
-        // In May 2023 got dumps in Google drive "MX10003 and MX 480 dropped traffic" which confirms that Juniper MX 10003 / MX480 with JUNOS 20.4R3-S4.8 encode
-        // it using zero output interface and zero ip_next_hop_ipv4. In same time these dumps have bgp_next_hop_ipv4 set to real non zero value of next router.
-        // To address this issue we added alternative section to check for zeroe 
+        // and we have no idea how it behaves in IPFIX mode.
+        //
+        // I think previously we had Juniper routers which set output interface to zero and both bgp_next_hop_ipv4 and
+        // ip_next_hop_ipv4 to zero values to report dropped and we checked only bgp_next_hop_ipv4 to identify dropped
+        // traffic. It worked well enough until we got flows explained below where bgp_next_hop_ipv4 is not 0.0.0.0 but
+        // ip_next_hop_ipv4 and output interface were set to zeroes.
+        //
+        // In May 2023 got dumps in Google drive "MX10003 and MX 480 dropped traffic" which confirms that Juniper MX
+        // 10003 / MX480 with JUNOS 20.4R3-S4.8 encode it using zero output interface and zero ip_next_hop_ipv4. In same
+        // time these dumps have bgp_next_hop_ipv4 set to real non zero value of next router. To address this issue we
+        // added alternative section to check for zeroe
         //
         // I posted question on LinkedIN: https://www.linkedin.com/feed/update/urn:li:activity:7062447441895141376/
         //
-            
+
         // We will apply it only if we have no forwarding_status in packet
         if (!flow_meta.received_forwarding_status) {
             // We need to confirm that TWO rules are TRUE:
             // - Output interface is 0
             // - Next hop for IPv4 is set and set to 0 OR next hop for IPv6 set and set to zero
             if (packet.output_interface == 0 &&
-                (
-                 (flow_meta.bgp_next_hop_ipv4_set && flow_meta.bgp_next_hop_ipv4 == 0) ||
-                 (flow_meta.ip_next_hop_ipv4_set  && flow_meta.ip_next_hop_ipv4 == 0 ) ||
+                ((flow_meta.bgp_next_hop_ipv4_set && flow_meta.bgp_next_hop_ipv4 == 0) ||
+                 (flow_meta.ip_next_hop_ipv4_set && flow_meta.ip_next_hop_ipv4 == 0) ||
                  (is_zero_ipv6_address(flow_meta.bgp_next_hop_ipv6) && flow_meta.bgp_next_hop_ipv6_set))) {
 
                 packet.forwarding_status = forwarding_status_t::dropped;
@@ -979,7 +1362,6 @@ bool ipfix_flowset_to_store(const uint8_
         packet.destination_port = 0;
     }
 
-
     // pass data to FastNetMon
     netflow_process_func_ptr(packet);
     return true;
@@ -987,7 +1369,19 @@ bool ipfix_flowset_to_store(const uint8_
 
 // That's kind of histogram emulation
 void increment_duration_counters_ipfix(int64_t duration) {
-    if (duration <= 15) {
+    if (duration == 0) {
+        ipfix_duration_0_seconds++;
+    } else if (duration <= 1) {
+        ipfix_duration_less_1_seconds++;
+    } else if (duration <= 2) {
+        ipfix_duration_less_2_seconds++;
+    } else if (duration <= 3) {
+        ipfix_duration_less_3_seconds++;
+    } else if (duration <= 5) {
+        ipfix_duration_less_5_seconds++;
+    } else if (duration <= 10) {
+        ipfix_duration_less_10_seconds++;
+    } else if (duration <= 15) {
         ipfix_duration_less_15_seconds++;
     } else if (duration <= 30) {
         ipfix_duration_less_30_seconds++;
@@ -1004,7 +1398,6 @@ void increment_duration_counters_ipfix(i
     return;
 }
 
-
 bool process_ipfix_data(const uint8_t* pkt,
                         size_t flowset_length,
                         const ipfix_header_t* ipfix_header,
@@ -1025,8 +1418,8 @@ bool process_ipfix_data(const uint8_t* p
 
     uint32_t flowset_id = ntohs(flowset_header->header.flowset_id);
 
-    const template_t* field_template =
-        peer_find_template(global_ipfix_templates, source_id, flowset_id, client_addres_in_string_format);
+    const template_t* field_template = peer_find_template(global_ipfix_templates, global_ipfix_templates_mutex,
+                                                          source_id, flowset_id, client_addres_in_string_format);
 
     if (field_template == NULL) {
         ipfix_packets_with_unknown_templates++;
@@ -1056,8 +1449,9 @@ bool process_ipfix_data(const uint8_t* p
                 logger << log4cpp::Priority::DEBUG << "IPFIX variable field element was used";
             }
 
-            // This implementation is rather limited as we read only single flowset here
+            // TODO: This implementation is rather limited as we read only single flowset here
             // In many cases we use this stuff for IPFIX Inline monitoring and it uses just single flowset but it may change in future
+            // TODO: Juniper PTX uses multiple flowsets per packet
             ipfix_flowset_to_store(pkt + sizeof(ipfix_data_flowset_header_t), ipfix_header, current_flowset_length_no_header,
                                    field_template, client_ipv4_address, client_addres_in_string_format);
         } else {
@@ -1069,6 +1463,19 @@ bool process_ipfix_data(const uint8_t* p
 
             uint32_t number_flowsets = (flowset_length - offset) / field_template->total_length;
 
+            // We need to calculate padding value
+            // IPFIX RFC explains it following way:
+            // https://datatracker.ietf.org/doc/html/rfc7011?ref=pavel.network#section-3.3.1
+            uint32_t flowset_padding = (flowset_length - offset) % field_template->total_length;
+
+            // Very likely data will be aligned by 4 byte boundaries and will have padding 1, 2, 3 bytes
+            // To be on safe side we assume that padding may be up to 7 bytes to achieve 8 byte boundaries
+            // All other values may be sign of some kind of issues. For example, it may be template conflicts
+            // https://pavel.network/its-just-wrong-to-update-ipfix-templates/
+            if (flowset_padding > 7) {
+                ipfix_flowsets_with_anomaly_padding++;
+            }
+
             if (number_flowsets > 0x4000) {
                 logger << log4cpp::Priority::ERROR << "Very high number of IPFIX data flowsets " << number_flowsets
                        << " Agent: " << client_addres_in_string_format
@@ -1080,10 +1487,8 @@ bool process_ipfix_data(const uint8_t* p
             if (number_flowsets == 0) {
                 logger << log4cpp::Priority::ERROR << "Unexpected zero number of flowsets "
                        << " agent: " << client_addres_in_string_format
-                       << " flowset template length: " << field_template->total_length 
-                       << " flowset length " << flowset_length
-                       << " source_id " << source_id
-                       << " flowset_id: " << flowset_id;
+                       << " flowset template length: " << field_template->total_length << " flowset length "
+                       << flowset_length << " source_id " << source_id << " flowset_id: " << flowset_id;
 
                 return false;
             }
@@ -1115,7 +1520,6 @@ bool process_ipfix_data(const uint8_t* p
     return true;
 }
 
-
 // Process IPFIX packet
 bool process_ipfix_packet(const uint8_t* packet,
                           uint32_t udp_packet_length,
@@ -1232,7 +1636,6 @@ bool process_ipfix_packet(const uint8_t*
     return true;
 }
 
-
 void update_ipfix_sampling_rate(uint32_t sampling_rate, const std::string& client_addres_in_string_format) {
     if (sampling_rate == 0) {
         return;
@@ -1259,7 +1662,6 @@ void update_ipfix_sampling_rate(uint32_t
 
             logger << log4cpp::Priority::INFO << "Learnt new IPFIX sampling rate " << new_sampling_rate << " for "
                    << client_addres_in_string_format;
-
         } else {
             auto old_sampling_rate = known_sampling_rate->second;
 
@@ -1268,10 +1670,10 @@ void update_ipfix_sampling_rate(uint32_t
 
                 ipfix_sampling_rate_changes++;
 
-                logger << log4cpp::Priority::INFO << "Detected IPFIX sampling rate change from " << old_sampling_rate << " to "
-                       << new_sampling_rate << " for " << client_addres_in_string_format;
-
+                logger << log4cpp::Priority::INFO << "Detected IPFIX sampling rate change from " << old_sampling_rate
+                       << " to " << new_sampling_rate << " for " << client_addres_in_string_format;
             }
         }
     }
 }
+
diff -pruN 1.2.6-1/src/netflow_plugin/netflow_collector.cpp 1.2.7-1/src/netflow_plugin/netflow_collector.cpp
--- 1.2.6-1/src/netflow_plugin/netflow_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netflow_plugin/netflow_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -80,6 +80,10 @@ class device_timeouts_t {
     bool operator==(const device_timeouts_t& rhs) const = default;
 };
 
+// Variable encoding may be single or two byte and we need to distinguish them explicitly
+enum class variable_length_encoding_t { unknown, single_byte, two_byte };
+
+
 // IPFIX per device timeouts
 std::mutex ipfix_per_device_flow_timeouts_mutex;
 std::map<std::string, device_timeouts_t> ipfix_per_device_flow_timeouts;
@@ -153,6 +157,9 @@ uint64_t ipfix_total_flows         = 0;
 std::string ipfix_total_ipv4_flows_desc = "Total number of IPFIX IPv4 flows (multiple in each packet)";
 uint64_t ipfix_total_ipv4_flows         = 0;
 
+std::string ipfix_flowsets_with_anomaly_padding_desc = "IPFIX flowsets with anomaly padding more then 7 bytes";
+uint64_t ipfix_flowsets_with_anomaly_padding         = 0;
+
 std::string ipfix_active_flow_timeout_received_desc = "Total number of received active IPFIX flow timeouts";
 uint64_t ipfix_active_flow_timeout_received         = 0;
 
@@ -244,6 +251,24 @@ uint64_t netflow9_duration_less_180_seco
 std::string netflow9_duration_exceed_180_seconds_desc = "Netflow v9 flows with duration more then 180 seconds";
 uint64_t netflow9_duration_exceed_180_seconds         = 0;
 
+std::string ipfix_duration_0_seconds_desc = "IPFIX flows with duration 0 seconds";
+uint64_t ipfix_duration_0_seconds         = 0;
+
+std::string ipfix_duration_less_1_seconds_desc = "IPFIX flows with duration less then 1 seconds";
+uint64_t ipfix_duration_less_1_seconds         = 0;
+
+std::string ipfix_duration_less_2_seconds_desc = "IPFIX flows with duration less then 2 seconds";
+uint64_t ipfix_duration_less_2_seconds         = 0;
+
+std::string ipfix_duration_less_3_seconds_desc = "IPFIX flows with duration less then 3 seconds";
+uint64_t ipfix_duration_less_3_seconds         = 0;
+
+std::string ipfix_duration_less_5_seconds_desc = "IPFIX flows with duration less then 5 seconds";
+uint64_t ipfix_duration_less_5_seconds         = 0;
+
+std::string ipfix_duration_less_10_seconds_desc = "IPFIX flows with duration less then 10 seconds";
+uint64_t ipfix_duration_less_10_seconds         = 0;
+
 std::string ipfix_duration_less_15_seconds_desc = "IPFIX flows with duration less then 15 seconds";
 uint64_t ipfix_duration_less_15_seconds         = 0;
 
@@ -373,6 +398,9 @@ uint64_t netflow_v9_lite_headers
 std::string ipfix_inline_headers_desc = "Total number of headers in IPFIX received";
 uint64_t ipfix_inline_headers         = 0;
 
+std::string ipfix_inline_encoding_error_desc = "IPFIX inline encoding issues";
+uint64_t  ipfix_inline_encoding_error         = 0;
+
 std::string ipfix_packets_with_padding_desc = "Total number of IPFIX packets with padding";
 uint64_t ipfix_packets_with_padding         = 0;
 
@@ -387,7 +415,10 @@ uint64_t flowsets_per_packet_maximum_num
 // TODO: add per source uniq templates support
 process_packet_pointer netflow_process_func_ptr = NULL;
 
+std::mutex global_netflow9_templates_mutex;
 std::map<std::string, std::map<uint32_t, template_t>> global_netflow9_templates;
+
+std::mutex global_ipfix_templates_mutex;
 std::map<std::string, std::map<uint32_t, template_t>> global_ipfix_templates;
 
 std::vector<system_counter_t> get_netflow_stats() {
@@ -620,6 +651,7 @@ std::string get_netflow_protocol_version
 /* Prototypes */
 void add_update_peer_template(const netflow_protocol_version_t& netflow_version,
                               std::map<std::string, std::map<uint32_t, template_t>>& table_for_add,
+                              std::mutex& table_for_add_mutex,
                               uint32_t source_id,
                               uint32_t template_id,
                               const std::string& client_addres_in_string_format,
@@ -679,6 +711,11 @@ class netflow_meta_info_t {
 
     // Cisco ASA flow identifier
     uint64_t flow_id = 0;
+
+    variable_length_encoding_t variable_field_length_encoding = variable_length_encoding_t::unknown;
+
+    // Store variable field length here to avoid repeating parsing
+    uint16_t variable_field_length = 0;
 };
 
 int nf9_rec_to_flow(uint32_t record_type,
@@ -689,6 +726,7 @@ int nf9_rec_to_flow(uint32_t record_type
                     netflow_meta_info_t& flow_meta);
 
 template_t* peer_find_template(std::map<std::string, std::map<uint32_t, template_t>>& table_for_lookup,
+                                      std::mutex& table_for_lookup_mutex,
                                       uint32_t source_id,
                                       uint32_t template_id,
                                       std::string client_addres_in_string_format) {
@@ -696,6 +734,8 @@ template_t* peer_find_template(std::map<
     // We use source_id for distinguish multiple netflow agents with same IP
     std::string key = client_addres_in_string_format + "_" + std::to_string(source_id);
 
+    std::lock_guard<std::mutex> lock(table_for_lookup_mutex);
+
     auto itr = table_for_lookup.find(key);
 
     if (itr == table_for_lookup.end()) {
@@ -744,6 +784,7 @@ void override_packet_fields_from_nested_
 void add_update_peer_template(
                               const netflow_protocol_version_t& netflow_protocol_version,
                               std::map<std::string, std::map<uint32_t, template_t>>& table_for_add,
+                              std::mutex& table_for_add_mutex,
                               uint32_t source_id,
                               uint32_t template_id,
                               const std::string& client_address_in_string_format,
@@ -759,6 +800,9 @@ void add_update_peer_template(
             << " source id: " << source_id;  
     }
 
+    // We need to put lock on it
+    std::lock_guard<std::mutex> lock(table_for_add_mutex);
+
     auto itr = table_for_add.find(key);
 
     if (itr == table_for_add.end()) {
diff -pruN 1.2.6-1/src/netflow_plugin/netflow_v9.hpp 1.2.7-1/src/netflow_plugin/netflow_v9.hpp
--- 1.2.6-1/src/netflow_plugin/netflow_v9.hpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netflow_plugin/netflow_v9.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -1,14 +1,11 @@
 // Netflow v9
 
-#include <cstdint>
-
 #include "../fast_endianless.hpp"
 
 #define NETFLOW9_TEMPLATE_FLOWSET_ID 0
 #define NETFLOW9_OPTIONS_FLOWSET_ID 1
 #define NETFLOW9_MIN_RECORD_FLOWSET_ID 256
 
-/* Flowset record types the we care about */
 #define NETFLOW9_IN_BYTES 1
 #define NETFLOW9_IN_PACKETS 2
 #define NETFLOW9_IN_PROTOCOL 4
@@ -63,6 +60,11 @@
 #define NETFLOW9_SAMPLER_NAME 84
 
 #define NETFLOW9_FORWARDING_STATUS 89
+
+// Legacy field. Recommended replacement is NETFLOW9_DATALINK_FRAME_SIZE
+// Cisco Catalyst 4500 uses this field with field NETFLOW9_LAYER2_PACKET_SECTION_DATA to deliver Netflow v9 lite
+#define NETFLOW9_LAYER2_PACKET_SECTION_SIZE 103
+
 #define NETFLOW9_LAYER2_PACKET_SECTION_DATA 104
 
 #define NETFLOW9_FLOW_ID 148
@@ -83,17 +85,6 @@
 #define NETFLOW9_SELECTOR_TOTAL_PACKETS_OBSERVED 318
 #define NETFLOW9_SELECTOR_TOTAL_PACKETS_SELECTED 319
 
-
-// TODO: we need to move away from this logic
-
-// According to spec it should be 4 bytes:
-// http://www.cisco.com/en/US/technologies/tk648/tk362/technologies_white_paper09186a00800a3db9.html
-#define NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL_LENGTH 4
-
-// But in real world I saw this one for Cisco ASR1000
-#define NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL_LENGTH_ASR1000 2
-
-
 class __attribute__((__packed__)) netflow9_header_common_t {
     public:
     uint16_t version        = 0;
@@ -164,4 +155,3 @@ class __attribute__((__packed__)) netflo
     public:
     uint8_t reason_code : 6, status : 2;
 };
-
diff -pruN 1.2.6-1/src/netflow_plugin/netflow_v9_collector.cpp 1.2.7-1/src/netflow_plugin/netflow_v9_collector.cpp
--- 1.2.6-1/src/netflow_plugin/netflow_v9_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netflow_plugin/netflow_v9_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -1,4 +1,7 @@
-void update_netflow_v9_sampling_rate(uint32_t sampling_rate, const std::string& client_addres_in_string_format);
+// That's not a module as we do refactoring right now in small steps
+// TODO: place make it proper module
+
+void update_netflow_v9_sampling_rate(uint32_t new_sampling_rate, const std::string& client_addres_in_string_format);
 
 // This function reads all available options templates
 // http://www.cisco.com/en/US/technologies/tk648/tk362/technologies_white_paper09186a00800a3db9.html
@@ -82,11 +85,11 @@ bool process_netflow_v9_options_template
 
     template_t field_template{};
 
-    field_template.template_id  = template_id;
-    field_template.records      = template_records_map;
-    field_template.num_records  = records_number;
-    field_template.total_length = total_size + scopes_total_size;
-    field_template.type         = netflow_template_type_t::Options;
+    field_template.template_id         = template_id;
+    field_template.records             = template_records_map;
+    field_template.num_records         = records_number;
+    field_template.total_length        = total_size + scopes_total_size;
+    field_template.type                = netflow_template_type_t::Options;
     field_template.option_scope_length = scopes_total_size;
 
     // We need to know when we received it
@@ -98,9 +101,14 @@ bool process_netflow_v9_options_template
     bool updated                   = false;
     bool updated_existing_template = false;
 
-    add_update_peer_template(netflow_protocol_version_t::netflow_v9, global_netflow9_templates, source_id, template_id, client_addres_in_string_format,
+    add_update_peer_template(netflow_protocol_version_t::netflow_v9, global_netflow9_templates,
+                             global_netflow9_templates_mutex, source_id, template_id, client_addres_in_string_format,
                              field_template, updated, updated_existing_template);
 
+    // This code is not perfect from locks perspective as we read global_netflow9_templates without any locks below
+
+    // NB! Please be careful with changing name of variable as it's part of serialisation protocol
+
     if (updated_existing_template) {
         netflow_v9_template_data_updates++;
     }
@@ -190,12 +198,9 @@ bool process_netflow_v9_template(const u
         bool updated                   = false;
         bool updated_existing_template = false;
 
-        add_update_peer_template(netflow_protocol_version_t::netflow_v9, global_netflow9_templates, source_id, template_id, client_addres_in_string_format,
-                                 field_template, updated, updated_existing_template);
-
-        // If we have any changes for this template, let's flush them to disk
-        if (updated) {
-        }
+        add_update_peer_template(netflow_protocol_version_t::netflow_v9, global_netflow9_templates,
+                                 global_netflow9_templates_mutex, source_id, template_id,
+                                 client_addres_in_string_format, field_template, updated, updated_existing_template);
 
         if (updated_existing_template) {
             netflow_v9_template_data_updates++;
@@ -210,7 +215,12 @@ bool process_netflow_v9_template(const u
     return true;
 }
 
-bool netflow9_record_to_flow(uint32_t record_type, uint32_t record_length, const uint8_t* data, simple_packet_t& packet, netflow_meta_info_t& flow_meta, const std::string& client_addres_in_string_format) {
+bool netflow9_record_to_flow(uint32_t record_type,
+                             uint32_t record_length,
+                             const uint8_t* data,
+                             simple_packet_t& packet,
+                             netflow_meta_info_t& flow_meta,
+                             const std::string& client_addres_in_string_format) {
     // Some devices such as Mikrotik may pass sampling rate in data section
     uint32_t sampling_rate = 0;
 
@@ -592,10 +602,23 @@ bool netflow9_record_to_flow(uint32_t re
         }
 
         break;
+    case NETFLOW9_LAYER2_PACKET_SECTION_SIZE:
+        if (record_length == 2) { 
+            uint16_t datalink_frame_size = 0; 
+
+            memcpy(&datalink_frame_size, data, record_length);
+            flow_meta.data_link_frame_size = fast_ntoh(datalink_frame_size);
+        } else {
+            netflow_v9_too_large_field++;
+
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_LAYER2_PACKET_SECTION_SIZE";
+            }
+        }
+
+        break;
     case NETFLOW9_LAYER2_PACKET_SECTION_DATA:
-        // We create block here as gcc does not want to compile without it with error: error: jump to case label
-        // https://stackoverflow.com/questions/5685471/error-jump-to-case-label-in-switch-statement
-        {
+        if (true) {
             netflow_v9_lite_headers++;
 
             bool read_packet_length_from_ip_header = true;
@@ -610,13 +633,17 @@ bool netflow9_record_to_flow(uint32_t re
 
             bool extract_tunnel_traffic = false;
 
-            auto result =
-                parse_raw_packet_to_simple_packet_full_ng((u_char*)(data), full_packet_length, record_length,
-                                                       flow_meta.nested_packet, extract_tunnel_traffic, read_packet_length_from_ip_header);
+            auto result = parse_raw_packet_to_simple_packet_full_ng((u_char*)(data), full_packet_length, record_length,
+                                                                    flow_meta.nested_packet, extract_tunnel_traffic,
+                                                                    read_packet_length_from_ip_header);
 
             if (result != network_data_stuctures::parser_code_t::success) {
                 // Cannot decode data
                 netflow_v9_lite_header_parser_error++;
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Cannot parse packet header with error: " << network_data_stuctures::parser_code_to_string(result); 
+                }
             } else {
                 netflow_v9_lite_header_parser_success++;
                 // Successfully decoded data
@@ -648,11 +675,11 @@ bool netflow9_record_to_flow(uint32_t re
         }
 
         break;
-    
+
     // There is a similar field NETFLOW9_BGP_NEXT_HOP_IPV4_ADDRESS but with slightly different meaning
     // https://www.cisco.com/en/US/technologies/tk648/tk362/technologies_white_paper09186a00800a3db9.html
     case NETFLOW9_BGP_NEXT_HOP_IPV4_ADDRESS:
-        
+
         if (record_length == 4) {
             uint32_t bgp_next_hop_ipv4 = 0;
             memcpy(&bgp_next_hop_ipv4, data, record_length);
@@ -738,10 +765,10 @@ bool netflow9_record_to_flow(uint32_t re
     case NETFLOW9_BYTES_FROM_DESTINATION_TO_SOURCE:
         if (record_length == 2) {
             uint16_t bytes_counter = 0;
-            
+
             memcpy(&bytes_counter, data, record_length);
-            bytes_counter        = fast_ntoh(bytes_counter);
-            
+            bytes_counter = fast_ntoh(bytes_counter);
+
             flow_meta.bytes_from_destination_to_source = bytes_counter;
         } else if (record_length == 4) {
             uint32_t bytes_counter = 0;
@@ -838,34 +865,36 @@ bool netflow9_record_to_flow(uint32_t re
             }
         }
         break;
-    case NETFLOW9_SAMPLING_INTERVAL: 
-        // Well, this record type is expected to be only in options templates but Mikrotik in RouterOS v6.49.6 has another opinion
-        // and we have dump which clearly confirms that they send this data in data templates
+    case NETFLOW9_SAMPLING_INTERVAL:
+        // Well, this record type is expected to be only in options templates but Mikrotik in RouterOS v6.49.6 has
+        // another opinion and we have dump which clearly confirms that they send this data in data templates
 
         if (record_length == 4) {
             uint32_t current_sampling_rate = 0;
 
             memcpy(&current_sampling_rate, data, record_length);
 
-            // NB! Our sampling rate update logic uses endian-less conversion directly in update_netflow_v9_sampling_rate / update_ipfix_sampling_rate 
-            // and we should not convert this value to little endian here
+            current_sampling_rate = fast_ntoh(current_sampling_rate);
+
+            // Pass it to global variable
+            sampling_rate = current_sampling_rate;
 
-            // We do convert it to little endian only for pretty printing
-            // logger << log4cpp::Priority::INFO << "Got sampling date from data packet: " << fast_ntoh(current_sampling_rate);
-            
-            // That's where Mikrotik quirks start 
+            // As we have it in data section it may overflow logs but that's best we can do and I think we need to have such information
+            if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                logger << log4cpp::Priority::DEBUG << "Got sampling date from data packet: " << current_sampling_rate;
+            }
+
+            //
+            // That's where Mikrotik quirks start
             // From Mikrotik routers with no sampling configured we receive 0 in this field which is not perfect but reasonable enough.
-            // 
+            //
             // Another issue that we receive values like: 16777216 which is just 1 wrongly encoded in host byte order in their data
-            // Should I mention that in this case router had following setup: packet-sampling=yes sampling-interval=2222 sampling-space=1111 
+            // Should I mention that in this case router had following setup: packet-sampling=yes sampling-interval=2222 sampling-space=1111
             // And I have no idea what is the source of "1" as sampling rate
             // It's so broken that we agreed to suspend implementation until they fix it
             //
             // Fortunately in ROS7.10 it works just fine
             //
-
-            // Pass it to global variable
-            sampling_rate = current_sampling_rate;
         } else {
             netflow_v9_too_large_field++;
 
@@ -877,13 +906,11 @@ bool netflow9_record_to_flow(uint32_t re
         break;
     }
 
-    bool netflow_v9_read_sampling_rate_in_data_section = false;
-
-    // We keep this logic under the fence flag because RouterOS v6 sampling implementation is exceptionally broken and enabling it by default will
-    // not make any good
-    if (netflow_v9_read_sampling_rate_in_data_section) {
-        // TODO: another issue with this logic that we will run it for each flow in packet which may cause additional overhead during processing
-        // It's not significant and we will keep it that way for now
+    // We keep this logic under the fence flag because RouterOS v6 sampling implementation is exceptionally broken and
+    // enabling it by default will not make any good
+    if (false) {
+        // TODO: another issue with this logic that we will run it for each flow in packet which may cause additional
+        // overhead during processing It's not significant and we will keep it that way for now
         update_netflow_v9_sampling_rate(sampling_rate, client_addres_in_string_format);
     }
 
@@ -916,39 +943,82 @@ void netflow9_options_flowset_to_store(c
         // Time to extract sampling rate
         // Cisco ASR1000
         if (elem.record_type == NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL) {
-            // Check supported length
-            if (elem.record_length == NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL_LENGTH or
-                elem.record_length == NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL_LENGTH_ASR1000) {
-                bool result = be_copy_function(data_shift, (uint8_t*)&sampling_rate, sizeof(sampling_rate), elem.record_length);
-
-                if (!result) {
-                    logger << log4cpp::Priority::ERROR
-                           << "Tool tried to read outside allowed memory region, prevented "
-                              "fault: FLOW_SAMPLER_RANDOM_INTERVAL";
+            // According to spec it should be 4 bytes: http://www.cisco.com/en/US/technologies/tk648/tk362/technologies_white_paper09186a00800a3db9.html
+            // but in real world we saw 2 byte encoding for Cisco ASR1000
+            if (elem.record_length == 2) {
+                uint16_t current_sampling_rate = 0;
+                memcpy(&current_sampling_rate, data_shift, elem.record_length);
+
+                // Convert 2 byte representation to little endian byte order
+                current_sampling_rate = fast_ntoh(current_sampling_rate);
+
+                sampling_rate = current_sampling_rate;
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG
+                           << "2 byte encoded NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL sampling rate: " << sampling_rate
+                           << " from " << client_addres_in_string_format;
                 }
+            } else if (elem.record_length == 4) {
+                uint32_t current_sampling_rate = 0;
+                memcpy(&current_sampling_rate, data_shift, elem.record_length);
+
+                // Convert 4 byte representation to little endian byte order
+                current_sampling_rate = fast_ntoh(current_sampling_rate);
 
-                // logger << log4cpp::Priority::ERROR << "sampling rate: " << fast_ntoh(sampling_rate);
+                sampling_rate = current_sampling_rate;
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG
+                           << "4 byte encoded NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL sampling rate: " << sampling_rate
+                           << " from " << client_addres_in_string_format;
+                }
             } else {
-                logger << log4cpp::Priority::ERROR << "Incorrect length for FLOW_SAMPLER_RANDOM_INTERVAL: " << elem.record_length;
+                netflow_v9_too_large_field++;
+                logger << log4cpp::Priority::ERROR
+                       << "Incorrect length for NETFLOW9_FLOW_SAMPLER_RANDOM_INTERVAL: " << elem.record_length;
             }
         } else if (elem.record_type == NETFLOW9_SAMPLING_INTERVAL) {
-            // Juniper MX
-            if (elem.record_length > sizeof(sampling_rate)) {
-                logger << log4cpp::Priority::ERROR << "Unexpectedly big size for NETFLOW9_SAMPLING_INTERVAL: " << elem.record_length;
-                continue;
-            }
+            // Juniper MX uses this type to encode sampling rate
+
+            if (elem.record_length == 2) {
+                uint16_t current_sampling_rate = 0;
+                memcpy(&current_sampling_rate, data_shift, elem.record_length);
+
+                // Convert 2 byte representation to little endian byte order
+                current_sampling_rate = fast_ntoh(current_sampling_rate);
+
+                sampling_rate = current_sampling_rate;
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "2 byte encoded NETFLOW9_SAMPLING_INTERVAL sampling rate: " << sampling_rate
+                           << " from " << client_addres_in_string_format;
+                }
+            } else if (elem.record_length == 4) {
+                uint32_t current_sampling_rate = 0;
+                memcpy(&current_sampling_rate, data_shift, elem.record_length);
+
+                // Convert 4 byte representation to little endian byte order
+                current_sampling_rate = fast_ntoh(current_sampling_rate);
 
-            bool result = be_copy_function(data_shift, (uint8_t*)&sampling_rate, sizeof(sampling_rate), elem.record_length);
+                sampling_rate = current_sampling_rate;
 
-            if (!result) {
-                logger << log4cpp::Priority::ERROR << "Tool tried to read outside allowed memory region, prevented fault: NETFLOW9_SAMPLING_INTERVAL";
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "4 byte encoded NETFLOW9_SAMPLING_INTERVAL sampling rate: " << sampling_rate
+                           << " from " << client_addres_in_string_format;
+                }
+            } else {
+                netflow_v9_too_large_field++;
+                logger << log4cpp::Priority::ERROR << "Incorrect length for NETFLOW9_SAMPLING_INTERVAL: " << elem.record_length;
             }
         } else if (elem.record_type == NETFLOW9_INTERFACE_DESCRIPTION) {
             if (elem.record_length > 128) {
                 // Apply reasonable constraints on maximum interface description field
                 netflow_v9_too_large_field++;
 
-                // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INTERFACE_DESCRIPTION";
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INTERFACE_DESCRIPTION";
+                }
             } else {
                 // Find actual length of name ignoring zero characters
                 // In Cisco's encoding all empty symbols are zero bytes
@@ -964,7 +1034,9 @@ void netflow9_options_flowset_to_store(c
                     // It may mean that we have no null byte which terminates string
                     netflow_v9_too_large_field++;
 
-                    // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INTERFACE_DESCRIPTION";
+                    if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                        logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INTERFACE_DESCRIPTION";
+                    }
                 }
             }
         } else if (elem.record_type == NETFLOW9_INPUT_SNMP) {
@@ -984,7 +1056,9 @@ void netflow9_options_flowset_to_store(c
             } else {
                 netflow_v9_too_large_field++;
 
-                // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INPUT_SNMP";
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INPUT_SNMP";
+                }
             }
         } else if (elem.record_type == NETFLOW9_ACTIVE_TIMEOUT) {
             uint16_t active_timeout = 0;
@@ -996,11 +1070,16 @@ void netflow9_options_flowset_to_store(c
 
                 netflow_v9_active_flow_timeout_received++;
                 device_timeouts.active_timeout = active_timeout;
-                // logger << log4cpp::Priority::DEBUG << "Got active timeout: " << active_timeout << " seconds";
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Got active timeout: " << active_timeout << " seconds";
+                }
             } else {
                 netflow_v9_too_large_field++;
 
-                // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_ACTIVE_TIMEOUT";
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_ACTIVE_TIMEOUT";
+                }
             }
 
         } else if (elem.record_type == NETFLOW9_INACTIVE_TIMEOUT) {
@@ -1013,11 +1092,16 @@ void netflow9_options_flowset_to_store(c
 
                 netflow_v9_inactive_flow_timeout_received++;
                 device_timeouts.inactive_timeout = inactive_timeout;
-                // logger << log4cpp::Priority::DEBUG << "Got inactive timeout: " << inactive_timeout << " seconds";
+
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Got inactive timeout: " << inactive_timeout << " seconds";
+                }
             } else {
                 netflow_v9_too_large_field++;
 
-                // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INACTIVE_TIMEOUT";
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_INACTIVE_TIMEOUT";
+                }
             }
         } else if (elem.record_type == NETFLOW9_FLOW_SAMPLER_ID) {
             if (elem.record_length == 4) {
@@ -1027,7 +1111,9 @@ void netflow9_options_flowset_to_store(c
 
                 sampler_id = fast_ntoh(sampler_id);
 
-                // logger << log4cpp::Priority::DEBUG << "Got sampler id from options template: " << int(sampler_id);
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG << "Got sampler id from options template: " << int(sampler_id);
+                }
             } else if (elem.record_length == 2) {
                 uint16_t sampler_id = 0;
 
@@ -1039,16 +1125,23 @@ void netflow9_options_flowset_to_store(c
             } else {
                 netflow_v9_too_large_field++;
 
-                // logger << log4cpp::Priority::DEBUG << "Too large field for NETFLOW9_FLOW_SAMPLER_ID options: " << elem.record_length;
+                if (logger.getPriority() == log4cpp::Priority::DEBUG) {
+                    logger << log4cpp::Priority::DEBUG
+                           << "Too large field for NETFLOW9_FLOW_SAMPLER_ID options: " << elem.record_length;
+                }
             }
         }
 
-
-        // logger << log4cpp::Priority::ERROR << "Interface number: " << interface_id_to_name.interface_id << " name: '" << interface_id_to_name.interface_description << "'";
-
         offset += elem.record_length;
     }
 
+    // We print only non zero numbers to distinguish cases when we did not receive anything
+    if (logger.getPriority() == log4cpp::Priority::DEBUG && interface_id_to_name.interface_id != 0) {
+        logger << log4cpp::Priority::DEBUG << "Interface number: " << interface_id_to_name.interface_id << " on "
+               << client_addres_in_string_format << " name: '" << interface_id_to_name.interface_description << "'";
+    }
+
+
     update_netflow_v9_sampling_rate(sampling_rate, client_addres_in_string_format);
 
     // Update flow timeouts in our store
@@ -1056,14 +1149,12 @@ void netflow9_options_flowset_to_store(c
                                 client_addres_in_string_format, netflow_protocol_version_t::netflow_v9);
 }
 
-void update_netflow_v9_sampling_rate(uint32_t sampling_rate, const std::string& client_addres_in_string_format) {
-    if (sampling_rate == 0) {
+// Incoming sampling rate uses little endian
+void update_netflow_v9_sampling_rate(uint32_t new_sampling_rate, const std::string& client_addres_in_string_format) {
+    if (new_sampling_rate == 0) {
         return;
     }
 
-    // NB! Incoming sampling rate is big endian / network byte order
-    auto new_sampling_rate = fast_ntoh(sampling_rate);
-
     netflow9_custom_sampling_rate_received++;
 
     // logger<< log4cpp::Priority::INFO << "I extracted sampling rate: " << new_sampling_rate
@@ -1091,8 +1182,8 @@ void update_netflow_v9_sampling_rate(uin
 
                 netflow9_sampling_rate_changes++;
 
-                logger << log4cpp::Priority::INFO << "Detected sampling rate change from " << old_sampling_rate << " to "
-                       << new_sampling_rate << " for " << client_addres_in_string_format;
+                logger << log4cpp::Priority::INFO << "Detected sampling rate change from " << old_sampling_rate
+                       << " to " << new_sampling_rate << " for " << client_addres_in_string_format;
 
             }
         }
@@ -1130,7 +1221,6 @@ void increment_duration_counters_netflow
     return;
 }
 
-
 void netflow9_flowset_to_store(const uint8_t* pkt,
                                const netflow9_header_t* netflow9_header,
                                const std::vector<template_record_t>& template_records,
@@ -1178,7 +1268,8 @@ void netflow9_flowset_to_store(const uin
         uint32_t record_type   = iter->record_type;
         uint32_t record_length = iter->record_length;
 
-        bool netflow9_record_to_flow_result = netflow9_record_to_flow(record_type, record_length, pkt + offset, packet, flow_meta, client_addres_in_string_format);
+        bool netflow9_record_to_flow_result = netflow9_record_to_flow(record_type, record_length, pkt + offset, packet,
+                                                                      flow_meta, client_addres_in_string_format);
         // logger<< log4cpp::Priority::INFO<<"Read data with type: "<<record_type<<"
         // and
         // length:"<<record_length;
@@ -1215,9 +1306,7 @@ void netflow9_flowset_to_store(const uin
         }
     }
 
-    bool netflow_mark_zero_next_hop_and_zero_output_as_dropped = false;
-
-    if (netflow_mark_zero_next_hop_and_zero_output_as_dropped) {
+    if (false) {
         // For Juniper routers we need fancy logic to mark packets as dropped:
         // https://apps.juniper.net/feature-explorer/feature-info.html?fKey=7679&fn=Enhancements%20to%20inline%20flow%20monitoring
 
@@ -1365,8 +1454,8 @@ bool process_netflow_v9_data(const uint8
     // "<<flowset_id;
 
     // We should find template here
-    const template_t* field_template =
-        peer_find_template(global_netflow9_templates, source_id, flowset_id, client_addres_in_string_format);
+    const template_t* field_template = peer_find_template(global_netflow9_templates, global_netflow9_templates_mutex,
+                                                          source_id, flowset_id, client_addres_in_string_format);
 
     if (field_template == NULL) {
         netflow9_packets_with_unknown_templates++;
@@ -1422,6 +1511,7 @@ bool process_netflow_v9_data(const uint8
     return true;
 }
 
+
 bool process_netflow_packet_v9(const uint8_t* packet,
                                uint32_t packet_length,
                                const std::string& client_addres_in_string_format,
@@ -1527,4 +1617,3 @@ bool process_netflow_packet_v9(const uin
 
     return true;
 }
-
diff -pruN 1.2.6-1/src/netmap_plugin/netmap_collector.cpp 1.2.7-1/src/netmap_plugin/netmap_collector.cpp
--- 1.2.6-1/src/netmap_plugin/netmap_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/netmap_plugin/netmap_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -206,9 +206,7 @@ void receiver(std::string interface_for_
 
         logger.info("Start new netmap thread %d", i);
 
-        // Well, we have thread attributes from Boost 1.50
-
-#if defined(BOOST_THREAD_PLATFORM_PTHREAD) && BOOST_VERSION / 100 % 1000 >= 50 && !defined(__APPLE__) && defined(__GLIBC__)
+#if defined(BOOST_THREAD_PLATFORM_PTHREAD) && !defined(__APPLE__)
         /* Bind to certain core */
         boost::thread::attributes thread_attrs;
 
diff -pruN 1.2.6-1/src/network_data_structures.hpp 1.2.7-1/src/network_data_structures.hpp
--- 1.2.6-1/src/network_data_structures.hpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/network_data_structures.hpp	2024-07-01 20:01:34.000000000 +0000
@@ -33,7 +33,7 @@ namespace network_data_stuctures {
 
 // We are using this structure as pretty interface for IPv4 address bytes in host byte order (little  endian)
 class __attribute__((__packed__)) ipv4_octets_form_little_endian_t {
-public:
+    public:
     uint8_t fourth = 0;
     uint8_t third  = 0;
     uint8_t second = 0;
@@ -130,7 +130,7 @@ class __attribute__((__packed__)) mpls_l
     public:
     uint32_t label : 20 = 0, qos : 3 = 0, bottom_of_stack : 1 = 0, ttl : 8 = 0;
 
-    std::string print() {
+    std::string print() const {
         std::stringstream buffer;
 
         buffer << "label: " << uint32_t(label) << " "
@@ -145,7 +145,7 @@ class __attribute__((__packed__)) mpls_l
 static_assert(sizeof(mpls_label_t) == 4, "Bad size for mpls_label_t");
 
 // In this class we keep vlan id, priority and cfi
-class __attribute__((__packed__))  ethernet_vlan_metadata_t {
+class __attribute__((__packed__)) ethernet_vlan_metadata_t {
     public:
     uint16_t vlan_id : 12, cfi : 1, priority : 3;
 };
@@ -157,12 +157,11 @@ static_assert(sizeof(ethernet_vlan_metad
 class __attribute__((__packed__)) ethernet_vlan_header_t {
     // We must not access these fields directly as it requires explicit byte order conversion
     private:
-        uint16_t vlan_metadata_as_integer = 0;
-        uint16_t ethertype = 0;
+    uint16_t vlan_metadata_as_integer = 0;
+    uint16_t ethertype                = 0;
 
     // We can access data in packet only using special methods which can do all required format conversions
     public:
-
     // Returns ethertype in host byte order
     uint16_t get_ethertype_host_byte_order() const {
         return fast_ntoh(ethertype);
@@ -230,7 +229,7 @@ class __attribute__((__packed__)) ethern
 
     public:
     // Returns ethertype in host byte order
-    uint16_t get_ethertype_host_byte_order() {
+    uint16_t get_ethertype_host_byte_order() const {
         return fast_ntoh(ethertype);
     }
 
@@ -270,7 +269,6 @@ class __attribute__((__packed__)) arp_he
     uint32_t target_protocol_address = 0;
 
     public:
-
     uint8_t get_hardware_address_length() const {
         return hardware_address_length;
     }
@@ -310,9 +308,11 @@ class __attribute__((__packed__)) arp_he
                << "protocol_address_length: " << uint32_t(get_protocol_address_length()) << " "
                << "operation: " << get_operation_host_byte_order() << " "
                << "sender_hardware_address: " << convert_mac_to_string(sender_hardware_address) << " "
-               << "sender_protocol_address: " << convert_ip_as_big_endian_to_string(get_sender_protocol_address_network_byte_order()) << " "
+               << "sender_protocol_address: "
+               << convert_ip_as_big_endian_to_string(get_sender_protocol_address_network_byte_order()) << " "
                << "target_hardware_address: " << convert_mac_to_string(target_hardware_address) << " "
-               << "target_protocol_address: " << convert_ip_as_big_endian_to_string(get_target_protocol_address_network_byte_order());
+               << "target_protocol_address: "
+               << convert_ip_as_big_endian_to_string(get_target_protocol_address_network_byte_order());
 
         return buffer.str();
     }
@@ -364,15 +364,15 @@ class __attribute__((__packed__)) udp_he
     uint16_t get_source_port_host_byte_order() const {
         return fast_ntoh(source_port);
     }
-    
+
     uint16_t get_destination_port_host_byte_order() const {
         return fast_ntoh(destination_port);
     }
-    
+
     uint16_t get_length_host_byte_order() const {
         return fast_ntoh(length);
     }
-    
+
     uint16_t get_checksum_host_byte_order() const {
         return fast_ntoh(checksum);
     }
@@ -394,14 +394,13 @@ static_assert(sizeof(udp_header_t) == 8,
 // https://datatracker.ietf.org/doc/html/rfc2784
 class __attribute__((__packed__)) gre_header_t {
     // We must not access these fields directly as they may need conversion
-   private:
+    private:
     // TODO: we have no pcaps where these fields are no zeros and we did not test this case
     // For some reasons PVS thinks that we did not initialised all members. I think they're not that great with bitfields
     uint16_t checksum : 1 = 0, reserved : 12 = 0, version : 3 = 0; //-V730
     uint16_t protocol_type = 0;
 
     public:
-
     uint16_t get_protocol_type_host_byte_order() const {
         return fast_ntoh(protocol_type);
     }
@@ -413,7 +412,7 @@ class __attribute__((__packed__)) gre_he
     uint16_t get_checksum() const {
         return checksum;
     }
-    
+
     uint16_t get_version() const {
         return version;
     }
@@ -472,7 +471,6 @@ class __attribute__((__packed__)) croppe
     uint16_t destination_port = 0;
 
     public:
-
     uint16_t get_source_port_host_byte_order() const {
         return fast_ntoh(source_port);
     }
@@ -491,18 +489,16 @@ class __attribute__((__packed__)) tcp_he
     uint16_t destination_port = 0;
     uint32_t sequence_number  = 0;
     uint32_t ack_number       = 0;
-    
+
     // Flags here encoded as tcp_flags_t
     uint16_t data_offset_and_flags_as_integer = 0;
 
     private:
-
     uint16_t window_size = 0;
     uint16_t checksum    = 0;
     uint16_t urgent      = 0;
 
     public:
-
     uint16_t get_source_port_host_byte_order() const {
         return fast_ntoh(source_port);
     }
@@ -510,23 +506,23 @@ class __attribute__((__packed__)) tcp_he
     uint16_t get_destination_port_host_byte_order() const {
         return fast_ntoh(destination_port);
     }
-    
+
     uint32_t get_sequence_number_host_byte_order() const {
         return fast_ntoh(sequence_number);
     }
-    
+
     uint32_t get_ack_number_host_byte_order() const {
         return fast_ntoh(ack_number);
     }
-    
+
     uint16_t get_window_size_host_byte_order() const {
         return fast_ntoh(window_size);
     }
-    
+
     uint16_t get_checksum_host_byte_order() const {
         return fast_ntoh(checksum);
     }
-    
+
     uint16_t get_urgent_host_byte_order() const {
         return fast_ntoh(urgent);
     }
@@ -586,7 +582,7 @@ class __attribute__((__packed__)) tcp_he
         return tcp_flags->ack == 1;
     }
 
-    bool get_urg ()const  {
+    bool get_urg() const {
         uint16_t data_offset_and_flags_as_integer_litle_endian = fast_ntoh(data_offset_and_flags_as_integer);
 
         tcp_flags_t* tcp_flags = (tcp_flags_t*)&data_offset_and_flags_as_integer_litle_endian;
@@ -594,7 +590,7 @@ class __attribute__((__packed__)) tcp_he
         return tcp_flags->urg == 1;
     }
 
-    bool get_ece ()  const {
+    bool get_ece() const {
         uint16_t data_offset_and_flags_as_integer_litle_endian = fast_ntoh(data_offset_and_flags_as_integer);
 
         tcp_flags_t* tcp_flags = (tcp_flags_t*)&data_offset_and_flags_as_integer_litle_endian;
@@ -602,7 +598,7 @@ class __attribute__((__packed__)) tcp_he
         return tcp_flags->ece == 1;
     }
 
-    bool get_cwr () const {
+    bool get_cwr() const {
         uint16_t data_offset_and_flags_as_integer_litle_endian = fast_ntoh(data_offset_and_flags_as_integer);
 
         tcp_flags_t* tcp_flags = (tcp_flags_t*)&data_offset_and_flags_as_integer_litle_endian;
@@ -618,7 +614,7 @@ class __attribute__((__packed__)) tcp_he
         return tcp_flags->ns == 1;
     }
 
-    uint8_t get_reserved() const{
+    uint8_t get_reserved() const {
         uint16_t data_offset_and_flags_as_integer_litle_endian = fast_ntoh(data_offset_and_flags_as_integer);
 
         tcp_flags_t* tcp_flags = (tcp_flags_t*)&data_offset_and_flags_as_integer_litle_endian;
@@ -696,9 +692,9 @@ inline std::string convert_ipv6_in_byte_
 */
 
 class __attribute__((__packed__)) ipv6_fragment_header_flags {
-     public:
-        // fragment_offset is a number of 8byte chunk
-        uint16_t more_fragments : 1, reserved2 : 2, fragment_offset : 13;
+    public:
+    // fragment_offset is a number of 8byte chunk
+    uint16_t more_fragments : 1, reserved2 : 2, fragment_offset : 13;
 };
 
 static_assert(sizeof(ipv6_fragment_header_flags) == 2, "Bad size for ipv6_header_flags_t");
@@ -717,7 +713,6 @@ class __attribute__((__packed__)) ipv6_e
     uint32_t identification = 0;
 
     public:
-
     uint16_t get_more_fragments() const {
         uint16_t flags_little_endian = fast_ntoh(fragmentation_and_flags_as_integer);
 
@@ -787,7 +782,7 @@ static_assert(sizeof(ipv6_header_flags_t
 
 class __attribute__((__packed__)) ipv6_header_t {
     // We must not access these fields directly as they need decoding
-    private:    
+    private:
     // Multiple flags carried in ipv6_header_flags_t
     uint32_t version_and_traffic_class_as_integer = 0;
 
@@ -801,13 +796,13 @@ class __attribute__((__packed__)) ipv6_h
 
     uint32_t get_flow_label() const {
         uint32_t version_and_traffic_class_little_endian = fast_ntoh(version_and_traffic_class_as_integer);
-    
+
         ipv6_header_flags_t* header_flags = (ipv6_header_flags_t*)&version_and_traffic_class_little_endian;
 
         return header_flags->flow_label;
     }
 
-    uint32_t get_traffic_class() const { 
+    uint32_t get_traffic_class() const {
         uint32_t version_and_traffic_class_little_endian = fast_ntoh(version_and_traffic_class_as_integer);
 
         ipv6_header_flags_t* header_flags = (ipv6_header_flags_t*)&version_and_traffic_class_little_endian;
@@ -835,7 +830,7 @@ class __attribute__((__packed__)) ipv6_h
         return hop_limit;
     }
 
-    std::string print() const  {
+    std::string print() const {
         std::stringstream buffer;
 
         buffer << "version: " << get_version() << " "
@@ -856,8 +851,8 @@ static_assert(sizeof(ipv6_header_t) == 4
 // It's class for fragmentation flag representation. It's pretty useful in some cases
 class __attribute__((__packed__)) ipv4_header_fragmentation_flags_t {
     public:
-        // The offset value is the number of 8 byte blocks of data
-        uint16_t fragment_offset : 13, more_fragments_flag : 1, dont_fragment_flag : 1, reserved_flag : 1;
+    // The offset value is the number of 8 byte blocks of data
+    uint16_t fragment_offset : 13, more_fragments_flag : 1, dont_fragment_flag : 1, reserved_flag : 1;
 
     std::string print() {
 
@@ -876,7 +871,6 @@ static_assert(sizeof(ipv4_header_fragmen
 class __attribute__((__packed__)) ipv4_header_t {
     // We must not access these fields directly as they need conversion
     private:
-
     uint8_t ihl : 4 = 0, version : 4 = 0;
     uint8_t ecn : 2 = 0, dscp : 6 = 0;
 
@@ -887,16 +881,15 @@ class __attribute__((__packed__)) ipv4_h
     // There we have plenty of fragmentation specific fields encoded in ipv4_header_fragmentation_flags_t
     uint16_t fragmentation_details_as_integer = 0;
 
-    uint8_t ttl             = 0;
-    uint8_t protocol        = 0;
+    uint8_t ttl      = 0;
+    uint8_t protocol = 0;
 
-    uint16_t checksum       = 0;
+    uint16_t checksum = 0;
 
     uint32_t source_ip      = 0;
     uint32_t destination_ip = 0;
 
     public:
-
     ipv4_header_t()
     : ihl(0), version(0), ecn(0), dscp(0), total_length(0), identification(0), fragmentation_details_as_integer(0),
       ttl(0), protocol(0), checksum(0), source_ip(0), destination_ip(0) {
@@ -910,7 +903,7 @@ class __attribute__((__packed__)) ipv4_h
         return fast_ntoh(total_length);
     }
 
-    bool is_fragmented() {
+    bool is_fragmented() const {
         if (this->get_more_fragments_flag()) {
             return true;
         }
@@ -923,20 +916,20 @@ class __attribute__((__packed__)) ipv4_h
     }
 
     uint8_t get_ihl() const {
-    	return ihl;
-    }	
-     
+        return ihl;
+    }
+
     uint8_t get_version() const {
-    	return version; 
+        return version;
     }
-    
+
     uint8_t get_ecn() const {
-    	return ecn;
-    } 
-    
+        return ecn;
+    }
+
     uint8_t get_dscp() const {
-    	return dscp;
-    } 
+        return dscp;
+    }
 
     uint16_t get_fragmentation_details_host_byte_order() {
         return fast_ntoh(fragmentation_details_as_integer);
@@ -965,10 +958,10 @@ class __attribute__((__packed__)) ipv4_h
         uint16_t fragmenation_details_little_endian = fast_ntoh(fragmentation_details_as_integer);
 
         ipv4_header_fragmentation_flags_t* fragmentation_flags = (ipv4_header_fragmentation_flags_t*)&fragmenation_details_little_endian;
-    
+
         return fragmentation_flags->more_fragments_flag == 1;
     }
-     
+
     bool get_dont_fragment_flag() const {
         uint16_t fragmenation_details_little_endian = fast_ntoh(fragmentation_details_as_integer);
 
@@ -1009,7 +1002,7 @@ class __attribute__((__packed__)) ipv4_h
         fragmentation_details_as_integer = fast_hton(fragmenation_details_little_endian);
     }
 
-    // Value is a number of 8 byte blocks 
+    // Value is a number of 8 byte blocks
     void set_fragment_offset_8byte_chunks(uint16_t value) {
         uint16_t fragmenation_details_little_endian = fast_ntoh(fragmentation_details_as_integer);
 
@@ -1032,7 +1025,7 @@ class __attribute__((__packed__)) ipv4_h
     uint32_t get_source_ip_host_byte_order() const {
         return fast_ntoh(source_ip);
     }
-    
+
     uint32_t get_destination_ip_host_byte_order() const {
         return fast_ntoh(destination_ip);
     }
@@ -1082,7 +1075,8 @@ enum class parser_code_t {
     no_ipv6_support,
     no_ipv6_options_support,
     unknown_ethertype,
-    arp
+    arp,
+    too_many_nested_vlans,
 };
 
 std::string parser_code_to_string(parser_code_t code);
diff -pruN 1.2.6-1/src/notify_about_attack.sh 1.2.7-1/src/notify_about_attack.sh
--- 1.2.6-1/src/notify_about_attack.sh	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/notify_about_attack.sh	2024-07-01 20:01:34.000000000 +0000
@@ -11,7 +11,7 @@
 
 email_notify="please_fix_this_email@domain.com"
 
-# For ban and attack_details actions we will receive attack details to stdin
+# For ban action we will receive attack details to stdin
 # Please do not remove "cat" command because
 # FastNetMon will crash in this case as it expects read of data from script side
 #
@@ -19,7 +19,7 @@ email_notify="please_fix_this_email@doma
 if [ "$4" = "ban" ]; then
     # This action receives multiple statistics about attack's performance and attack's sample to stdin
 
-    cat | mail -s "FastNetMon Guard: IP $1 blocked because $2 attack with power $3 pps" $email_notify;
+    cat | mail -s "FastNetMon Community: IP $1 blocked because $2 attack with power $3 pps" $email_notify;
     
     # Please add actions to run when we ban host
     exit 0
diff -pruN 1.2.6-1/src/packaging/fedora/fastnetmon.service 1.2.7-1/src/packaging/fedora/fastnetmon.service
--- 1.2.6-1/src/packaging/fedora/fastnetmon.service	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/packaging/fedora/fastnetmon.service	2024-07-01 20:01:34.000000000 +0000
@@ -11,7 +11,7 @@ Group=fastnetmon
 Restart=on-failure
 RestartSec=3
 LimitNOFILE=65535
-# We need it to use AF_PACKET when run under non root user
+# We need it to use AF_PACKET and AF_XDP when run under non root user
 AmbientCapabilities=CAP_NET_RAW CAP_IPC_LOCK
 
 [Install]
diff -pruN 1.2.6-1/src/packaging/homebrew/fastnetmon.rb 1.2.7-1/src/packaging/homebrew/fastnetmon.rb
--- 1.2.6-1/src/packaging/homebrew/fastnetmon.rb	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/packaging/homebrew/fastnetmon.rb	2024-07-01 20:01:34.000000000 +0000
@@ -1,31 +1,31 @@
 class Fastnetmon < Formula
   desc "DDoS detection tool with sFlow, Netflow, IPFIX and port mirror support"
   homepage "https://github.com/pavel-odintsov/fastnetmon/"
-  # TODO: Check if we can use unversioned `grpc` at version bump
   license "GPL-2.0-only"
   head "https://github.com/pavel-odintsov/fastnetmon.git"
-  revision 3
+  revision 5
 
   bottle do
-    sha256 cellar: :any,                 arm64_ventura:  "81c83f3712b5a056ed190b0639225066fcf08b4c84e219df309f43e71f24f734"
-    sha256 cellar: :any,                 arm64_monterey: "fe4f2d1805139c1e7c0d2b5b4431870d55972ebd0412ae05e9b8f5ee12208ccc"
-    sha256 cellar: :any,                 arm64_big_sur:  "17800806bc4e52dbf11d661059495d5cfd7850ad1ad950eaed52b089cfcb3b84"
-    sha256 cellar: :any,                 ventura:        "1a108e5de92055568e1fe092a779bec815f08da43345e4db6a574e38e49ecdc8"
-    sha256 cellar: :any,                 monterey:       "393c75e0894d4804d5f8d08896e1022c6992a5d24679dc4aa6a5a45577e8246e"
-    sha256 cellar: :any,                 big_sur:        "c085f7a2d3a8d6e91d697de4afdc5268694448a8d7b05642f1b13815cdadbeb0"
-    sha256 cellar: :any_skip_relocation, x86_64_linux:   "f028e8ae77dec6ae789aa1ee6598cb38aa4cfa28f970f8287d6ed7eaab0c50c4"
+    sha256 cellar: :any,                 arm64_sonoma:   "e2224278e6a039eb8815b070dbec167059c97c45ce140d040e743933551f4aa6"
+    sha256 cellar: :any,                 arm64_ventura:  "867ad398c827b030e7a37c6ae7ec43424b5f39049712ad4e73ad9f34272af6d8"
+    sha256 cellar: :any,                 arm64_monterey: "289219de6117e93818efe215608ec63a581f65a844796296b8c8dcf7131e4282"
+    sha256 cellar: :any,                 sonoma:         "4e2b2eaae5b1208543fd6cba7d17319c61dca90694f353ae68271677da81b0a5"
+    sha256 cellar: :any,                 ventura:        "ca02b5e0eaf4c162a32529427ee82f9ce322dfd76f74da6da5f217ff3d0e733d"
+    sha256 cellar: :any,                 monterey:       "c69862f99e4e368ff2df5ffabdb74b04c415b8441f22ea7fdd2cb1bab24f1e57"
+    sha256 cellar: :any_skip_relocation, x86_64_linux:   "3e789634cedde18c8806a0d23a9469f72bc0f95da40f5e5556457f8a54425d9f"
   end
 
   depends_on "cmake" => :build
   depends_on "abseil"
   depends_on "boost"
   depends_on "capnp"
-  depends_on "grpc@1.54"
+  depends_on "grpc"
   depends_on "hiredis"
   depends_on "log4cpp"
   depends_on macos: :big_sur # We need C++ 20 available for build which is available from Big Sur
   depends_on "mongo-c-driver"
   depends_on "openssl@3"
+  depends_on "protobuf"
   uses_from_macos "ncurses"
 
   on_linux do
@@ -38,8 +38,6 @@ class Fastnetmon < Formula
 
   def install
     system "cmake", "-S", "src", "-B", "build",
-                    "-DENABLE_CUSTOM_BOOST_BUILD=FALSE",             # need to be removed in upstream as we do not need it
-                    "-DDO_NOT_USE_SYSTEM_LIBRARIES_FOR_BUILD=FALSE", # need to be removed in upstream as we do not need it
                     "-DLINK_WITH_ABSL=TRUE",
                     "-DSET_ABSOLUTE_INSTALL_PATH=OFF",
                     *std_cmake_args
@@ -52,8 +50,7 @@ class Fastnetmon < Formula
       opt_sbin/"fastnetmon",
       "--configuration_file",
       etc/"fastnetmon.conf",
-      "--log_to_console",
-      "--disable_pid_logic", # need to be removed in upstream as we do not need it
+      "--log_to_console"
     ]
     keep_alive false
     working_dir HOMEBREW_PREFIX
@@ -91,3 +88,4 @@ class Fastnetmon < Formula
     Process.kill "SIGTERM", fastnetmon_pid
   end
 end
+
diff -pruN 1.2.6-1/src/pcap_reader.cpp 1.2.7-1/src/pcap_reader.cpp
--- 1.2.6-1/src/pcap_reader.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/pcap_reader.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -63,7 +63,7 @@ void init_logging() {
 
     logger.setPriority(log4cpp::Priority::INFO);
     logger.addAppender(appender);
-    logger.info("Logger initialized!");
+    logger.info("Logger initialized");
 }
 
 void pcap_parse_packet(const char* flow_type, char* buffer, uint32_t len);
diff -pruN 1.2.6-1/src/plugin_runner.cpp 1.2.7-1/src/plugin_runner.cpp
--- 1.2.6-1/src/plugin_runner.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/plugin_runner.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -66,7 +66,7 @@ void init_logging() {
 
     logger.setPriority(log4cpp::Priority::INFO);
     logger.addAppender(appender);
-    logger.info("Logger initialized!");
+    logger.info("Logger initialized");
 }
 
 void process_packet(simple_packet& current_packet) {
diff -pruN 1.2.6-1/src/scripts/fastnetmon_notify.py 1.2.7-1/src/scripts/fastnetmon_notify.py
--- 1.2.6-1/src/scripts/fastnetmon_notify.py	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/scripts/fastnetmon_notify.py	2024-07-01 20:01:34.000000000 +0000
@@ -53,7 +53,7 @@ def mail(subject, body):
 
 
 if action == "unban":
-    subject = "Fastnetmon Guard: IP %(client_ip_as_string)s unblocked because %(data_direction)s attack with power %(pps_as_string)d pps" % {
+    subject = "FastNetMon Community: IP %(client_ip_as_string)s unblocked because %(data_direction)s attack with power %(pps_as_string)d pps" % {
         'client_ip_as_string': client_ip_as_string,
         'data_direction': data_direction,
         'pps_as_string' : pps_as_string,
@@ -63,7 +63,7 @@ if action == "unban":
     mail(subject, "unban")
     sys.exit(0)
 elif action == "ban":
-    subject = "Fastnetmon Guard: IP %(client_ip_as_string)s blocked because %(data_direction)s attack with power %(pps_as_string)d pps" % {
+    subject = "FastNetMon Community: IP %(client_ip_as_string)s blocked because %(data_direction)s attack with power %(pps_as_string)d pps" % {
         'client_ip_as_string': client_ip_as_string,
         'data_direction': data_direction,
         'pps_as_string' : pps_as_string,
@@ -74,18 +74,6 @@ elif action == "ban":
     mail(subject, body)
 
     sys.exit(0)
-elif action == "attack_details":
-    subject = "Fastnetmon Guard: IP %(client_ip_as_string)s blocked because %(data_direction)s attack with power %(pps_as_string)d pps" % {
-        'client_ip_as_string': client_ip_as_string,
-        'data_direction': data_direction,
-        'pps_as_string' : pps_as_string,
-        'action' : action
-    }
-    body = "".join(sys.stdin.readlines())
-
-
-    mail(subject, body)
-    sys.exit(0)
 else:
     sys.exit(0)
 
diff -pruN 1.2.6-1/src/scripts/install_fastnetmon_dependencies.pl 1.2.7-1/src/scripts/install_fastnetmon_dependencies.pl
--- 1.2.6-1/src/scripts/install_fastnetmon_dependencies.pl	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/scripts/install_fastnetmon_dependencies.pl	2024-07-01 20:01:34.000000000 +0000
@@ -96,8 +96,8 @@ sub main {
         
         # gRPC dependencies 
         're2_2022_12_01',
-        'abseil_2022_06_23',        
-        'zlib_1_2_13',,
+        'abseil_2024_01_16',        
+        'zlib_1_3_1',
         'cares_1_18_1',
 
         'protobuf_21_12',
@@ -109,6 +109,8 @@ sub main {
         'rdkafka_1_7_0',
         'cppkafka_0_3_1',
 
+        'clickhouse_2_3_0',
+
         'gobgp_3_12_0',
         'log4cpp_1_1_4',
         'gtest_1_13_0'
@@ -122,7 +124,8 @@ sub main {
     # To guarantee that binary dependencies are not altered in storage side we store their hashes in repository
     my $binary_build_hashes = { 
         'gcc_12_1_0' => {
-            'debian:9'            => '63995539b8fb75cc89cc7eb3a2b78aaf55a5083fb95bb2b5199b2f4545329789410c54f04f7449a2f96543f21d51977bdd2b9ede10c70f910459dae83b030212',
+	    'ubuntu:24.04' => '8fb7feef267313461fd21c1f9c2d397f82fb93969cd5f0d4a6f3d09cb7154d9a97252d612197b76dd20a8396ee6c0af990337a0449fef60bee304a21ab45d888',
+            'ubuntu:aarch64:24.04' => '4416ba59762859550b854b5c0ff0af65cc3e9bd78bda631068504b2535f10dbc85a401588d1653556117937a0c4d82bea491eb771d7d97a704a90f92bff091f0',
             'debian:10'           => '2c18964400a6660eae4ee36369c50829fda4ad4ee049c29aa1fd925bf96c3f8eed3ecb619cc02c6f470d0170d56aee1c840a4ca58d8132ca7ae395759aa49fc7',
             
             'debian:11'           => '3ad28bf950a7be070f1de9b3184f1fe9f42405cdbc0f980ab97e13d571a5be1441963a43304d784c135a43278454149039bd2a6252035c7755d4ba5e0eb41480',
@@ -149,6 +152,9 @@ sub main {
             'centos:aarch64:9'    => 'b8d18c9b682c91e1cebb0cf3b1efb2281c6bcea067261e63cff2dee076d4842db3cb213b8ef3d986e03491ddf38e59d4b7ccab5dbe9f82bb7e3d4ef9ddaa772a',
         },
         'openssl_1_1_1q'        => {
+	    'ubuntu:24.04' => '4359cad3dee0b022cb1949b425767e90cd2da09f9d9809e8ba2b0cf8866dab8bf1d3f74536f4b82bb0c3d691f11c1f78b6e9b5eb1fcf08cd02e14390c2a10ba4',
+
+            'ubuntu:aarch64:24.04'=> '6a504201bf3190597a5c923a73ec7e7a33093f622ee107905d3725a85b2ec0c8eba70994db0ad23b46fcb055847f28526e3e92aa777b36eabc1288186d6a9e44',
             'centos:7'            => 'ab9dde43afc7b6bcc4399b6fbd746727e0ce72cf254e9b7f6abcc5c22b319ab82c051546decc6804e508654975089888c544258514e30dc18385ad1dd59d63fb',
             
             'centos:8'            => 'c4c1fe35008606bc65bff4c125fae83738c397fb14081d59cb1e83ad5b8a69b9f80b7c91318c52613f00a7cf5b7a64dd6d23d2956c2ce083fc4c7502e81714cb',
@@ -157,7 +163,6 @@ sub main {
             'centos:9'            => '76d2be30ca3afdf3e603b7690a3e7a8bf8423d4b359d928ef45f7aa827dec6d12e47c1f995c945d419763820d566590945aadf7d3ba38344b8b5d184fcc9bffc',
             'centos:aarch64:9'    => 'ab23ef0ecf1abf7badff5ae759f264ca0bf1749813b6825fbb1875040de0559d1561a97c32abb21b546229d16d81bac186ac5c5738bc3a854f4b5873a77215f7',
 
-            'debian:9'            => 'd284915be431493b4c336d452478a28906a8268c4079fbb19c8851cf70a1a9eefe942a424e922caa4bc38eaf66b40a9971576a62ba0aebe7fd20d05b2bdeacf0',
             'debian:10'           => 'eac2b5a066386f7900b1e364b5347d87ab4a994a058ecfaf5682a9325fc72362b8532ddf974e092c08bebd9f4cc4b433e00c3ab564c532fa6ed1f30a6b354626',
             
             'debian:11'           => 'd1b1aeecbfb848a0f58316e46b380a9c15773646fe79b3d8dca81cb9ef2dce84ee15375a19df6b1146ca19e05b38d42512aed1c35a8d26e9db0ebe0733acdff9',
@@ -176,6 +181,9 @@ sub main {
             'ubuntu:aarch64:22.04'=> '303c01b34d86609341dfe6a77c6c0d51192ba654d71a142e2a1ae42c8085073c489586c6fb743f20a18f4d1128001cc15eb2a5d98c6523cad1bfbaef0bed089c',
         }, 
         'cmake_3_23_4'          => {
+	    'ubuntu:24.04' => '2f302be8dcaa073aadff64f77fe6392316da923191684a09339992feb5795f7f72c915ed262e7bb859146854748d2d2967c0b7c69f980edbacdf76c43c13bed2',
+
+            'ubuntu:aarch64:24.04' => 'a8d8af073d6af91ea5a257cbebd6ad4f5fa2aa2f9cf2160272ca7e7463d4b42e6ddb2f3c63b9d8f42a54f057a55fbcd05d96f1cdc9fa0ccd07ceefc465747383',
             'centos:7'            => 'f19d35583461af4a8e90a2c6d3751c586eaae3d18dcf849f992af9add78cf190afe2c5e010ddb9f5913634539222ceb218c2c04861b71691c38f231b3f49f6c5',
             
             'centos:8'            => 'dbe18cd4555aa60783554dcd06d84edac69640d15ef3ec7b4e2ff29e58b643fa8a0bcc2b838d6ae3c52a45043382e40a51888eaf1b45b2de3788931affc9e1c7',
@@ -184,7 +192,6 @@ sub main {
             'centos:9'            => 'ffcfb14f224b24b67ca68edcf36b24d8dc6ddce47dc597ccf4d13301ce7d87e79c9fec67197ce1ee57b9acd8bde58633418b8c1eff1a85300a6f7af033263d2c',
             'centos:aarch64:9'    => 'f34540fc160b197b89f9a814794d4abdf3b9607fa1af5a81f9bd9478a3ae460799f26f35e433cd650f8857232b0251d18db6152c7782fc1e7ba2008d272cf685',
 
-            'debian:9'            => 'd23bc4b5e5b8ab39ecb2046629a259265ea82f9247785c4c63cef2c11f0eb8064476f3d775a5b94ce0272f9a3227f2b618d87dae387840b69e468b9985416398',
             'debian:10'           => 'cab3412debee6f864551e94f322d453daca292e092eb67a5b7f1cd0025d1997cfa60302dccc52f96be09127aee493ab446004c1e578e1725b4205f8812abd9ea',
             
             'debian:11'           => '9aac32d98835c485d9a7a82fd4269b8c5178695dd0ba28ed338212ca6c45a26bff9a0c511c111a45c286733d5cdf387bcc3fb1d00340c179db6676571e173656',
@@ -203,6 +210,9 @@ sub main {
             'ubuntu:aarch64:22.04'=> '6c22838bcf91e31e54ed9a1b015019d84d2b527205dd07be970bd6190d3b9be3a54cee83a1a94138cb5abb264b36e0d1e397feb1fdaf35c7c2529f58162699a4',
         },
         'boost_build_4_9_2'     => {
+            'ubuntu:24.04' => 'cfcbdee292749e2e5367aaf23b2ae088ebd1512ca325cd03375329076f0f61056212b3919a2ae2643c06d4f5543817eab5a03772557464a781b2c3ddc87fb7eb',
+
+            'ubuntu:aarch64:24.04' => 'cd81eb33fa82955171b71f9c8ae1fb44834ead1e0d394118bc5385b0cf05edec71d9026ea55dd593543e1002b9cf1668dfa684f3c369799d1568d2de28339236',
             'centos:7'            => 'd395a8e369d06e8c8ef231d2ffdaa9cacbc0da9dc3520d71cd413c343533af608370c7b9a93843facbd6d179270aabebc9dc4a56f0c1dea3fe4e2ffb503d7efd',
             
             'centos:8'            => '7e79ac11badf496a70af00f87afca2f4cab915b017f06733bd5ba4524d1083f22c5a89a46ee4bad97aaf2b5bdefd65eb92abe63d4857618ac8af1a068700ff18',
@@ -211,7 +221,6 @@ sub main {
             'centos:9'            => 'fb604dab4188dfa7d81483274fe30daa8ddc27bd8ea0ba37eaf7171db781f397750ab8a27edb160895307ee5e5c89f3b59478cb7f40e7e6113513c76965b6c21',
             'centos:aarch64:9'    => '4cf47707e4e542cab65f3482bf8ba76462d263c14369bb675f7bae9f9c70e880286138cd258de28de050359350f464a829bdf8e4ded5394a1bf3808be7df5cd6',
 
-            'debian:9'            => 'ac536be94ec5133c45f4d435dd082e1ee7299bce7ae971e361eda716466963be358452ff0c959d7e610a05b03dbbd41ce195be4ee6023b8b223f6cdb22cd0c67',
             'debian:10'           => '89c1a916456f85aa76578d5d85b2c0665155e3b7913fd79f2bb6309642dab54335b6febcf6395b2ab4312c8cc5b3480541d1da54137e83619f825a1be3be2e4e',
             
             'debian:11'           => 'f434ddf167a36c5ec5f4dd87c9913fb7463427e4cda212b319d245a8df7c0cb41ec0a7fb399292a7312af1c118de821cf0d87ac9dcd00eed2ea06f59e3415da2', 
@@ -230,6 +239,9 @@ sub main {
             'ubuntu:aarch64:22.04'=> 'c77ac38d6c9d5e28beb0a96d2228efb4392a081d2a8495d729bc7cc8744c69f8a08ebd971b1e66ae83dca8aa84e866cc4f7ec27e1da4402f8fb72e732588f09a',
         },
         'icu_65_1'              => {
+	    'ubuntu:24.04' => '05b2a34ea2e1af642f5da612daddbc79e302ea9939ebd856cc0bf1e375ea2b2d481691c6745c3346e78f926ed1fd7436c271b3dd1a1c904a42c9c22151cbac7c',
+
+            'ubuntu:aarch64:24.04'=> '40390255f13f0607f6120412b66001f87d6a5dad562d2c458d094374ca8b42332822d163c3181625e2434e67d27b9ef90a4b80f8fbd80986359c5c90abe0be71',
             'centos:7'            => '4360152b0d4c21e2347d6262610092614b671da94592216bd7d3805ab5dbeae7159a30af5ab3e8a63243ff66d283ad4c7787b29cf5d5a7e00c4bad1a040b19a2',
             
             'centos:8'            => '0f3bc9c55e93956ce39c044cb99b4eaff8b69365c69ce845a56ff00ec32cbaeb84ccc9b37757f8024c7c7a1fffcc0e61ee4d8eeb226ac447a2d9718b5667e052',
@@ -238,7 +250,6 @@ sub main {
             'centos:9'            => 'ebc4041781e7886d4c2526469bbe23849711b9c9b3e209ff16640dcb0d9c3c874a4958a6a4393c47b0ef8b188bd1ad74aff04ecf82c0214f6d7c4b08549e02af',
             'centos:aarch64:9'    => '30e9be25c9f61c9448fcd567420af034c2d51797630e6df596b2f6b8b0ff9bf72ccac83437fe0f576d229053ba45338ab0d2aa891c29b73bf7b31b5bd834811a',
 
-            'debian:9'            => 'bdf9c89926d3aff1c5b65d20b94b2bddece53841732349bcb15f956025f950809e0212841712f21b52c5286c513066c01fa025a0e06ab9feee9bef8f7b74372d',
             'debian:10'           => '1c10db8094967024d5aec07231fb79c8364cff4c850e0f29f511ddaa5cfdf4d18217bda13c41a1194bd2b674003d375d4df3ef76c83f6cbdf3bea74b48bcdcea',
             'debian:11'           => '0cca0308c2f400c7998b1b2fce391ddef4e77eead15860871874b2513fe3d7da544fdceca9bcbee9158f2f6bd1f786e0aa3685a974694b2c0400a3a7adba31c8', 
             'debian:aarch64:11'   => 'a1926f3528067b9a5db29da4fcca52da62114e1f0763880595ad455ce6025788975325abd974cc9e8b17e0769c16211dafef91160e2d698e955769475766d51e',
@@ -256,6 +267,8 @@ sub main {
             'ubuntu:aarch64:22.04'=> 'efd3e5a1090b9aa670a41ad67e2212d690bf6de05d6eb2c66fb9e7b6c1d9c5760477380a708172f4511e556a78749516cf7209a376322ed1ed3bbef749a014b3',
         },
         'boost_1_81_0'          => {
+	    'ubuntu:24.04' => 'ec51db04c9b98dce709a68a310ed283f3da2dfe4d8be6986b31fd84d3d26409f912e8e38d6456074c4a43c47ce5bcf7ffc4f400492520ebcd6fde15512c7a8b8',
+            'ubuntu:aarch64:24.04' =>  'ca39e0f541a7ab34f38baf0ea67d6a9a018cea55fcf09ac3e476a1f85f0659959c4c388f73e00ecf036263450c80e193078bac10087946ad4d1ca0c97a1c4bfc',
             'centos:7'            => '403c89dfdfe3ef979f2f742b9a199a3031426ec6c10a0b1be895e5876240e5b636a33b590dc01766acbebe36ff9b6c7175523be2d95097ac37994a346081b343',
             
             'centos:8'            => '0e57552be3ac0d753838628d38485826aa402b2ac752ea1d546994bee3e9d689b3b439e652285f30f777cbc4e19a8217923d994079f243e8a3e4d4f354fa865b',
@@ -264,7 +277,6 @@ sub main {
             'centos:9'            => '3e9ad8d2032b5eda9bfe9a1a151f98545ae78cf6422dd307c733507554d4cd23a5d7b30d44552a15c66c0faa25ab2146fdf5a14a2cf360efc5c49ae17ddeb0f1',
             'centos:aarch64:9'    => '4e1d337d3193b6e0deddd8351729d7bfb145632b7b1c1388b613a55259ce0f20a3cb5e27c039f67143c277c39148e5bfff20cedc1246e8d4b13e7b73473a43a4',
 
-            'debian:9'            => 'b2bd35fc71d6e00bd35d3ae38728fb5312ed53cbcfb7ff4544281a5016f62961cb4b8371aead26c9964b4cf483ae9e6ee5beed003b7f9d26ad40c90547439795',
             'debian:10'           => '3b146de940bf36ea301c2078edc8dead611c4a770643c548080ecfdf8820856b23fa73a15fcab0579550cb19ad816fbef6040ad98ee500a8d15a66ed99eef241',
             
             'debian:11'           => '6e8a48ce6874e5f12b1734e590c726dd53801a5193e71cc505ce2bf9e558318fe970bbac1c8e50938798e0c86a9314ea32268ce0e817cc4a6023f46fd6e011ae',
@@ -283,6 +295,8 @@ sub main {
             'ubuntu:aarch64:22.04'=> 'b1df2e2ce44aaac8d0c3f66a1e9c9eb612e20836ddb815e6b91eec9ed48089752d8e5910a2b57edccaf06667fce04642e5867b36bf37c6614df07a3419877f70',
         },
         'capnproto_0_8_0'       => {
+             'ubuntu:24.04' => '907ad5313a033cae8bb5320dfadf9ac9d8c4310d477d7e9a0570453a0696384706f3ac855b4aadbc5062c903d9ec72088f16db0ac04ff44d262762580a65b00b',
+            'ubuntu:aarch64:24.04'=> '536b931fd0e8abe22f0bab54f113db5689e2c28b6efdae786696436f0cb796c1a989b1f7a587afbd563f3333bf3f4faa477754d107d22ca04955e5620baec713',
             'centos:7'            => '5c796240cb57179122653b61ee3ef45ca3d209ad83695424952be93bb3aad89e6e660dba034df94d55cc38d3251c438a2eb81b7de2ed9db967154d72441b2e12',
             
             'centos:8'            => '27a2b5128a4398c98e65af1c00c7deae62a472b3b0c01bda96e6903d77974205f2cc6f1dddbe57cb39b3f503fbf466caf255c093d0b0c123e28850f517f0272b',
@@ -291,7 +305,6 @@ sub main {
             'centos:9'            => 'a4cfb081e1b08b41dc0d51d62e9136826b313c65c773afc2942da09d096f0e07d109be500313ea6cb6d241ff5737f2d6b51a85526e8495afde45fdb2e89f8953',
             'centos:aarch64:9'    => '1ec4a4473e217eb6a0ae2d1c5026283f0f08811c70fdf14b658f467ef5ddfb31d18dffd7c763cf535288b6a3988831dbacc4ed58b69bafd333b35057d7eac6c8',
 
-            'debian:9'            => '7c6b3c073ab6461daef783ab08d367df56730764bc43d1c2a66d6a4001744400a98adf0399326ceb303f2d609c206858c311300eb06b252bf899d5a5616f142e',
             'debian:10'           => 'e9ba7567657d87d908ff0d00a819ad5da86476453dc207cf8882f8d18cbc4353d18f90e7e4bcfbb3392e4bc2007964ea0d9efb529b285e7f008c16063cce4c4e',
             
             'debian:11'           => '72c91ed5df207aa9e86247d7693cda04c0441802acd4bf152008c5e97d7e9932574d5c96a9027a77af8a59c355acadb0f091d39c486ea2a37235ea926045e306', 
@@ -310,6 +323,9 @@ sub main {
             'ubuntu:aarch64:22.04'=> '9f29fd8e1ee6065929c0fc6ab1c39e924a4a9062d4a2fdd060a03885f26d30927d538e6d7cdfea21f1577fb6259c53e7bf25148ba250226f0dff0f6dcd5e1ece',
         },
         'hiredis_0_14'          => {
+	    'ubuntu:24.04' => '1f002880ebd59952ee806c107fc200c1a49b69343386796968922f36e39661df814a958372544ccc0a051fdb3aa4fe053636016a74fad9521bf905ef5da41341',
+
+            'ubuntu:aarch64:24.04'=>'6fe1ced6859c750e05250af05ea386e0166c1b3c54dcd5497310274e8859a8cd7fdc2a298182e19643a3e3c48ac3eea385ec4ee74e7487cd6b159383d57f47cc',
             'centos:7'            => '03afc34178805b87ef5559ead86c70b5ae315dd407fe7627d6d283f46cf94fd7c41b38c75099703531ae5a08f08ec79a349feef905654de265a7f56b16a129f1',
             
             'centos:8'            => 'ccd1828c397ed56e4ea53dd63931bddd24c0164def64ceedca8d477eb0cafd7db12ae07a4da9584331b1af9ef33792da1cb082b3a93df9372df5ad233c5f231e',
@@ -318,7 +334,6 @@ sub main {
             'centos:9'            => '304e402b1a86734095476024840c0ba8a0ccf98771ac9655672671a7b264ee73a87a2043ce96ee8acffa12901f75ca5403dda297c040b8b3cfd220979df472c7',
             'centos:aarch64:9'    => 'aad8b76882dff7b92891647ed596e0e4ac12930f37f7a7ac4f81f6600c0e289ba0adf82bcd0480969ea1e1dc66ee9e9cd9531227ecd6ca6757bc34337a4c187a',
 
-            'debian:9'            => 'dae76b5ff1749f9b28af8b2bb87e36879312bad7f6ea1f622e87f957eb1d8c9ea7eb4591a92a175f7db58268371a6c70de7d07cbffa43e763c326a08bbf09cb9',
             'debian:10'           => '76ca19f7cd4ec5e0251bc4804901acbd6b70cf25098831d1e16da85ad18d4bb2a07faa1a8e84e1d58257d5b8b1d521b5e49135ce502bd16929c0015a00f4089d',
             
             'debian:11'           => 'c0effe2b28aa9c63c0d612c6a2961992b8d775c80cb504fdbb892eb20de24f3cb89eb159c46488ae3f01c254703f2bb504794b2b6582ce3adfb7875a3cb9c01c', 
@@ -337,6 +352,9 @@ sub main {
             'ubuntu:aarch64:22.04'=> '3852674e4d8fb58ccfccda3e1509216484a437155f70590fb2b5bc45c41dcbfd2adc16095424806335ffbf4f285588defec36fe97b1edd8baba628daa70b3ece',
         },
         'mongo_c_driver_1_23_0' => {
+	    'ubuntu:24.04' => '0671e5bea1a03ae95a02293683c2f3cfb11652285db5e8a1a2148299a6364d942a70383a9fb0499e4eae7f1f7dae32b2e4e7b98632bf0f74aed589f2c1694bdd',
+
+            'ubuntu:aarch64:24.04'=> '09da4d10a8445f27d34628a4ff2c24a4e6a95058cd86d46d414df35663e43565036d3973f71897cb0681e68597a0b905f4fec4753518afc71601d5a2909af4fd',
             'centos:7'            => '8ea15364969ad3e31b3a94ac41142bb3054a7be2809134aa4d018ce627adf9d2c2edd05095a8ea8b60026377937d74eea0bfbb5526fccdcc718fc4ed8f18d826',
             
             'centos:8'            => '99f69f62622032f4f13dad5431529e4f0e69f02de0e23f74e438a2a3677a61a33e649b7384b242857401776a2162aec9478b5ce3658b9ce0b9e27f8fa61f625a',
@@ -345,7 +363,6 @@ sub main {
             'centos:9'            => 'b1785b2bf23c8363856b8131732577ca955d66d346716a6d5c2f306042fc25d4cfd9ba320dcdcaf34ec810b1eb7be585427f382acbdf99589b84dc246a85871a',
             'centos:aarch64:9'    => 'dd575c403085190ee682074c8a826ee4c38ba91786bedebead80db149df228a7a80ffc93a9d13167f7fe29b2a43d653f4f6ee3123edf52dac5a20b1058d3ba8d',
 
-            'debian:9'            => '5b41952d68747fbe4d402b2f5be29250e68936599fc0254cc79c4518548b209056a24debce1aca3b0efa9fa09b1c1e0e3a6cbd588690cb03cb5e5cc487c18253',
             'debian:10'           => '3beadd580e8c95463fd8c4be2f4f7105935bd68a2da3fd3ba2413e0182ad8083fd3339aab59f5f20cc0593ffa200415220f7782524721cb197a098c6175452e9',
             'debian:11'           => '22be62776fcb48f45ca0a1c21b554052140d8e00dd4a76ef520b088b32792317b9f88f110d65d67f5edb03596fb0af0e22c990a59ca8f00019ae154364bd99e9', 
             'debian:aarch64:11'   => 'f3431068b375c7b1746ff0809ad41f9b0e9a7b28499420dd432df8d5cc3c9545b1046542959f4b9ec9ae32659d9d4beafbe8ac735e35b0fdf92c169f90f1b6ce',
@@ -363,6 +380,8 @@ sub main {
             'ubuntu:aarch64:22.04'=> 'e0a342176ccc26bf2a978f160b04046cf5a1bec35b7eaf85574b3f76196f29354dbb8eabe86326d7a1f93ce6805e18127462f7048ef7e8c7d226c1d04e4241ba',
         },
         're2_2022_12_01'        => {
+	    'ubuntu:24.04' => '2a0c6571f5803fe2b09bd2f5100a4a4b625d1a3c86160a4a77080f9ec5ca37a9592392e1026e516cb544bcf1b9c8c31252d2dbef040ad3b22be52731b63e4703',
+            'ubuntu:aarch64:24.04'=> 'd5491441bc7940d4f82bc7e503382251f674cde393d2ccb6e36e68b496761e7946bf8988beffc3c77e4527d523ace43adf9fdcac0cd765fa7a196d88a914af06',
             'centos:7'            => 'f0df85b26ef86d2e0cd9ce40ee16542efc7436c79d8589c94601fedac0e06bd0f84d264741f39b4d65a41916f6f1313cfe83fde28056f906bbeeccc60a04fff0',
             
             'centos:8'            => '57a0442b035767f163559b31a76c2f59285d3605ff078b17aae45a8c643d22f7876ce707d0d2b9b23791f8059921b5334e9b6860718e46510a0aedf05ffbaa58',
@@ -371,7 +390,6 @@ sub main {
             'centos:9'            => '24ceda96377155a57fa6161def14a8dc7daf10f825fb97f39fcf434fece8b4efe7523e91cae6911f6b58753e73e47547a01488498fd16e7b4c64764682a2313f',
             'centos:aarch64:9'    => '7d4210d404b9e0e244cfaf234a09d81bf15e0c63f68159bc90afb4c732a4e1e5e85e94e5b1a2dd67f9766b47f28c9a8e4662106722b2ab95fd5df9be1070021b',
 
-            'debian:9'            => '74fbeb57fe006f4e6c47d818ebd5bf2816c385a952c328e0231a6707160f05977d55cc45fa28ac1ee1c8c44b6f28622ce1d22452f0dc9f164866e90c87c19ca4',
             'debian:10'           => 'f2f6dc33364f22cba010f13c43cea00ce1a1f8c1a59c444a39a45029d5154303882cba2176c4ccbf512b7c52c7610db4a8b284e03b33633ff24729ca56b4f078',
             
             'debian:11'           => 'd64fa2cfd60041700b2893aab63f6dde9837f47ca96b379db9d52e634e32d13e7ca7b62dd9a4918f9c678aa26a481cc0a9a8e9b2f0cd62fc78e29489dd47c399', 
@@ -389,59 +407,63 @@ sub main {
             'ubuntu:22.04'        => '6cda2a6653881a8a06af7f7d4b8e16be09bbe5e3ce463a2e62d8f479aa028e81e7eb8489035b55dfedbe5dd223a27f4673337073a216062d7499992153448a5b',
             'ubuntu:aarch64:22.04'=> '530bd200ab98edf4fcaf74f407ff53788a0de676a5a383eef067e819263945bb5e883029a7ae4596b72542e6b7a17af3128592cab8f519dd6d646cd7e6bd5b54',
         },
-        'abseil_2022_06_23'     => {
-            'centos:7'            => '671a77966a021fe8ca8f25d6510a4ddd7bea78815c9952126fcfabe583315d68ae6c9257bca4c0ad351ff15ae9a7f27c4dab0a4dff6b9f296713b4dfdef4573d',
+        'abseil_2024_01_16'     => {
+            'centos:7'            => '53449e6d5448ecd21156b4a93b43b1e94be9578c21ae435a4a737920d94cb2a423301f9276122980a1f93e21c47c75feb9abe2a090b460158c30e8ba606eecfb',
             
-            'centos:8'            => 'a81445b63bcb97541c39a1afdc330ad15840cd8fdc1fc004ac934cd8acf4b4a50a0755ed8a0e7e64c4fa6f3d99725fc67b9d35f4da4753c597a37f6cf0d0ee5d',
-            'centos:aarch64:8'    => '421aecf02072129c92e47e91edbc550d2cb399d5aa8eb44021262f72d3aaecdb8247d4936a6452af7b48d5f23434d55e9df3927912357a58e05d972896d8b347',
+            'centos:8'            => '3a03f62a9ce0a0176602161da1c5f53a827784043deb771bb211fc33dcc39e4435362d30ef8dcbc17b4936b3a30c7506775d6517fc7c691fb422ce333e277cbf',
+            'centos:aarch64:8'    => '920957bc324721ec5f6bb9426babead4dd9b5feaebb1d4763e717558f26cfc857e3b86ff73f20f9c8720fbed5c1b0c103df2d782c4e69fc1f3c4717178b575c9',
 
-            'centos:9'            => '247dfe1699a3bb00e57fe3764d2a69f452f4fabf887c8a0134b73afb5516996518e631c23d59fa998cdf992e6e4f364adb54b3479d6bc4ebbe868d21655e1235',
-            'centos:aarch64:9'    => 'c8f7e9a3e065de4c56736fea43d7f55d0fa2e1e2104688616c1bdb5b018d1faed601c00da3207b4b785acd5ec1a6182c015f1897f7e164884eaf84ab52a06607',
+            'centos:9'            => '3f93b9dffc046e6ee0a74ba0e0eefd44d6710d831eb3ab3250617f918770c1b564267bde806c41c30591b261da5ef03cbfa3d3a48cc01d436cc5c3d4fe0ef5c5',
+            'centos:aarch64:9'    => '902777398c214c2ff34df3f264a24d8c95317b83a79923ad722d99275b49529ffbb55be90e149fa99719cfae3d07a37461665b5d18b729195fbc42d5eaa393de',
 
-            'debian:9'            => 'd9657d15987a84e857897672259f61b6939ac7170eeb66216996225652f7e0f92f97a1e20adbdcb1e24ec32fcae5283462bbdf0a4f1e0819973c7030ed9c7212',
-            'debian:10'           => '5256e2da02b15e8e69aadb0a96bbffd03858f3aa37cb08c029d726627ee26b0428fc086e94d8a0ce2c6a402b8484b96b3ccb5aa3a15af800348b26ce4873068a',
+            'debian:10'           => '65c553eef7902fe25742af0030439144fd70d84d8b5fe0b14b9276b560e04f9b86c5f1e896b25f8ccc4b69b4d5fed4175b48b6c81eace1ee21289ffe57159e7f',
             
-            'debian:11'           => '68be5a422e7b22cc10da9daca3cfe34d33d53f18093c36008eb236b868a6e52e97a4a6b3dc35ce0a4224689d711bbbd63073653622b06cc745294f53bed7ef18', 
-            'debian:aarch64:11'   => '2493497f388797c68154b462660c848067b49d45ef24943d9edac3653a263d6c6129371cc0db07bcfde4bc5533fd45f7a17a792ee4dd4d999872f490962931dd',
+            'debian:11'           => '96c335b23f82aefc81bd4f967822e8852d01721ecba3356cd46c4a452f1a121d7c53b7e9f6145bc1c839479b48f15a538fcf23c5c015cd2869404131ac25a232',
+            'debian:aarch64:11'   => '5a1f9c0a2c86b3d1a8d53103c77d49708aac4f758342a1f4107194259ba734407b4f9ae829b3fc3e42cdd08395d688e73722b0a0343f49a51fcb8bd2abe00105',
 
-            'debian:12' => '12687c75a8cd4dc99d26963be71dd0b922194f64fa31267a40d6aed7b73de02dbf0bd2a006219abdf0021065821308d9106a6b6a4aa44dbe911299bbe9766777',
-            'debian:aarch64:12' => 'a9d7ec1cd626c6954e24fd0be0979b909fdd4c203bcee967428bc209877e4aec8b6c6b494bfc12b875b523e4fe70b8f25391939c85b2a61ec2293869112f767b',
+            'debian:12' => '9c4616429747e243e5b072439304b6cc2108fc501d455ff36d7d21f144c821818592ae1642183829ba7da28737cae284a8eee0e5c279e95111b51c153c082edb',
+            'debian:aarch64:12' => '34a75cc20e47715250474bdf1979ff50b67ee2e676551b37be412eae141286866b52a7a1108b2c0315c25bac2f53fe180249799983d3298d184465c89412275f',
 
-            'ubuntu:16.04'        => '2346e76308afeb174d0825921e2e0b417f268745ceef99ce38f148a00f02ca0763256025245aea56ff4f65922ab63ca037857e9b53377c6be972048e94767cb9',
-            'ubuntu:18.04'        => '4e6da7f81d195e61c92189e3382021ba9180ca25e91067be91d3fb681d35804bce0fbbe7afc82a0d988a063de29895dbef1ce2c3c3a36458f64219ba7eae5792',
+            'ubuntu:16.04'        => 'c8e0d9c4b3c490162aae93052e57399a62d9283d7a78aea282693413d7e84d27f9810bbab8118eeca8d33422ea85d0b728b762d6d8e8640f72c69fb1ae32dda8',
+            'ubuntu:18.04'        => '86995e505ed01ae97d1e16b1541b75d3f138f8567348dc64a56052bfa6bbe0bff1d82e2a2ed0b439d114b109213f49040bbebf3216dde81ec5f990d6b811a497',
             
-            'ubuntu:20.04'        => '08723db3b20b948a8eb2e7e98e548c5030ac44e79b7561e3a9994865eaeec24f48f9904f3d1005e0b7b8818055ffa3d197cc6cd53dbdc7cdca7f1de8f242b245',
-            'ubuntu:aarch64:20.04'=> '23001ad8d467e167d2d287acb8ab50551cb18256a3404afffd8d1e247fa2b390203c4328361ea4e1d3e3bf8342bdd71f34bfddbac90b99e8a652ee730ef7d794',
+            'ubuntu:20.04'        => '33854a60527d1e9ffd2b38c32f7fe695348c1ee3619005aa288f1639c79dd6c8ac52f8ea4b43a8cdd122ea784bb291cf9803c326610a9ba5bf2739ccb4cab317',
+            'ubuntu:aarch64:20.04'=> '0a99de44ad0d94f8d75202a127a84a9eab7c8a2a7095546f1e87ee55745e45fe8bb4ce023ae7effe676c4a2c8c2a67d644dcde6bee86f72283ba32b76eb1294e',
+
+            'ubuntu:22.04'        => '2a4f531d210946c806e382765abdaf85713cb88d491dc7052c0ae4ae188d25a09f5cbf71f487eaca1dd9eff1bdf9e472d464697f5dc8b0e9405de6820c07fa32',
+            'ubuntu:aarch64:22.04'=> 'd5881f8ac7842109fd982bbff7bf5ba7572c41b83d4c5b5a659e2019cf3265202057e26e4453345316e9c6c7f21fee00d7ef2b4069a96af434305d14f1aaed24',
 
-            'ubuntu:22.04'        => '9ba3803665cab932e033721c6be78850453a3db9cfa0b248c1f754f6287d8a6dfe959b6eb967c95b475168d3a4ec41685725a52b8466145b2d9892b79f97283b',
-            'ubuntu:aarch64:22.04'=> 'e0742a48ab2b775c0978a698a672fb4bf4a2f94e73be4a38976e68141c5e71b3c6c38734dfcedc405774eb2e3d175b169cefd73873475d6ccfeed582715643e8',
+	    'ubuntu:24.04'        => '1ad4265bde0cee2a25c2a6585277712476979e82245ef8784364804215e1864b2a5931f410c85a65e7aee47b2db494d58e2916278689c6028ff95d1fd56e3056',
+	    'ubuntu:aarch64:24.04'=> 'e322a686c54562f1369fd02a9f02929be91792acc02839f78e872cfebc8c98827cfcbc038184913716bf4f6108b31268307af5db161fb6e6cc2a05fbb9b2f077',
         },
-        'zlib_1_2_13'           => {
-            'centos:7'            => '649e8353e1c7ad7597378b25a81e3bccda28441a80a40d12a3e5e5bee34b88681e90157118736358e858a964b1bdc8cb1c35c6df3bdc2aeafe31664abcabb93f',
+	'zlib_1_3_1' => {
+            'centos:7'            => '519329e00230316457b662bcf218ceec3837111dd088766232e8393cf01d4a0f008f7cb2cb6a4153b0f5867572c340f71bbc96a6bf0f675dce273d5962555ae5',
             
-            'centos:8'            => 'f4fa12d80f9a56ecf8dd8ed09de98c1204b8755f7426495ab5671d7dd42828dc31a790e0bab2a4a69224bf8bb6a8f1cdd1bf1444e596d58a08345b98e4ce6f89',
-            'centos:aarch64:8'    => 'f1f417d99472c8c1b2d56ab706867c3b027078dcb6050741750015ff14827ddba30d73adb9f35c1fa0892125872bbe32d2d30e99874b5d7ef36e1b70107593d1',
+            'centos:8'            => '7b44bd3b8ed348176f60cee201c38c9e56cd9e4b51807d9d4aa9b60e06238fbb3f5e4370b68bc501770f8f7e05f672b302857addf39d88fe8ea1f315914a34ac',
+            'centos:aarch64:8'    => '710c99271c42231c516a65e5cd311543d65e511a8040df294ece7c8cc4feefdfc81cca6ad4cf1d496193d2cdfebebc90b93c1fa3514899c9ae954baeb4f1a2cf',
 
-            'centos:9'            => 'd0a58e00541a2808db3e701d7f1148e1d68527802a4a63d6b305bf37aca2e39045b28d0527b46d75b9d008c7e8730eddca6c567e8b1d5c7c9381fa71fcaea3ec',
-            'centos:aarch64:9'    => '2eea56c656faa4c1e6668644a3ab5793482f4b645a57163697a63a12769113a21c85a71dab747118d498a3658d359b6934d1c7a9dd533f9e782ef6450abbf3af',
+            'centos:9'            => 'b61e8aa399303aab3b5f9e61efe5a0b9bcc2a7a15df714039af8eb5027be7faf98c3ae6220102480809ec8ebac8982a87549d13e8788756249b4eb17ab92203e',
+            'centos:aarch64:9'    => '846290fb44195f2882718ae315748dfa73ebc22261836a2632f2b897bfb3a95e592c3bac18b104fd5181d865db8e7e38235f3996854670eb688ea68d7a09b639',
 
-            'debian:9'            => 'f2d63bb2b629408166da876a3797fe4b2f71aed793696634b9653248eae0ac5ff50f39e48afb504edf08c99a9e1fe4f6568b4be59e3a2116970dc2e030eb312c',
-            'debian:10'           => '8f7d5ae6b8922b0da22c94ad6dac2bde9c30e4902db93666c8dd1e8985c7c658a581a296bd160c5fff9c52c969b95aa806a8ae7dd4ee94eeb165d62a7fa499f8',
+            'debian:10'           => '27fbd2fbf52ce0bc970d7e963bc2aa5e757ba09ad38765283c31b298ffdce97aaf7ecc90563fa110abeb535ef5d13f69976b5fbf731adec9a6b8079c4aef7353',
             
-            'debian:11'           => 'f44a69f274b8bad567b197248587c35dfb1ae0a58f921075d79b0c855df347b796593435f6a0ab6af92fd1464ef0a8032e7f2e8889c7844a38a2a04705bf6f5c', 
-            'debian:aarch64:11'   => '1af74cc8d2f7efd29393867475460ead42dad622386ff86cb48b74a8961c5091c3ddcf95968f60f8918f795ab609e24478f1154b6833dbf1fdfa2ed5062266d1',
+            'debian:11'           => '92cdd4bd6ab80209bbc6aff8c116213d36bef7de6164f186c7f56fe77d58674edc975ca90c67b20767b303c5ab5fe689fc0944c48e560dda59d2bc68055beb45',
+            'debian:aarch64:11'   => '3bf8452e020ef2e623a4410b592bcf1d9ea3a2968c335eb3107eb880f249018d304e9f4c490207f0e5c9f3fa7901a3bb0eff1e73dd163aa2f4cebd1a23981805',
 
-            'debian:12' => '83d8a2b298fcb154a842888a28fcd0d000218919a4f28c132eb78c6a4b0f7bf10d80995a0079128957359202ed36ab01178b927a1b428bc6cf74b0bd81e81f11',
-            'debian:aarch64:12' => '9f6ce5568f71dd26258ca7d9c6a0a3fd05381b9b419486f016e29d50cb93762f13eda5d26103059c868739ff92e67dcc9f013d6afbe8d0fbe01e95ed94986a75',
+            'debian:12' => '54fb9181922cc37f8df35e6a0183bddd2ff36ac6b8b7217125e8086c1e4812d46b3fd5fd881e965beae1b2dd7aeaf7406f0bba4d732321f7f3fc51be257fd91c',
+            'debian:aarch64:12' => '7c36f0f6e7006bbb99786f80af843e517c9838fd022eb41a8872c47309390cebb4740e47ef71b494245e9b260e0ce57ef9da3676a7d00fcfbeefb87188e75fff',
 
-            'ubuntu:16.04'        => 'e4a3e89bd72bef42a2fdc3a13559966924361593bd03318532cbe81a5f70ef1991f8e5ab245e4740ef97deae75b907b27d9a8c4ed33d2be88ed912a31d0e7b2e',
-            'ubuntu:18.04'        => '0bfe299e2d99ad9a163e1e32e1f23f0126237f171a05dcbffbe86e2d76ee770a739794e9148d25b66916ce0531eb2811da682f99b1dc9405ec7c5b88db49dd26',
+            'ubuntu:16.04'        => '2613ba3bc6bc4753ccf6c0399695a45dbe776ee1db896f7875045f271e81892134272dfc7b0407991c5b64ec29adc732b53c579fc09a9f82cca2f61ab684ebb9',
+            'ubuntu:18.04'        => 'd541d0b456aea4f576ac686ee3878e3dea7da95571841c24ac14570587e6f7ae5875508901a94f42b2af613bb29d599175b4b66588f18310a03c1a89b866f3c6',
+            
+            'ubuntu:20.04'        => 'a61b4cbf384c445445bd778835153b372e76698a1cca281004c3cd89379edc5a9683367fb96afa445795575fe8fa9dbe80ab1e8954ecea57eecf2ffaa4b1fb5d',
+            'ubuntu:aarch64:20.04'=> '3fb900aab3ddb375854909e854851ff9423fe8029724083c2e38853b7785a1605765509bd1fb20b7f5b74d8b0c08624ef656630374f0fc855a659f661133d480',
             
-            'ubuntu:20.04'        => 'ad51fa641299a4a72f2c767e0d3c3b754b89482591fb0381a2ebfe6465825b03907203af4384ef85515410ae31be0daf6573c9c381de5a3748ed19ffd56db0e3',
-            'ubuntu:aarch64:20.04'=> '918141f90f74f92aa9ec4194a5cea22baefdfaac601401cf9ab382b5f35707c3e9f005a4f05c79b362a1b5216b4d46fbffadda70158391049991c4174cd81a73',
+	    'ubuntu:22.04'        => 'e0f52449d2e2ec8a9634b96ebf6fdbc9cc062e34cb6a2037a3b8812a9f2882ce3909e721f580851a3b3b986094b2c5f9cceb6e00b87dd0366ff8d5c028304a71',
+            'ubuntu:aarch64:22.04'=> '62cf5507e691728868a007aafeb3a951155ea690db8afa505ae6972583564b671d37b3d5b1dd5be90a54bc911c351227492180182f527774792d58830f19245f',
 
-            'ubuntu:22.04'        => '3458922d32fe306526b48400f5f75dc756f04a2edea355c8e2fa9041d7c3577808e575f648eff1dc0f3e8ef88121efd5ed8fdeaf9a9a89de801ae607ce30f624',
-            'ubuntu:aarch64:22.04'=> '3e7b7250efd933aa8a58b9560b7e231a3496fc8969bb36a97b748a4ae59c9de296679aa1bbed7bd9fdfce7e97f97340e241afd93f2b6c472569a6c7158101953',
+            'ubuntu:24.04' => '5c4248ef746369f2a995cb7a79d21eb4e4d55b06a824c2fbb5ee4a195462fb96fbafbdb719bdc11a2b3e7b67e09b043ced83842a421006ad9bfa45defefd9b06',
+            'ubuntu:aarch64:24.04'=> '0c5a58e9349acd0250b0fcbc5c39f095c14806ab0743e0650ccfd831e5f8f568517143ba24ffb97401be2743f7d91010c46268cd649acc2bb79c169ad3ca8ac4',
         },
         'cares_1_18_1'          => {
             'centos:7'            => '65902575e20b3297a5a45a6bafcc093a744e4774ea47bb1604c828dfa2eb9a8ccd63cfc4a2bffbb970540ca6f5122235c5e19f10690d898dad341c78a3977383',
@@ -452,7 +474,6 @@ sub main {
             'centos:9'            => '630f37a4363b42ca2256a3482009f6535680efc504e6df5ac2ea07104331803d14bc610e472b6143127eccb3315bd90a4961c1bbd13e47f2bf6be14000b3427d',
             'centos:aarch64:9'    => 'b5b4ea12176f7db5591c862077f621ecaaced9c276231d81c189c8262b978f68d084e6d6e2b2fcaa488c0c1ae8fad5a9b36a861c91f77569f722f4c413617540',
 
-            'debian:9'            => '1f4474b79ca5f01ff4ee8edc3f25551c7d1425e691a135348a242784eafb21c625af4a189bff3275a667a61f78269f199b70077d7ff9755e8f2a30ad1ba6d200',
             'debian:10'           => '433fdaed84962575809969d36a5587becbcf557221b82dfe4c65c4a67e6736de0dfe1408e1fb8859aacf979931a75483bac7679f210c84a5b030ddeba079524d',
             
             'debian:11'           => 'ac55ef15730576b2e4c464775cfcfd13a67c497787d80719d524992585af9f78271d1a1e80cacb3c7566ee240cddf459cae933621fe8574d906be708fd23a40e', 
@@ -469,6 +490,8 @@ sub main {
 
             'ubuntu:22.04'        => '4447ff5648ddf7b96365be52505f585eb1d51f1c8ab2383553073239df538a5e5cbfdac04cf7998d0ef71bd1f201113bafe52d052dcc57b123132aa3f7011ab8',
             'ubuntu:aarch64:22.04'=> '957d26b5370f40b0873d3d0b273496688df8130a7e4568db57171e418e59dd27685cc81922c89b890b817269725f0ff49cc9511fb77203df3a32e51f6891f79a',
+	    'ubuntu:24.04' => '9de0745b8bb43f8dcddd0d7c879902a140b1063d5ccde3e53e365d8e037eaa350817d1f7314d7f995631e1451b216288c35f029cffa48c4c4618eec61384633f',
+            'ubuntu:aarch64:24.04'=> '66c0aa0f8e39a9c6732ea789f47453adb29ad2ff5af0869e74f9fa6900c67d116182d298d2802c5d6864e7ca327171af5d0cff08ebcc05172342ce7621100897',
         },
         'protobuf_21_12'        => {
             'centos:7'            => '82ad83b8532cf234f9bbc6660c77a893279f8ff27c38b14484db3063a65ca15b3dd427573daf915ef2097137640fa9ff859761e6d0696978f9c120cd31099564',
@@ -479,7 +502,6 @@ sub main {
             'centos:9'            => '2ece586671958cf8d619f6da6b6102e1ae36ffc15113d0fe9c3b151a6b15bffbf2ae957c4b74bfcf85996b6327cddf120bc1951b68376bc5d72c5609f9b63b9b',
             'centos:aarch64:9'    => 'f90e7d3f23457cc13ea19559aca093ab58692ac81f233bed355f4a0cd9c7c8aa1ac44c5e336b39d807a2f46386368a6e9617728479b9007aef3fdacf1a7510b3',
 
-            'debian:9'            => '77882d112364681cfe795a8676d75d214a1030f0bf1a2e281b4100b493b8b4eb6e3c57db9f19770f6df9c3d629a43aebba446391bff299170f9ed9ee08cd0f52',
             'debian:10'           => 'b0dde2a94dc7e935f906608be5c8204393e87ba5703b78b84ad41ab690107eb306c50c9572669b0d18a55334ba26ed22a2242b54d6e30dffb1c11f8328b23c20',
             
             'debian:11'           => '97252bc39c9c218f02f1c5d1020296497934b1fb2ed9300c133db650ef327cbb06e5fb985234bc00ca9e86239ff2dd28b844a0eb92dedad2d4a3d88e47984caf', 
@@ -496,33 +518,36 @@ sub main {
 
             'ubuntu:22.04'        => '5a8b91f98531d91fc5836ca63246016ee1be0dfc50b51cbf2cb6e8c5f84c3716ce6700aa7d30b33c986407a25dc8e39aa6e8628fce85f1947de49edb3ba5c211',
             'ubuntu:aarch64:22.04'=> '4ccf53133017195dfcb16da67912ea15ff6c8d2aa8530d808f971f6854fe562a88a46bbc4fb99965add5f3054d2f5fc24f4032feca5b6124cae4807a3c8923a2',
+	    'ubuntu:24.04' => '4e37724689e7fe173d628d48d7bb7b3d41fa26071e583c5b01d5873ab0c134e0ae37a6e429c55f55f9b91fb98ebf9896607d475e12a4f1ee1ff92eef4730f0f2',
+            'ubuntu:aarch64:24.04'=> '604d2d781b5811fcca1a536f737ee7abd15583052fee73d02a85dcfa2613db2580bb32b3a4dd5d1a29afc193f10be17bf4747e586f8a7f8265b46d6f60954d7e',
         },
         'grpc_1_49_2'           => {
-            'centos:7'            => '4c77cf97c5c42dfddf002b9b453459ed28c8de3715145c8f162fed45f650400bcdf5c7fc714aa50b1fa14f486ae86b47d6d2cb03d00862281dda4482583385db',
+            'centos:7'            => '0641b6cfb15da28ffdbb26eadcafebab238b9a2769e36a297718bfb6cf4518029ea16edb716e7b89634db564e63d8d636389c12d0e85a25ddc726ceb51ae1843',
             
-            'centos:8'            => '02ccf070291c2cb1268cf3887c8e92c99ac614a757cafdf96c7235c5a2e583be5a89f8174d5fed93f3dabc17f9049a90064b9b88f465e3c1736dcf3f2505e2a3',
-            'centos:aarch64:8'    => '9957c8c8e66a82c245346dbfc0edb5fbee36ddf3dada7315d0529d9a2b7ac838dd173f1cfea6af1986a89aba5273d676477ff5b3c65e422c5e95daffe317f137',
+            'centos:8'            => 'acbaea6e9522a860ec11d59c8a28d54f08a8d8d7400d4f14c9bbe711685d612f9f5aa063b07bbf8ce9b886ccfb295a2fde7f0410d4ecc9daa67e03c4f15fbff0',
+            'centos:aarch64:8'    => '458281ec94a6421cb43f2fdb0ab3d5f0a4124f6cabcaa53ad3fea65236149eeaafd117e8471605d4fb6ccd7727b6a9c874fc977db5ac59f61d6a2075a923ee91',
 
-            'centos:9'            => '0848adea41083de22470fde9ce161ca4adf005a6931095b99ad5844808c7ee09f1d5139e9c78e8b4ff5032e06a73ca0d0428f1503838eec46748625e54acf94f',
-            'centos:aarch64:9'    => '451f94967baa95bfa7826ebc3fc8d1deae544bff90b6a37486b5af03155d315e9c3bcc99f0a71deda8d380cf41a5f644ee0d227c8dddccfb182bfebce4656b01',
+            'centos:9'            => '9bf7bc55e267d3d70ebe784391f955e3f0d72c23708b542d3786944e55936eac0291acbe4fe2bcd36545329aaa27cc105016e3cfd4580130706d8ab55c919fbb',
+            'centos:aarch64:9'    => '33d67cdc11e563c64f810dc446232710f29a09704e8dc5618e1b45aa6cc028bd6e8f43337ec07a614c2f2b8680573e5a78b6dda243fdbb8a2e41e37ee2bcf8f1',
 
-            'debian:9'            => 'eaa6052481b1ef2535bd474caf404763a1b7b3eb85ba3ae5c0d1effee7ceb86577689e57666fbbb10bb100351ecd61e966cb72ff1ef376fdfb1ebbcb48ff1870',
-            'debian:10'           => '71c6d626aaebcec2f9faa8df215ac988379ef3b7eeb2bdbef4d176d6a3534ec561fa55a4f2b69979c9cd51dcd52aa59b937718066f35cfb1cef5861f2e988bf8',
+            'debian:10'           => 'f62b27dafca95ef4bf9ae4177b3d1ac25cb17d5e6b64816694ebc234b3653e64555a953398f86f6652f4ff2038d81a5cee4b828472bb900155999e62c2a9b128',
             
-            'debian:11'           => 'bd54409a859c088e60363d5cc5afc03d2326759ba0c40e1d08a83518b0556c953830fe232945252174e69482520eec3f6f7999b85eaa417ac780dce1bd064a70', 
-            'debian:aarch64:11'   => '9d7b42ecc1f230436e069d321e64186483939a3aa61173d3da39fc92723d363115a5e19e7276492dfefacc091dab53edf32eab34028da16110ef8caa80bf0057',
+            'debian:11'           => '327548fe0b1b5419779a4ee16c4e09b5b6cb19af397720018d8af7755c33850693b1e56c4b422654f0c56d25bcd2d7230cf630a7034360a4315d853b2851b636',
+            'debian:aarch64:11'   => 'aead130b4e3fc1bd846ed4260ad54bc6ca56bc60aaef32995074027ca049ed6010afe66df559e1276f37cb112321ee7f56c7962f54cf5851ff0973e4a3a2ee4b',
 
-            'debian:12' => 'd83a08f2f932a232b26dd270e861e769c4007deed7fb052d19491dfcd186ebfe9218388ac89bb6d18ca333e347992302c2fddcb41b7d3d0c246c60340aa48a14',
-            'debian:aarch64:12' => '5baf57563663044e8893acd787f4e324624eebbcd76dc828f91f6655a3ff4bcebbf62ad5a7bb521b4b4e52c940067c8f4f116995b4754af537510b5964442fd2',
+            'debian:12' => 'fd96041122531ff450a42d59110fc729149f52178e3922ccfa45abd3b91d53b57f250410282a3a26f1e5ddb896d6ecd6eb4d23c3fb3bd89423427d5dde5ff970',
+            'debian:aarch64:12' => 'caf23a0e9ded1d337085f1767e7b44d454135f28b4107447e78054cdfd825570b62fbd773b00ff979656557aee596b9eb8ebbf9e2347cc7173702bcc6802219f',
 
-            'ubuntu:16.04'        => '4c26236d708260d682f346eb5fb9c4c3828cd31c286f4ae95357e9e4b9a99220e29d65e7cb5ea25dd9210bc08194170863b275f0016bce8302e6d2e8a31687e2',
-            'ubuntu:18.04'        => 'b885b3e7b22a1ec0d4a49d7de952a1c667eab4313c6c1e299f05969bfb194aa677bcce5cf495230087b65e25f76496786f998fdb250fd7c7826ba98164434aa1',
+            'ubuntu:16.04'        => '8f7e3ce183657660b18ae6b696dd4f28270fec39b41d70a3a66653f93da43f42bbda82cd8b7158fc5d50b9baef91e4a9c69c10b1e0ad61477341efa81e2b0987',
+            'ubuntu:18.04'        => '7d1a57b256543e8394be998d2da67888bbcf948f43cb451dc14c37fc8a5b4fb5811d1a9b079e1f3ecd02744f78a32f5b52315b1b0eded6a405dfa44fbcd19b35',
             
-            'ubuntu:20.04'        => 'af2a70d0ca5e77ebac80c2168a2b3627e40a2bfb1d79e63fd6fb2708d6f4db9dc2a24ef467615a0ef49f57b6444e4ddc8db4811ca4700e43b9b04c7b9dbb70a7',
-            'ubuntu:aarch64:20.04'=> 'b827a503307d981ec28e797f856c033349f6e1a75dd507cd6f1ff0a309db9082a81b11690a0db84d0b162f7d743f138c68bd790f0af04d49a27604216db3ab9f',
+            'ubuntu:20.04'        => 'f9f7f6c803fd948d6762cde4c0471c414b455a8e1a04206de0596050bd3b2d6105d3d4172e09928581397536a3680b5109a6010ec4f92dc1031f6c872eae1def',
+            'ubuntu:aarch64:20.04'=> 'f4b9afe30d9c99b1ee4d50237e3d4fb365ebbeaa02e287c18e1278c6e31db6e5305e96d647296fe6addb7273ad7248ac91de2b47ccbb079e4ac5a84256a9e3a5',
 
-            'ubuntu:22.04'        => '32e28500c2ad633a7780ae514383bdaf91766db0a50c5fbba5079869beedbf1d2fb4c8fe67b05aea7ae9460a7269dde2adc54f1e4c1a6b393ffa84d49a26c885',
-            'ubuntu:aarch64:22.04'=> '10ed552dcc8b414e17ef6950c47a75e75ffc1511bc082ebc11a6bcaf07789a8425ec65136a8ae6c9920af60b9e195bd9dd7ff252610bcfdc236dc3021d1b22a5',
+            'ubuntu:22.04'        => '4b353beae63e58c98530819f5e0645aed0117c52d7a351a3dea05086cfb757b136442bc064a9bc87c46f29017b77b28776a1514f322c5276cb0eb2d926b895a5',
+            'ubuntu:aarch64:22.04'=> '1d0643cbf1f993dbc9f2cfbc31e865dd061c4f0cb6d6476ae0719186e502ed6e5e83dc8331a86ef2d3a5beac02f5d623844a0fa434ae67801794a74bd6cde5c8',
+            'ubuntu:24.04' => '876dc319e9aab49ba268e853adb9a006b539bea00d8c1ca6d599a6892f525db41369252470c9454ecf0da154e82389495b6c14e4d7c5779a536b59731bc76af4',
+            'ubuntu:aarch64:24.04'=> '100465fb2031673382de62b341c51d543e13e07bbe4806a515560068bed4f157dded45de591c0a33d8c6470d1afa28525003ec1a6b5fcf0ead79d9592d0e8987',
         },
         'elfutils_0_186'        => {
             'centos:7'            => '23acf9d80f72da864310f13b36b941938a841c6418c5378f6c3620a339d0f018376e52509216417ec9c0ce3d65c9a285d2c009ec5245e3ee01e9e54d2f10b2f8',
@@ -533,7 +558,6 @@ sub main {
             'centos:9'            => 'b518006d054e123142c186b7eeff5f0d76ea3828487da6cab46e1ad172367a92dc038b1b88dd284226909df25bec3979e400637336839a4d322cac376afda8ec',
             'centos:aarch64:9'    => '60e416ad017664e90f8fcb6662d4e1f1d1aedc12278918ef5236ab5900926ea68d6f8f1a3ef46b6c1aba21483cbe9d9f1ab1332ddffe499ed0811cc12a947b4b',
 
-            'debian:9'            => 'd5cc79509a537feb7fe2cc0241695f530ac5459f7dbdc83d16590db83057cc3ee79f2197033d9ce6a8530cc5491836943a04e18af13a2c71d40f6b68a3ebfd6d',
             'debian:10'           => '16bdd1aa0feee95d529fa98bf2db5a5b3a834883ba4b890773d32fc3a7c5b04a9a5212d2b6d9d7aa5d9a0176a9e9002743d20515912381dcafbadc766f8d0a9d',
             
             'debian:11'           => 'b9adf5fde5078835cd7ba9f17cfc770849bf3e6255f9f6c6686dba85472b92ff5b75b69b9db8f6d8707fcb3c819af2089ef595973410124d822d62eb47381052', 
@@ -550,6 +574,8 @@ sub main {
 
             'ubuntu:22.04'        => 'f714682aa3bb7a8a86880973eea1461baf2d00fd6cd8d67a5e0c287079bc36da0cd7b196501e4cad708665b713d7e97452b03e1c33db58dc3ed6a05c2893b32e',
             'ubuntu:aarch64:22.04'=> '5a408486dbe7c4f84e7f4f528e0bcbf396dc4f256f78f8a6a1604e1837e08939e5d6d11d3aa440ae9623f6a3715898744791ca6f147f533f47fb115286b3398d',
+            'ubuntu:24.04' => 'ca2049c1c0137ae1b398580779976ef3fd99c50d464b1ce4d61d403493ee23f4016ccef3efd1ba72fe1e78a47034db694ce1d3df36c1b3084e15bf74cc71b4fc',
+            'ubuntu:aarch64:24.04'=> 'a5189e475e5a8e0c605a31c178e73b1bdc1a598e8de033f8f07dd13c3c63a4593e7920891917b72d5431045ce591746e7ca9d8a9c09e33f8a760dfc3fca61489',
         },
         'bpf_1_0_1'             => {
             'centos:7'            => 'b6c6b072cef81b2462c280935852f085b7e09f9677723caf9bb5df08971886985446ba20a4aa984381c766ed0fc2d2b9cd2afaa7ab3d63becde566738058fd1d',
@@ -560,7 +586,6 @@ sub main {
             'centos:9'            => '6313c8ad1c6e6e070e06796807770a291d85ae6e5fb67d3045dbcb144016968e34b5256f83006be0847fcc53222b931c300b11598d7bf031d75c6284343a6db1',
             'centos:aarch64:9'    => '373d469eb4c8281c1632c345681d5bccf58fa65c23620239df651ac669b8c2abdeb926e7304fea513881cab07eecb3815a161220e671ee5ac77b2aa36803b0a6',
 
-            'debian:9'            => '0f397e08a6bec515260c2937d76dbf48ad8b3452ead4ac5c41d4b3536ba7e8a40fa703f7638111492e690d9c9e3fd5316aaf41c9c93e82eacd8dd0fb6bac2c2c',
             'debian:10'           => '8f2e456bcd0b89fafe97c6368f725d85230f183f72a720bb4f7da043ca6ea255a2c97e374eb78407e8ef969d84faebd63cf5b509eb9bf4476fac5b08567574b9',
 
             'debian:11'           => '11e91e87b2d10d5e73958c1944abb50e1c9df5891ad563683e2b313848c85d3fd15aff8ce70445afc768dd490c5d8de12f887b314eb55af7e4a8f9613c003806',
@@ -577,7 +602,9 @@ sub main {
 
             'ubuntu:22.04'        => 'c92b722e28624633de4e8411f89984434d4281d4e674677b800317235f5363285c5618e93a59945b90196026b0c4d061716c7e5bde817e4f4bb93efbaaeefb12',
             'ubuntu:aarch64:22.04'=> '5899eb3741c29a7c7d1e6f8a60fa08813890a60b45e5f7d0f980e74287ad48953d897263b8d3455116ac058db26e424576e1046f9c35d0c9262cd31b0ff0e4ae',
-        },
+            'ubuntu:24.04' => '78598ddb3901c4ea4d305996b54c5ab5d1b7db694407abcbc390cb228e31dfccd0646d1354ef374f7264f0a9ccb00c0a8ce237c32934affbf44c59b0033c564e',
+            'ubuntu:aarch64:24.04'=> '82cf3e15de24cb4d49c9c8cc3cbf1ae325e2ef36d6246018036c5ec424f64c3a62c8c7d52bf6e3b0aef060721f0d641f80cab7c5e654f48cbfe12728ef03c728',
+    	},
         'rdkafka_1_7_0'           => {
             'centos:7'            => '40e01992e97b4620eb6c86def5efb69734534cf24a374f74ba9a1f640303f08a413bf5c3d2bed447bd1afee082b0bf213d4d3da9dfe696ecf3226a2058098725',
             
@@ -587,7 +614,6 @@ sub main {
             'centos:9'            => '544d070e5e61e8d12bab9be9c39d040d7380308241f81f0676ddb627764066788b4a4a45693b8d656d2ed2e412501cedb797b94cea1169d18045ac541d51bf82',
             'centos:aarch64:9'    => '8c3e3abd7428359fb3085b62b9f4f8683df2bd486ca67095f2e05ef474522cd8a87fbbe7e5b448b46b197a80f4c0b611fc346ae386b934e1b3597263f92cb793',
 
-            'debian:9'            => '67981b5f576971a79e4685bf867dbc7685453842a31b48a6d48a82f639d67f4be6f7fb1ea8ae60f6170c6367874c05362fb05e4114397016ef7c6fdd6eb6e387',
             'debian:10'           => '6abed5425d55ebe0c251e9b4e51750297491d7fe15c4e1584c53f38d660d0ae91cf05565c9db5cfa36d217becf32ed64a099b7af55391da299536689083cf6d4',
             
             'debian:11'           => '2f94bfa0602b780a4f6685d4f1b56ae1276f9e6688bdab380b6e91b90f9f83330f94eccc84d95171399f6c980c2eefd72a587f0d483ecd159cbe9d23bd9084b0', 
@@ -604,6 +630,28 @@ sub main {
 
             'ubuntu:22.04'        => 'c547ecc1e5d94f557184fe7a9202a56065edc5afcb71d8b803be7d864c20422af889a7ed693623280ee0a0991cabde99901edfa5ed02a352d9bd63f716277f42',
             'ubuntu:aarch64:22.04'=> 'c51ac309888e879d303f4aefaaeba1d86c1e2159a77dc9f0c8e8e0638c1a80f133f32b197cd4aca7e7ca49142ad7e96d964542444de94817eeb2bb608c8e348c',
+	    'ubuntu:24.04' => '17b7aee8a36cbe12029dbe9cbb19857a77147f89f294b3e730cdf0ed2cadf0dc1f34d98e2404b48f130f83d632529bcbf85b8479ed774425cf18f72e1400a3eb',
+            'ubuntu:aarch64:24.04'=> '4e518fbb0594447250b7242ab3210c191ef009e2d8f22ec70335d84fdd37b86b07802b20bfdc1e5f6caa89e90b0704b2c35ded3768385a71296b249355c1a92f',
+        },
+        'clickhouse_2_3_0' => {
+            'centos:7'             => 'd265d32ecb417f881c8cef21e6c3d4849105565e4b912feddcbcccf78676caa8afbfccfbb48e3783510ffccdb41cdc76b117d0b953d5455b9cd0aecd1c3b7b0b',
+            'centos:8'             => 'fafe50590a51daa7f43cf03b073e718ac36368e13699c5848d9c19ad8eb0d0eea6f2aa2b52490aeee039ea8b991dbfe4a3a37a9f3965dacae241a692f63ee096',
+            'centos:aarch64:8'     => 'f97002fb6e744b06308bcfcf2979b039a08c929902726388785fa9a90a77d6b09d8d4ed3241362a6ec18b2ed747dfd8e0576b3fa195e3cac253c0a43f342a0ef',
+            'centos:9'             => '189523411392a0ef076e15c7bd3a30a99572f52682f4b51533b3da47ac666fccffb970f1cabfda0ad8268fd23a2f7909f2c48d3e769daf384122c27f8f75b507',
+            'centos:aarch64:9'     => 'dd09d6d6fbe35cc426cbf496a8147002231bf1e74729eb3b5a2dd1fb16c5e7ac1fff5bac61dba62682a9df0de982b35f8ff30640e74e591f3a4c13124890dd79',
+            'debian:10'            => '65b790625e8c9214bd51931cb7016edbf7af718b18eed78bb218386bbc1031c1f7ebdfbbcfc6dd333dca64b12e2c57710c94be45f2ac2954be563cddc2394ea0',
+            'debian:11'            => '5685f91cc970af9170b5699edea679a567c6238f355265de20e9d83a514422d85c13128b29682b915eaf41ba5bd7116bd927eec20bb88d0256f2bbf078e5601d',
+            'debian:aarch64:11'    => 'a19c456d98fae1e25a12b6156ffd6750f2943d5323edac51ea971edc8d9639d47e934a1914bf5c6f72ba7e90c7a6d9ce0bef361b3a532df39163e7096dbe0d10',
+            'debian:12'            => '675d84f18fb77bb3c63cb138091d3132f0cb16c7e09ffd42a101231d285bc0237fba4c7fb1f8b7ed2fed97ef4a0085f812a1191bbcc7c313e643719941d7fd41',
+            'debian:aarch64:12'    => 'cba719df6a0a3c4c19413854c409c11ea5b65d66fc3acc167a3086f7dad0b8a0ff7c9d3d92a590d94bb89b7050b73ed7e7f5683c42aa1efa8d250b4b36ecd12d',
+            'ubuntu:16.04'         => 'f0a19a15c312eaed2279831d8688ed748f8a82f263f63556356c1ced4e80f9c9c19ab9eecfff503427cc1e06c406248407e3edd60e5cbaa3945782cd53414fd7',
+            'ubuntu:18.04'         => '45287e7ecc8b55fb0abf6eecdfb7b75c7a07ca564de2ac85b0b33b5883f6eeabe4c260a13a9b69fb89f3a64350e40a1745a10eab8d68b593ec9a89240a9856bf',
+            'ubuntu:20.04'         => 'db2b7a5cc042f02002ded685ca201bb025a293be9cd619c4d7ecc51c04dd49abcd2b3345c2905df515e94b3e6441a72b68fedb9de445f18f2b48482a838ae910',
+            'ubuntu:aarch64:20.04' => 'df2bd0c9255a56ee5111287ddf6f6ee06b233b10df5fcfebe44f3a8b99767c23dcd7dfb23dc69e28a2bdcbc5e9b6a320acb886e7b36a48333f86fef625fdccec',
+            'ubuntu:22.04'         => '721f0de7d4e8c07ad44313bd33ad586fdcb71d367e8d6eb9a398c945ae258724b182eb00075e62940e400b47ec5409ddbffa720f01b391af353056c20900445a',  
+            'ubuntu:aarch64:22.04' => '091df73ed7194bf4075344c9a65c023680a53ee4fb11cbd6d615309256bb7df3cdea1e34b3ac6a36021646a0288fd8a9dea908079394767a0be0c8588daf3d8c',
+	     'ubuntu:24.04' => '9fbb45a10e524b01bf0d659258491cde5538d3a300c7da06e6267510f56d0cb7d7d1f38f359a371bbd580e7fff6c43f3af4dbd6748d6e91424931f95d73bdf26',
+            'ubuntu:aarch64:24.04'=> 'd894452fdbc81850f4fe242c783bf66b1a8e00ac12df193190714bb32349d3b373645e67988caf59051f08b47e85328af347c35a9b09f12e4cffbc3ddd1ba62a',
         },
         'cppkafka_0_3_1'          => {
             'centos:7'            => '47fc81102062f418a0895f2787bf337da8d7e766b178ed315284cc12913c58b99e395ad044e2e5954299c3c9cde23b3145dc43d4469d360aee66cc850b09b82e',
@@ -614,7 +662,6 @@ sub main {
             'centos:9'            => '1b22492da81139d4f42640b43c43f2e3ca43dc51b6cb2136a80297ba20ecd28f0cfcc035f11526d1b42975558547f978bba01b418c5d9bc0d3f1e910bde5a8ca',
             'centos:aarch64:9'    => '236a613dae16f5ecd48144fe0fb5265ffa9b3d9b53edf944c60a6b0ebfc16f7318d17794a3a39f8ede4b2da4a82ae8e9627ab667967d682d8057076e6526fef2',
 
-            'debian:9'            => '6d9abff6ea377ef058f48663c40a54142c19cc43a69d67766dedfd1ddcb4c02c5b9a7c62b8122dc8692d5bc0655857f53d006f8d32a37004e4967368180c073c',
             'debian:10'           => 'c6316b9171b31eb94b2c31b9532d38f7db372ede62c06372b473149f3e4a2ba386439f4e5caaa7582f0ea015460903d4cd3f750b0f57fa5fc25612a50c10b501',
             
             'debian:11'           => 'ff83197e4d9056e629fe8633cb605ae8d5957b585f450f190ea01644ff850fa4bf69bccef15d15848896a35a49b3c38918261abe1bb6fc28991369666087ba38',
@@ -631,6 +678,8 @@ sub main {
 
             'ubuntu:22.04'        => '9da7b3c41adc768bbfa84d82f6edca9e5c37423c9c04766e992d0473ed5bc08817be01c35dddde33ebcfc9032bfd2ea69657b259161649c23ed64ea22ce95291', 
             'ubuntu:aarch64:22.04'=> 'fda755c2fcfe73cd09c5cdb1666b7d1a33562cf920ef8b87f70e693de8b0c86b8705b9bd9313bcde4122126feda65c5d15e25db43e68f5a23de9b628025035d0',
+	    'ubuntu:24.04' => '38bc724834abfa5fe25030bd913be0263883035404cbb69e7f7874b42c4d5d26b4efcb38a82eddcfe6012ce6c8e07479dc9a8ca8224bd2d7b71c6efdf14732b8',
+            'ubuntu:aarch64:24.04'=> '3403236656f3fb402e79bf8895a8427a42947dc3a1610073f3dcfa0db1f1b8144197fe1fa9b12f0dc5c12cb97a6da2cef2179561ca7a904f917aec6d69a37714',
         },
         'gobgp_3_12_0'          => {
             'centos:7'            => 'ee4e8a976a16b4f0e49753a81e17405b3c219d979313a39e059ec99125e7a5804691c30f2989e60b404d6a9cdc5636d6d9e545e6766c3fd4bede4ff0b830f204',
@@ -641,7 +690,6 @@ sub main {
             'centos:9'            => '25c504c671be26066c1f370eb03bb681209c87bba0c6fce766c8416534007af8e8279b360072711326fa1d248255201adf06c0ccbd1682ab34860d21f72c190f',
             'centos:aarch64:9'    => 'cdd4c9a1a0e25f584a1f33ba159c34d7a8b7d3c285a75a2ad0675aebe94aba888726463eafb37cb4f96751be4a474e4b95603c15c7bef0219586bcc94767263a',
 
-            'debian:9'            => '72305f540d838fb5c7e0b416e5c8a493033da4d9afe21ab979d619a1df69115b9036f824aff8d78145aa9742efe4e5363756b87082de6de13dfb17b856a54762',
             'debian:10'           => '10a38076bebd3a1eb6dd81c5374f209f17808e51ac6476dc256d2a91cd904d5b15a6f9a2161099b2d1e6eaaecc1c3beb54cca1083ac11900001374f4624b38f3',
 
             'debian:11'           => '750102bac73ec2c1fb36f470c86d37a2ae59bd49cf76e1ea48385099d6a3bad0bc49768ee3b41ba2f85de7131e28f757d6093c6be879165e211615d50d69239a',
@@ -658,6 +706,8 @@ sub main {
 
             'ubuntu:22.04'        => 'b3f2168c6b705804155ca944a6c7850057d50652efc57c3c4194838b147176779b98d7b2bf9af72ee141805d62f7a6c1460244ce60b570dbdffc114d5e7dc899',
             'ubuntu:aarch64:22.04'=> '4e9114ed4c9fde74517f04fc8b79b44854ee5fc8b51b99816ad60dccbc61a682993c4321a0df6920a40164281ba24d171f9d4972e54a9f3015d993caf7d03c47',
+	    'ubuntu:24.04' => '9fd084181abef9cdded2b95a1d0ff95cc0077861fcd6dc83ef47d92e0f0f50cda44afd03d7fa55838562418180e9362725757c0d7ad8f9f09b3b4b2e27701514',
+            'ubuntu:aarch64:24.04'=> '44b4b83e3ef2e8d6ceaee6e433edab7acbb3396f35561598db3c78d5dbdae05031158b50364e9d7d8e6e850a36d4f2506456cd62f480706e44063f2751549c17',
         },
         # It's actually 1_1_4rc3 but we use only minor and major numbers
         'log4cpp_1_1_4'         => {
@@ -669,7 +719,6 @@ sub main {
             'centos:9'            => '010c54e0b62aeda78509bb404e372e85e42073b08b2d0ba90f7e7fcd8bb3d6b943acb56e9dcd8113b44bc6b3bbaa83572cbdf81a9dd7e5b555c29fc73ff46ebf',
             'centos:aarch64:9'    => 'f7d2fad8ac0bb8b7890e9c21fe4b178ee7cefd252484546c91f2c8d21eac6673addfd59323c2623abc1a5d0bb641b807f42153c782a84f1bc593547b9509515b',
 
-            'debian:9'            => 'de75b1f0397338c3167ed65d9bd36f346aaa9ebde4b4cc09cee434b7c34a0ded41263533a3ca2c13201a1418ad0cac804aa9aba18ccb800555123b9f8818d042',
             'debian:10'           => '5567b2a040d71e5c1c44687dd9ed32d3987590e0aae3b5653add8b7885b9e1688ecdbecd23d5c54a309388fcaf234df24464550f662a3f76b3a8a235d93219e9',
 
             'debian:11'           => 'efd6883dadd7ffc01464d22fc2380edf8b0356ee897a3a3cb901008ef477f9e7769f63bcf66910b3db680dd2f58cb554228454d7c41c30f8782aabc396625d3c',
@@ -686,9 +735,10 @@ sub main {
 
             'ubuntu:22.04'        => '086e182a2ca2475d46e4a959398d52434d5ad700f2db5a568a5c77b6e91bc51fc34cd36aca7be68810ff0981d304d444bcbb5bc2fa549f8ae3f6d24d8a91157c',
             'ubuntu:aarch64:22.04'=> '82b6229a5346d3859f3263c5a3fae403f7123b2db805e7ef8ca94d3222a5aa8d8ce79a2f6e3345a2849bb949aeb984010154e2119dc20adb5e7052271439492d',
-        },
+             'ubuntu:24.04' => 'fc63e000d80d0484a9bfe02336545adca368a7dcdee8f2087440a9826f34df1bd75de982247a1727bc6f0d78b9f4c24efae0d61e5172e22c4c9a20601990412f',
+            'ubuntu:aarch64:24.04'=> 'be8d01ee93efaf64242853d465a993a5bdba191c832a82fbfc0179b7439ea391965e0a3f464d0462376bbd94a946eceb1928bebd439a363a69b93609ce567882',
+    	},
         'gtest_1_13_0' => {
-            'debian:9'            => '775fbc33cd00f4d56991d860f38af9360169471e1e45ae87f75aae146d2723338cb51e3c9c99716b5f0e03bad3d9eb20b39d84beaaf8753844cc56c3f503b789',
             'debian:10'           => 'f8759bd2a908e533f56b8401464189f75938ed8ccd23b5de36f5dc5ec408d7c790cef1d594bbeb2e52b8fc526f8267fea296b7e6d159dc8f2b5c4aa7618daf5a',
             
             'debian:11'           => 'ff6e7e6c6922a821173e8ce74340488877c39b9fac35d2f0d6137ed80cbfc423669ff12dd55427553011b700b3a48c970543198748d8fd145d8aa11b62b250ce',
@@ -713,8 +763,12 @@ sub main {
 
             'centos:9'            => '398948e08847b7ac09a232414dc462abe9c66d098e71de3350fcb9cca38fdf0204a302d7fc75ada4fad33072371059646c4d2167baed311143240de9a8e62091',
             'centos:aarch64:9'    => 'c441a2450669fb06cc2a237a1098ab1976a49b521069e021fc81de0c34f4de97f954ac3449120f3f80963ce72a7594a449b7cd94ba89b7645397a7a8df469124',
+	    'ubuntu:24.04' => 'ea6129cda9182bf0f4ace130c579af07f2cd74929b4598dedd5febeae0fd0b6e1470eb256168c71fe4efaab6d750e4d52067fda132cef0cb48f1767f123531c2',
+            'ubuntu:aarch64:24.04'=> 'fe86cbd52ea4f2e8bb513dd608194dd4ee7da513a730185e7d1d51d97b5c87b1ac4b413a7330066b44fbcab510e36e6c0cc30a0ed2f085f6801d3512806ce632',
         },
         'pcap_1_10_4' => {
+	    'ubuntu:24.04' => 'a6b09826c7b180a84ab5eb6add7e433fd37772610d7f31634e3637f7c6397232bbf558bbcf8d63aa1cab5357297d996dcdfe2da04179c705649156633c0263b5',
+            'ubuntu:aarch64:24.04'=> 'b65d7aeb1a7f4189d3cf047545270f688c2b9f6bca8a62aababd68121e0e8369efa283bc1290486f188d8f225b1f7c2bf741fd27f2848bae938efbdfac72855d',
             'centos:7'            => '24f30e6d52cf7a76c059734a8feb5e8e8123584cf5bc0be0097a15e3035b984b7c7c74244115b6799dad36a074c69e4aa325113d3d12912ce9719488639e8d36',
 
             'centos:8'            => 'd83e92009cf5f3144b0dccd95e5acd90d7620d3c68f6ce58b5f3b5b71eea7711de986d61b5a9c2544fcae6f4df8259150f031d5c08e9b312b2eed3c6816364f6',
@@ -723,7 +777,6 @@ sub main {
             'centos:9'            => '83e72418b59f5665062674d3ddb1c6dda2a9c022c7bf3a2dae700ff221f7dc000b22c5b775a06c2a1230d57c93decd9e2ce7482a50f9e62f99063adc201727e8',
             'centos:aarch64:9'    => '0342437fe2d0158fcf6e43fa3acba86db3d67c24aac6c6fcf5b18b766a42344c81c516d2f07d8a8619c37a3801216a508ec9db2620f111605650fc7cbe5795d2',
 
-            'debian:9'            => '',
             'debian:10'           => '0af93960a7bf5eecb30cc133b2130d2cdf2f7a455eaa939fdf526051eaf8418a232ac48a0f31f9a6b517ae8c6c091358795afa4237dcfb2d5949cef567713f4a',
 
             'debian:11'           => 'e19cf14f8e9d3035d9a130286aa8b50e6d9254151f22343d56f64041d5b8f184cdddbc63d16f40724e6348e1aa06dfa721ec40bba3255e875ebd8c9d69fa0464',
diff -pruN 1.2.6-1/src/scripts/notify_with_discord.sh 1.2.7-1/src/scripts/notify_with_discord.sh
--- 1.2.6-1/src/scripts/notify_with_discord.sh	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/scripts/notify_with_discord.sh	2024-07-01 20:01:34.000000000 +0000
@@ -31,10 +31,6 @@ if [ "$fastnetmon_action" = "ban" ]; the
     # Read data from stdin
     cat > /dev/null
     color="14425373"
-elif [ "$fastnetmon_action" = "attack_details" ]; then
-    # Read data from stdin
-    cat > /dev/null
-    color="16765184"
 elif [ "$fastnetmon_action" = "unban" ]; then
     color="3857437"
 else
diff -pruN 1.2.6-1/src/scripts/notify_with_slack.sh 1.2.7-1/src/scripts/notify_with_slack.sh
--- 1.2.6-1/src/scripts/notify_with_slack.sh	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/scripts/notify_with_slack.sh	2024-07-01 20:01:34.000000000 +0000
@@ -21,12 +21,12 @@
 # Redhat: yum install bind-utils
 
 #
-# For ban and attack_details actions we will receive attack details to stdin
+# For ban action we will receive attack details to stdin
 # Please do not remove the following command because
 # FastNetMon will crash in this case (it expect read of data from script side).
 #
 
-if [ "$4" = "ban" ] || [ "$4" = "attack_details" ]; then
+if [ "$4" = "ban" ]; then
     fastnetmon_output=$(</dev/stdin)
 fi
 
@@ -51,8 +51,6 @@ slack_action=${4}
 function slackalert () {
     if [ ! -z $slack_url  ] && [ "$slack_action" = "ban" ]; then
         local slack_color="danger"
-    elif [ ! -z $slack_url  ] && [ "$slack_action" = "attack_details" ]; then
-        local slack_color="warning"
     elif [ ! -z $slack_url  ] && [ "$slack_action" = "unban" ]; then
         local slack_color="good"
     else
@@ -79,11 +77,3 @@ if [ "$4" = "ban" ]; then
     # iptables -A INPUT -d $1 -j DROP
     exit 0
 fi
-
-if [ "$4" = "attack_details" ]; then
-    # Email Alert:
-    echo "${fastnetmon_output}" | mail -s "FastNetMon Analysis: IP $1 blocked because of $2 attack with power $3 pps" $email_notify;
-    # Slack Alert:
-    slackalert
-    exit 0
-fi
diff -pruN 1.2.6-1/src/scripts/perllib/Fastnetmon.pm 1.2.7-1/src/scripts/perllib/Fastnetmon.pm
--- 1.2.6-1/src/scripts/perllib/Fastnetmon.pm	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/scripts/perllib/Fastnetmon.pm	2024-07-01 20:01:34.000000000 +0000
@@ -138,6 +138,17 @@ sub get_library_binary_build_from_google
         return 0;
     }
 
+    # print "Start sha-512 calculation\n";
+    # Calculate hash of downloaded file
+    my $sha512 = get_sha_512_sum("/tmp/$dependency_archive_name");
+
+    unless ($sha512) {
+        warn "Cannot calculate SHA512 for file from S3\n";
+        return 2;
+    }
+
+    # print "Calculated sha-512 for $dependency_name $sha512\n";
+
     # Hashes for all distros
     my $data_hashes = shift;
 
@@ -152,20 +163,10 @@ sub get_library_binary_build_from_google
 
     # Hash must exist for all our existing dependencies
     unless ($current_build_hash) {
-        warn "Cannot get $dependency_name hash for Distro $distro_type $distro_version architecture $machine_architecture, please add it to build configuration";
+        warn "Cannot get $dependency_name hash for Distro $distro_type $distro_version architecture $machine_architecture, please add it to build configuration. Retrieved file with hash: $sha512";
         return 2;
     }
 
-    #print "Start sha-512 calculation\n";
-    my $sha512 = get_sha_512_sum("/tmp/$dependency_archive_name");
-
-    unless ($sha512) {
-        warn "Cannot calculate SHA512 for file from S3\n";
-        return 2;
-    }
-
-    # print "Calculated sha-512 for $dependency_name $sha512\n";
-
     if ($sha512 ne $current_build_hash) {
         warn "Hash mismatch. Expected: $current_build_hash got: $sha512. It may be sign of data tampering, please validate data source\n";
         return 2;
@@ -491,7 +492,7 @@ sub install_bpf {
     }
 
     my $elfutils_install_path = "$library_install_folder/elfutils_0_186";
-    my $zlib_path             = "$library_install_folder/zlib_1_2_13";
+    my $zlib_path             = "$library_install_folder/zlib_1_3_1";
 
     my $archive_file_name = 'v1.0.1.tar.gz ';
 
@@ -830,8 +831,8 @@ sub install_cares {
 sub install_zlib {
     my $folder_name = shift;
 
-    my $res = install_configure_based_software("https://zlib.net/zlib-1.2.13.tar.gz",
-        "55eaa84906f31ac20d725aa26cd20839196b6ba6", "$library_install_folder/$folder_name", "");
+    my $res = install_configure_based_software("https://zlib.net/zlib-1.3.1.tar.gz",
+        "f535367b1a11e2f9ac3bec723fb007fbc0d189e5", "$library_install_folder/$folder_name", "");
 
     unless ($res) {
         warn "Cannot install zlib\n";
@@ -866,13 +867,13 @@ sub install_grpc {
 
     my $protobuf_install_path = "$library_install_folder/protobuf_21_12";
 
-    my $abseil_install_path = "$library_install_folder/abseil_2022_06_23";
+    my $abseil_install_path = "$library_install_folder/abseil_2024_01_16";
 
     my $openssl_path = "$library_install_folder/$openssl_folder_name";
 
     my $cares_path = "$library_install_folder/cares_1_18_1";
 
-    my $zlib_path = "$library_install_folder/zlib_1_2_13";
+    my $zlib_path = "$library_install_folder/zlib_1_3_1";
 
     my $re2_path = "$library_install_folder/re2_2022_12_01";
 
@@ -1021,6 +1022,20 @@ sub install_rdkafka {
     return 1;
 }
 
+sub install_clickhouse {
+    my $folder_name = shift;
+
+    my $clickhouse_install_path = "$library_install_folder/$folder_name";
+
+    my $res = install_cmake_based_software("https://github.com/ClickHouse/clickhouse-cpp/archive/refs/tags/v2.3.0.tar.gz", "08a4a2e45ddcb33941c22f5e02177805d7fdd664",
+        $clickhouse_install_path, "$ld_library_path_for_make $cmake_path -DCMAKE_INSTALL_PREFIX:STRING=$clickhouse_install_path -DCMAKE_C_COMPILER=$default_c_compiler_path -DCMAKE_CXX_COMPILER=$default_cpp_compiler_path -DBUILD_SHARED_LIBS:BOOL=ON ..");
+
+    if (!$res) {
+        die "Could not install libclickhouse\n";
+    }
+
+    1;
+}
 
 
 sub install_elfutils {
@@ -1071,10 +1086,10 @@ sub install_abseil {
     # We need explicitly enable PIC to successfully build against gRPC
     # https://github.com/abseil/abseil-cpp/pull/741
     # -DCMAKE_POSITION_INDEPENDENT_CODE=true
-    my $res = install_cmake_based_software("https://github.com/abseil/abseil-cpp/archive/refs/tags/20220623.0.tar.gz",
-        "144c2108e1532c642cdb6ca532ee26e91146cf28",
+    my $res = install_cmake_based_software("https://github.com/abseil/abseil-cpp/archive/refs/tags/20240116.2.tar.gz",
+        "bb8a766f3aef8e294a864104b8ff3fc37b393210",
         "$library_install_folder/$folder_name",
-        "$ld_library_path_for_make $cmake_path -DCMAKE_C_COMPILER=$default_c_compiler_path -DCMAKE_CXX_COMPILER=$default_cpp_compiler_path -DABSL_BUILD_TESTING=ON -DABSL_USE_GOOGLETEST_HEAD=ON -DABSL_ENABLE_INSTALL=ON -DCMAKE_CXX_STANDARD=11 -DCMAKE_POSITION_INDEPENDENT_CODE=true -DCMAKE_INSTALL_PREFIX=$install_path ..");
+        "$ld_library_path_for_make $cmake_path -DCMAKE_C_COMPILER=$default_c_compiler_path -DCMAKE_CXX_COMPILER=$default_cpp_compiler_path -DABSL_BUILD_TESTING=OFF -DABSL_USE_GOOGLETEST_HEAD=ON -DABSL_ENABLE_INSTALL=ON -DCMAKE_CXX_STANDARD=14 -DCMAKE_POSITION_INDEPENDENT_CODE=true -DCMAKE_INSTALL_PREFIX=$install_path ..");
 
     if (!$res) {
         warn "Cannot install abseil\n";
diff -pruN 1.2.6-1/src/sflow_plugin/sflow_collector.cpp 1.2.7-1/src/sflow_plugin/sflow_collector.cpp
--- 1.2.6-1/src/sflow_plugin/sflow_collector.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/sflow_plugin/sflow_collector.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -11,6 +11,7 @@
 #include <ws2ipdef.h> // sockaddr_in6
 #include <ws2tcpip.h> // socklen_t
 #else
+#include <netdb.h>
 #include <arpa/inet.h>
 #include <netinet/in.h>
 #include <sys/socket.h>
@@ -137,7 +138,7 @@ bool process_sflow_counter_sample(uint8_
                                   const sflow_packet_header_unified_accessor& sflow_header_accessor);
 process_packet_pointer sflow_process_func_ptr = NULL;
 
-void start_sflow_collector(std::string interface_for_binding, unsigned int sflow_port);
+void start_sflow_collector(const std::string& sflow_host, unsigned int sflow_port);
 
 // Initialize sflow module, we need it for allocation per module structures
 void init_sflow_module() {
@@ -202,37 +203,48 @@ void start_sflow_collection(process_pack
     sflow_collector_threads.join_all();
 }
 
-void start_sflow_collector(std::string interface_for_binding, unsigned int sflow_port) {
+void start_sflow_collector(const std::string& sflow_host, unsigned int sflow_port) {
 
-    logger << log4cpp::Priority::INFO << plugin_log_prefix << "plugin will listen on " << interface_for_binding << ":"
+    logger << log4cpp::Priority::INFO << plugin_log_prefix << "plugin will listen on " << sflow_host << ":"
            << sflow_port << " udp port";
 
-    unsigned int udp_buffer_size = 65536;
-    char udp_buffer[udp_buffer_size];
+    struct addrinfo hints;
+    memset(&hints, 0, sizeof hints);
 
-    int sockfd = socket(AF_INET, SOCK_DGRAM, 0);
+    hints.ai_family   = AF_UNSPEC;
+    hints.ai_socktype = SOCK_DGRAM;
 
-    struct sockaddr_in servaddr;
-    memset(&servaddr, 0, sizeof(servaddr));
+    // AI_PASSIVE to handle empty sflow_host as bind on all interfaces
+    // AI_NUMERICHOST to allow only numerical host
+    hints.ai_flags = AI_PASSIVE | AI_NUMERICHOST;
 
-    servaddr.sin_family = AF_INET;
+    addrinfo* servinfo = NULL;
 
-    if (interface_for_binding == "0.0.0.0") {
-        servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
-    } else {
-        servaddr.sin_addr.s_addr = inet_addr(interface_for_binding.c_str());
+    int getaddrinfo_result = getaddrinfo(sflow_host.c_str(), std::to_string(sflow_port).c_str(), &hints, &servinfo);
+
+    if (getaddrinfo_result != 0) {
+        logger << log4cpp::Priority::ERROR << "sFlow getaddrinfo function failed with code: " << getaddrinfo_result
+               << " please check sflow_host syntax";
+        return;
     }
 
-    servaddr.sin_port = htons(sflow_port);
+    int sockfd = socket(servinfo->ai_family, servinfo->ai_socktype, servinfo->ai_protocol);
+
+    if (sockfd == -1) {
+        logger << log4cpp::Priority::ERROR << "Cannot create socket with error " << errno << " error message: " << strerror(errno);
+        return;
+    }
 
-    int bind_result = bind(sockfd, (struct sockaddr*)&servaddr, sizeof(servaddr));
+    int bind_result = bind(sockfd, servinfo->ai_addr, servinfo->ai_addrlen);
 
     if (bind_result != 0) {
         logger << log4cpp::Priority::ERROR << plugin_log_prefix << "cannot bind on " << sflow_port << ":"
-               << interface_for_binding << " with errno: " << errno << " error: " << strerror(errno);
+               << sflow_host << " with errno: " << errno << " error: " << strerror(errno);
         return;
     }
 
+    freeaddrinfo(servinfo);
+
     struct sockaddr_in6 peer;
     memset(&peer, 0, sizeof(peer));
 
@@ -261,6 +273,9 @@ void start_sflow_collector(std::string i
     }
 
     while (true) {
+        unsigned int udp_buffer_size = 65536;
+        char udp_buffer[udp_buffer_size];
+
         struct sockaddr_in client_addr;
         socklen_t address_len = sizeof(client_addr);
 
diff -pruN 1.2.6-1/src/simple_packet_parser_ng.cpp 1.2.7-1/src/simple_packet_parser_ng.cpp
--- 1.2.6-1/src/simple_packet_parser_ng.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/simple_packet_parser_ng.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -5,8 +5,8 @@
 #include "fast_library.hpp"
 
 #include <algorithm>
-#include <iterator>
 #include <cstring>
+#include <iterator>
 
 using namespace network_data_stuctures;
 
@@ -14,6 +14,9 @@ using namespace network_data_stuctures;
 // TODO: it's not working code yet
 bool decode_mpls = false;
 
+// We can strip only 3 nested vlans
+const uint32_t maximum_vlans_to_strip = 3;
+
 // Our own native function to convert wire packet into simple_packet_t
 parser_code_t parse_raw_packet_to_simple_packet_full_ng(const uint8_t* pointer,
                                                         int length_before_sampling,
@@ -32,30 +35,44 @@ parser_code_t parse_raw_packet_to_simple
         return parser_code_t::memory_violation;
     }
 
-    ethernet_header_t* ethernet_header = (ethernet_header_t*)local_pointer;
+    const ethernet_header_t* ethernet_header = (const ethernet_header_t*)local_pointer;
 
     // Copy Ethernet MAC addresses to packet structure using native C++ approach to avoid touching memory with memcpy
     std::copy(std::begin(ethernet_header->source_mac), std::end(ethernet_header->source_mac), std::begin(packet.source_mac));
 
-    std::copy(std::begin(ethernet_header->destination_mac), std::end(ethernet_header->destination_mac), std::begin(packet.destination_mac));
+    std::copy(std::begin(ethernet_header->destination_mac), std::end(ethernet_header->destination_mac),
+              std::begin(packet.destination_mac));
 
     local_pointer += sizeof(ethernet_header_t);
 
     // Copy ethertype as we may need to change it below
     uint16_t ethertype = ethernet_header->get_ethertype_host_byte_order();
 
-    if (ethertype == IanaEthertypeVLAN) {
-        // Return error if it shorter then vlan header
+    uint32_t number_of_stripped_vlans = 0;
+
+    // This loop will not start if ethertype is not VLAN
+    while (ethertype == IanaEthertypeVLAN) { 
+        // Return error if it's shorter than vlan header
         if (local_pointer + sizeof(ethernet_vlan_header_t) > end_pointer) {
             return parser_code_t::memory_violation;
         }
 
-        ethernet_vlan_header_t* ethernet_vlan_header = (ethernet_vlan_header_t*)local_pointer;
-
-        packet.vlan = ethernet_vlan_header->get_vlan_id_host_byte_order();
+        const ethernet_vlan_header_t* ethernet_vlan_header = (const ethernet_vlan_header_t*)local_pointer;
 
+        // We've agreed that this field keeps only outermost vlan
+        if (number_of_stripped_vlans == 0) {
+            packet.vlan = ethernet_vlan_header->get_vlan_id_host_byte_order();
+        }
+    
         local_pointer += sizeof(ethernet_vlan_header_t);
 
+        number_of_stripped_vlans++;
+
+        // We need to limit it to avoid possibility of attack which uses too many vlans tags to overload our parser
+        if (number_of_stripped_vlans > maximum_vlans_to_strip) {
+            return parser_code_t::too_many_nested_vlans;
+        }
+
         // Change ethertype to vlan's ethertype
         ethertype = ethernet_vlan_header->get_ethertype_host_byte_order();
     }
@@ -67,7 +84,7 @@ parser_code_t parse_raw_packet_to_simple
                 return parser_code_t::memory_violation;
             }
 
-            mpls_label_t* mpls_label_header = (mpls_label_t*)local_pointer;
+            const mpls_label_t* mpls_label_header = (const mpls_label_t*)local_pointer;
 
             std::cout << "MPLS header: " << mpls_label_header->print() << std::endl;
 
@@ -90,7 +107,7 @@ parser_code_t parse_raw_packet_to_simple
             return parser_code_t::memory_violation;
         }
 
-        ipv4_header_t* ipv4_header = (ipv4_header_t*)local_pointer;
+        const ipv4_header_t* ipv4_header = (const ipv4_header_t*)local_pointer;
 
         // Use network representation of addresses
         packet.src_ip = ipv4_header->get_source_ip_network_byte_order();
@@ -114,8 +131,8 @@ parser_code_t parse_raw_packet_to_simple
         packet.ip_fragment_offset = ipv4_header->get_fragment_offset_bytes();
 
         // We keep these variables to maintain backward compatibility with parse_raw_packet_to_simple_packet_full()
-        packet.captured_payload_length      = length_before_sampling;
-        packet.payload_full_length = length_before_sampling;
+        packet.captured_payload_length = length_before_sampling;
+        packet.payload_full_length     = length_before_sampling;
 
         // Pointer to payload
         packet.payload_pointer = (void*)pointer;
@@ -145,7 +162,7 @@ parser_code_t parse_raw_packet_to_simple
             return parser_code_t::memory_violation;
         }
 
-        ipv6_header_t* ipv6_header = (ipv6_header_t*)local_pointer;
+        const ipv6_header_t* ipv6_header = (const ipv6_header_t*)local_pointer;
 
         // TODO: we may use std::copy for it to avoid touching memory with memcpy
         memcpy(&packet.src_ipv6, ipv6_header->source_address, sizeof(packet.src_ipv6));
@@ -159,8 +176,8 @@ parser_code_t parse_raw_packet_to_simple
         packet.ip_length = ipv6_header->get_payload_length();
 
         // We keep these variables to maintain backward compatibility with parse_raw_packet_to_simple_packet_full()
-        packet.captured_payload_length      = length_before_sampling;
-        packet.payload_full_length = length_before_sampling;
+        packet.captured_payload_length = length_before_sampling;
+        packet.payload_full_length     = length_before_sampling;
 
         // Pointer to payload
         packet.payload_pointer = (void*)pointer;
@@ -196,7 +213,7 @@ parser_code_t parse_raw_packet_to_simple
 
             // We decided to parse only fragmentation header option as only this field may be found in the Wild
             if (protocol == IpProtocolNumberIPV6_FRAG) {
-                ipv6_extension_header_fragment_t* ipv6_extension_header_fragment = (ipv6_extension_header_fragment_t*)local_pointer;
+                const ipv6_extension_header_fragment_t* ipv6_extension_header_fragment = (const ipv6_extension_header_fragment_t*)local_pointer;
 
                 // If we received this header then we assume that packet was fragmented
                 packet.ip_fragmented = true;
@@ -224,18 +241,18 @@ parser_code_t parse_raw_packet_to_simple
     if (protocol == IpProtocolNumberTCP) {
         if (local_pointer + sizeof(tcp_header_t) > end_pointer) {
             // We observed that Huawei routers may send only first 52 bytes of header in sFlow mode
-            // and it's not enough to accommodate whole TCP header which has length of 20 bytes and we can observe only first 14 bytes 
-            // and it happened in case of vlan presence
+            // and it's not enough to accommodate whole TCP header which has length of 20 bytes and we can observe only
+            // first 14 bytes and it happened in case of vlan presence
 
             // To offer better experience we will try retrieving only ports from TCP header as they're located in the beginning of packet
             if (local_pointer + sizeof(cropped_tcp_header_only_ports_t) > end_pointer) {
-                // Sadly we cannot even retrieve port numbers and we have to discard this packet 
+                // Sadly we cannot even retrieve port numbers and we have to discard this packet
                 // Idea of reporting this packet as TCP protocol without ports information is not reasonable
                 return parser_code_t::memory_violation;
             }
 
             // Use short TCP header which has only access to source and destination ports
-            cropped_tcp_header_only_ports_t* tcp_header = (cropped_tcp_header_only_ports_t*)local_pointer;
+            const cropped_tcp_header_only_ports_t* tcp_header = (const cropped_tcp_header_only_ports_t*)local_pointer;
 
             packet.source_port      = tcp_header->get_source_port_host_byte_order();
             packet.destination_port = tcp_header->get_destination_port_host_byte_order();
@@ -243,7 +260,7 @@ parser_code_t parse_raw_packet_to_simple
             return parser_code_t::success;
         }
 
-        tcp_header_t* tcp_header = (tcp_header_t*)local_pointer;
+        const tcp_header_t* tcp_header = (const tcp_header_t*)local_pointer;
 
         packet.source_port      = tcp_header->get_source_port_host_byte_order();
         packet.destination_port = tcp_header->get_destination_port_host_byte_order();
@@ -257,7 +274,7 @@ parser_code_t parse_raw_packet_to_simple
             return parser_code_t::memory_violation;
         }
 
-        udp_header_t* udp_header = (udp_header_t*)local_pointer;
+        const udp_header_t* udp_header = (const udp_header_t*)local_pointer;
 
         packet.source_port      = udp_header->get_source_port_host_byte_order();
         packet.destination_port = udp_header->get_destination_port_host_byte_order();
@@ -271,7 +288,7 @@ parser_code_t parse_raw_packet_to_simple
             return parser_code_t::memory_violation;
         }
 
-        gre_header_t* gre_header = (gre_header_t*)local_pointer;
+        const gre_header_t* gre_header = (const gre_header_t*)local_pointer;
 
         // Current version of parser does not handle these special codes and we just fail parsing process
         // These flags may extend length of GRE header and current logic is not ready to decode any of them
@@ -361,8 +378,8 @@ parser_code_t parse_raw_ipv4_packet_to_s
     packet.ip_fragmented = ipv4_header->is_fragmented();
 
     // We keep these variables to maintain backward compatibility with parse_raw_packet_to_simple_packet_full()
-    packet.captured_payload_length      = length_before_sampling;
-    packet.payload_full_length = length_before_sampling;
+    packet.captured_payload_length = length_before_sampling;
+    packet.payload_full_length     = length_before_sampling;
 
     // Pointer to payload
     packet.payload_pointer = (void*)pointer;
@@ -409,4 +426,3 @@ parser_code_t parse_raw_ipv4_packet_to_s
 
     return parser_code_t::success;
 }
-
diff -pruN 1.2.6-1/src/tests/spsc_prototype.cpp 1.2.7-1/src/tests/spsc_prototype.cpp
--- 1.2.6-1/src/tests/spsc_prototype.cpp	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/tests/spsc_prototype.cpp	2024-07-01 20:01:34.000000000 +0000
@@ -74,7 +74,7 @@ void init_logging() {
 
     logger.setPriority(log4cpp::Priority::INFO);
     logger.addAppender(appender);
-    logger.info("Logger initialized!");
+    logger.info("Logger initialized");
 }
 
 uint64_t received_packets = 0;
diff -pruN 1.2.6-1/src/xdp_plugin/xdp_kernel.c 1.2.7-1/src/xdp_plugin/xdp_kernel.c
--- 1.2.6-1/src/xdp_plugin/xdp_kernel.c	2023-10-14 15:48:26.000000000 +0000
+++ 1.2.7-1/src/xdp_plugin/xdp_kernel.c	2024-07-01 20:01:34.000000000 +0000
@@ -1,6 +1,8 @@
 // SPDX-License-Identifier: GPL-2.0
 #define KBUILD_MODNAME "foo"
-#include "bpf/bpf_helpers.h"
+
+#include <linux/types.h>
+#include <bpf/bpf_helpers.h>
 #include <linux/bpf.h>
 
 //
